// Actions.h : Declaration of the CActions

#ifndef __ACTIONS_H_
#define __ACTIONS_H_

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// CActions
class ATL_NO_VTABLE CActions : 
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<CActions, &CLSID_Actions>,
	// public IDispatchImpl<IActions, &IID_IActions, &LIBID_GNLPPSEVNTCSMRLib>
	public IDispatchImpl<IActions, &IID_IActions, &LIBID_GnlPpsEvntCsmr>
{
public:
	CActions() {
		// initialize instance member variables
	}

	~CActions() {
		// uninitialize instance member variables
	}

DECLARE_REGISTRY_RESOURCEID(IDR_ACTIONS)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CActions)
	COM_INTERFACE_ENTRY(IActions)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

// IActions
public:
	STDMETHOD(XmlHttpSqlUpdate)(/*[in]*/ BSTR bsRdmsHost, /*[in]*/ BSTR bsRdmsDb, /*[in]*/ BSTR bsRdmsTbl, /*[in]*/ VARIANT vEventRecord, /*[in]*/ INT cfEventRecord, /*[in]*/ BOOL bHttpPost);
	STDMETHOD(XmlHttpSqlInsert)(/*[in]*/ BSTR bsRdmsHost, /*[in]*/ BSTR bsRdmsDb, /*[in]*/ BSTR bsRdmsTbl, /*[in]*/ VARIANT vEventRecord, /*[in]*/ INT cfEventRecord, /*[in]*/ BOOL bHttpPost);
	STDMETHOD(CreatePrc)(/*[in]*/ BSTR bsCmdLine, /*[in]*/ INT iShowWindow);
};

#endif //__ACTIONS_H_
