Attribute VB_Name = "Module1"
Option Explicit   ' forces all variables used to be declared before use
Const UDEBUG = 1  ' 0 = no debug stops | 1 = stop ad harcoded debug breaks

Private Sub Main()
    On Error GoTo catch
try:
    If (UDEBUG) Then
        Stop
    End If
    'Dim oGpec As GnlPpsEvntCsmr.Actions
    Dim oGpec As Object
    Set oGpec = CreateObject("GnlPpsEvntCsmr.Actions")
    Dim sProcess As String, wShowWindow As Long
    Call oGpec.CreatePrc("notepad.exe", 1)
    'Call oGpec.XmlHttpSqlInsert("foo", "bar", "foo", "bar", 10, True)
    Set oGpec = Nothing
    
    If (UDEBUG) Then
        Stop
    End If
    Call DelWmiNspc
    Call SqlXmlVdir
    Call MsiTests
    Call XslTest
    Call SqlXmlTest
    
    GoTo finally
catch:
    Dim lTemp As Long, sTemp As String
    lTemp = Err.Number
    sTemp = Err.Source
    sTemp = sTemp & " " & Err.Description
    If (UDEBUG) Then
        Stop
    End If
finally:
    ' TODO: any "guaranteed to execute" cleanup calls go here
    Set oGpec = Nothing
End Sub

Private Sub WebVdir()
    On Error GoTo catch  '// declare all purpose error handler
    
    If (MIN_DEBUG <= DEBUG_LVL) Then
        Stop  '// break for debugging
    End If
'C:\Inetpub\AdminScripts>mkwebdir -c localhost -w "Default Web Site" -v "reports"
',"c:\program files\msftnsg\appusetrksvc"

catch:
    If (0 <> Err.Number) And (MIN_DEBUG <= DEBUG_LVL) Then
        Stop  '// break for debugging
        Dim lTemp As Long, sTemp As String
        lTemp = Err.Number
        sTemp = Err.Source
        sTemp = Err.Description
    End If
End Sub

Private Sub SqlXmlVdir()
    On Error GoTo catch  '// declare all purpose error handler
    
    If (MIN_DEBUG <= DEBUG_LVL) Then
        Stop  '// break for debugging
    End If
    
    'add project/references/Microsoft Sql Virtual Directory Control 1.0 Type Library (<sql2k>\80\tools\binn\sqlvdir.dll)
    Dim oSqlVdirCtrl As SQLVDirControl, oSqlVdirs As IVRootEnum, oSqlVdir As ISQLVDir, _
        iAllowFlags As Integer, oSqlVdirNames As IVirtualNames, oSqlVdirName As IVirtualName
    Set oSqlVdirCtrl = CreateObject("SQLVDir.SQLVDirControl")
    Call oSqlVdirCtrl.Connect("localhost", "1")
    Set oSqlVdirs = oSqlVdirCtrl.SQLVDirs
    Set oSqlVdir = oSqlVdirs.AddVirtualDirectory("dbGnlPpsEvntCsmr")
    ' if vdir already exists
    ' -2147024713 == 0x800700B7, Automation error Cannot create a file when that file already exists.
    oSqlVdir.PhysicalPath = "C:\Program Files\MsftNsg\AppUseTrkSvc"
    oSqlVdir.UserName = "sa"
    oSqlVdir.Password = "sa"
    oSqlVdir.SecurityMode = smSQL  ' == 1
    oSqlVdir.ServerName = "(local)"
    oSqlVdir.DatabaseName = "dbGnlPpsEvntCsmr"
    iAllowFlags = afURL_QUERIES Or afTEMPLATES Or afXPATH Or afPOST  'Or afDONTCACHESCHEMAS
    ' 201 == 1 Or 8 Or 64 Or 128  'Or 256
    oSqlVdir.AllowFlags = afURL_QUERIES Or afTEMPLATES Or afXPATH Or afPOST 'Or afDONTCACHESCHEMAS
    Set oSqlVdirNames = oSqlVdir.VirtualNames
    Set oSqlVdirName = oSqlVdirNames.AddVirtualName("schema", 2, "C:\Program Files\MsftNsg\AppUseTrkSvc")
    Set oSqlVdirName = Nothing
    Set oSqlVdirName = oSqlVdirNames.AddVirtualName("template", 4, "C:\Program Files\MsftNsg\AppUseTrkSvc")
    Set oSqlVdirName = Nothing
    Call oSqlVdirCtrl.Disconnect
    
    If (MIN_DEBUG <= DEBUG_LVL) Then
        Stop  '// break for debugging
    End If
    
    Call oSqlVdirCtrl.Connect("localhost", "1")
    Set oSqlVdirs = oSqlVdirCtrl.SQLVDirs
    Call oSqlVdirs.RemoveVirtualDirectory("dbGnlPpsEvntCsmr")
    ' if vdir doesn't exist
    ' -2147196928 == 80046000, Automation Error
    Call oSqlVdirCtrl.Disconnect
        
catch:
    If (0 <> Err.Number) And (MIN_DEBUG <= DEBUG_LVL) Then
        Stop  '// break for debugging
        Dim lTemp As Long, sTemp As String
        lTemp = Err.Number
        sTemp = Err.Source
        sTemp = Err.Description
    End If
End Sub


Private Sub MsiTests()
    On Error GoTo catch  '// declare all purpose error handler
    
    If (MIN_DEBUG <= DEBUG_LVL) Then
        Stop  '// break for debugging
    End If
    
    'add project/references/Microsoft Windows Installer Object Library (%systemroot%\system32\msi.dll)
    Dim Installer As Installer, Database As Database, Session As Session, vTemp As Variant
    Set Installer = CreateObject("WindowsInstaller.Installer")
    'this will run a product install
    'Installer.InstallProduct ("tests.msi")
    
    'this doesn't work unless you dynamically populate the bare minimum stuff in the db
    'Set Database = Installer.OpenDatabase("debug.msi", msiOpenDatabaseModeCreateDirect)
    'Call Database.Commit
    'Set Session = Installer.OpenPackage("d:\vssWorkFld\ops\monitoring\gnlPpsEvntCsmr\tests\debug.msi")
    
    'this works, tests.msi is a ipwie20 project wizard all defaults and no more generated msi
    'full path is necessary
    'Set Session = Installer.OpenPackage("d:\vssWorkFld\ops\monitoring\gnlPpsEvntCsmr\tests\tests.msi")
    'or the actual msi you are trying to author and debug CustomAction scripts for
    Set Session = Installer.OpenPackage("d:\vssWorkFld\ops\monitoring\gnlPpsEvntCsmr\Product Configuration 1\Release 1\DiskImages\DISK1\AppUseTrkSvc.msi")

    vTemp = Installer.Environment("computername")  'dynamic session environment variable, use environment table to persist
    vTemp = Session.Property("InstallChoice")  'static property table
    vTemp = Session.Property("INSTALLLEVEL")  'static property table
    vTemp = Session.Property("_DEBUG")  'static property table
    vTemp = Session.Property("INSTALLDIR")  'dynamic property table, not yet initialized ???
    vTemp = Session.Property("ProgramFilesFolder")  'path variable table
    vTemp = Session.Property("$GnlPpsEvntCsmr")  'dynamic property table, not yet initialized ???
    
    Session.Property("INSTALLDIR") = "c:\program files\msftnsg\appusetrksvc"
    Session.Property("_DEBUG") = "defined"
    
    vTemp = Session.Property("INSTALLDIR")
    vTemp = Session.Property("_DEBUG")
    GoTo Cleanup
    
catch:
    If (0 <> Err.Number) And (MIN_DEBUG <= DEBUG_LVL) Then
        Stop  '// break for debugging
        Dim lTemp As Long, sTemp As String
        lTemp = Err.Number
        sTemp = Err.Source
        sTemp = Err.Description
    End If
    
Cleanup:
    If Not (Installer Is Nothing) Then
        Set Installer = Nothing
    End If
End Sub


Private Sub DelWmiNspc()
    On Error GoTo catch  '// declare all purpose error handler
    
    If (MIN_DEBUG <= DEBUG_LVL) Then
        Stop  '// break for debugging
    End If
    
    'add project/references/Microsoft WMI V1.1 Scripting Library (%systemroot%\system32\wbem\wbemdisp.tlb [/.dll])
    Dim oSWbemLocator As ISWbemLocator, oSWbemServices As ISWbemServices
    'Set oSWbemServices = GetObject("winmgmts:{(Security)}")
    'Set oSWbemServices = GetObject("winmgmts:{impersonationLevel=impersonate}!root\cimv2:__Namespace")
    ' Set oSWbemServices = GetObject("winmgmts:{impersonationLevel=impersonate}!root\cimv2")
    
    Set oSWbemLocator = CreateObject("WbemScripting.SWbemLocator")
    Dim iTemp As Integer
    iTemp = oSWbemLocator.Security_.ImpersonationLevel '3
    oSWbemLocator.Security_.ImpersonationLevel = wbemImpersonationLevelImpersonate  '3
    ' oSWbemLocator.Security_.ImpersonationLevel = wbemImpersonationLevelDelegate  '4
    iTemp = oSWbemLocator.Security_.ImpersonationLevel
    
    ' iTemp = oSWbemLocator.Security_.AuthenticationLevel  ' -2147217407, SWbemSecurity, "Generic failure "
    ' oSWbemLocator.Security_.AuthenticationLevel = wbemAuthenticationLevelDefault  '0
    ' oSWbemLocator.Security_.AuthenticationLevel = wbemAuthenticationLevelNone  '1
    ' iTemp = oSWbemLocator.Security_.AuthenticationLevel 'Generic Failure
    
    Dim oSWbemPrivilege As SWbemPrivilege, oSWbemPrivilegeSet As SWbemPrivilegeSet
    
    ' Set oSWbemPrivilege = oSWbemLocator.Security_.Privileges.Item(wbemPrivilegeDebug)  ' -2147217406, SWbemPrivilegeSet "Not found "
    Dim oSWbemPrivilegeSet As SWbemPrivilegeSet
    Set oSWbemPrivilegeSet = CreateObject("WbemScripting.SWbemPrivilegeSet")
    Call oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeDebug, True)
    /*  wbemPrivilegeDebug = 19, wbemPrivilegeIncreaseBasePriority = 13, wbemPrivilegeIncreaseQuota = 4,
    wbemPrivilegePrimaryToken = 2, wbemPrivilegeTakeOwnership = 8, wbemPrivilegeTcb = 6,
    wbemPrivilegeProfileSingleProcess = 12, wbemPrivilegeCreateToken = 1, wbemPrivilegeEnableDelegation = 26 */
    oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeDebug, true);
    oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeIncreaseBasePriority, true);;
    oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeIncreaseQuota, true);
    oSWbemLocator.Security_.Privileges.Add(wbemPrivilegePrimaryToken, true);
    oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeTakeOwnership, true);
    oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeTcb, true);
    oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeProfileSingleProcess, true);
    oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeCreateToken, true);
    oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeEnableDelegation, true);
    
    var iTemp = oSWbemLocator.Security_.ImpersonationLevel;  // should now be = 3
    // iTemp = oSWbemLocator.Security_.AuthenticationLevel;  // should now be = 0
    var oSWbemPrivilege = oSWbemLocator.Security_.Privileges.Item(wbemPrivilegeDebug);  // should now exist and = true
    
    Set oSWbemPrivilege = oSWbemLocator.Security_.Privileges.Item(wbemPrivilegeDebug)
    
    
    Set oSWbemServices = oSWbemLocator.ConnectServer(, "root\cimv2")
    
    Set oSWbemPrivilege = oSWbemServices.Security_.Privileges.Item(wbemPrivilegeDebug)
    Call oSWbemServices.Security_.Privileges.Add(wbemPrivilegeDebug, True)
    ' Call oSWbemServices.Security_.Privileges.AddAsString("SeDebugPrivilege", True)
    Set oSWbemPrivilege = oSWbemLocator.Security_.Privileges.Item(wbemPrivilegeDebug)
    
    Call oSWbemServices.Delete("__NAMESPACE.Name=""msftNsg""")  '-2147217406, SWbemService, "Not found "
    
    
catch:
    If (0 <> Err.Number) And (MIN_DEBUG <= DEBUG_LVL) Then
        Stop  '// break for debugging
        Dim lTemp As Long, sTemp As String
        lTemp = Err.Number
        sTemp = Err.Source
        sTemp = Err.Description
    End If
End Sub


Private Sub XslTest()
    On Error GoTo catch  '// declare all purpose error handler
    
    If (MAX_DEBUG <= DEBUG_LVL) Then
        Stop  '// break for debugging
    End If

    'add project/references/Microsoft XML, [version 2.0 | v2.6 | v3.0]
    '  version 2.0 = %systemroot%\system32\msxml.dll
    '  v2.6 = %systemroot%\system32\msxml2.dll
    '  v3.0 = %systemroot%\system32\msxml3.dll
    Dim oDomDoc As DOMDocument
    Set oDomDoc = CreateObject("Msxml2.DOMDocument")
    'Set oDomDoc = CreateObject("Msxml2.FreeThreadedDOMDocument")
    oDomDoc.async = False
    'oDomDoc.validateOnParse = False
    Dim br As Boolean
    br = oDomDoc.Load("D:\vssWorkFld\ops\monitoring\gnlPpsEvntCsmr\tests\tmplMinDurWQuts.xml")
    'note - full path is required for load to succeed
    
    Dim iDuration As Integer, oRootNode As IXMLDOMNode
    Set oRootNode = oDomDoc.lastChild
    iDuration = GetTotalDuration(oRootNode)
    
    Dim iMins As Integer, iSecs As Integer
    iMins = iDuration / 60
    iSecs = iDuration Mod 60
    
    If (MAX_DEBUG <= DEBUG_LVL) Then
        Stop  '// break for debugging
    End If

catch:
    If (0 <> Err.Number) And (MIN_DEBUG <= DEBUG_LVL) Then
        Stop  '// break for debugging
        Dim lTemp As Long, sTemp As String
        lTemp = Err.Number
        sTemp = Err.Source
        sTemp = Err.Description
    End If
    If Not (oRootNode Is Nothing) Then
        Set oRootNode = Nothing
    End If
    If Not (oDomDoc Is Nothing) Then
        Set oDomDoc = Nothing
    End If
End Sub


Private Function GetTotalDuration(oRootNode As IXMLDOMNode) As Integer
    On Error GoTo catch  '// declare all purpose error handler
    
    If (MAX_DEBUG <= DEBUG_LVL) Then
        Stop  '// break for debugging
    End If
    
    Dim oAppUseNodeList As IXMLDOMNodeList
    Set oAppUseNodeList = oRootNode.selectNodes("AppUse")
    ' Set oAppUseNodeList = oRootNode.getElementsByTagName("AppUse")
   
    Dim iIndex As Integer, iSum As Integer, oAppUseNode As IXMLDOMNode, _
        oAppUseNamedNodeMap As IXMLDOMNamedNodeMap, oAppUseDurationNode As IXMLDOMNode, _
        sDuration As String, vDuration As Variant, iDuration As Integer
    
    For iIndex = 0 To (oAppUseNodeList.length - 1)
        Set oAppUseNode = oAppUseNodeList.Item(iIndex)
        'sDuration = oAppUseNode.nodeValue
        'sDuration = oAppUseNode.Text
        'note - .nodeValue throws and error if element nodeValue is empty, .text does not
        Set oAppUseNamedNodeMap = oAppUseNode.Attributes
        Set oAppUseDurationNode = oAppUseNamedNodeMap.getNamedItem("Duration")
        If Not (oAppUseDurationNode Is Nothing) Then
            vDuration = oAppUseDurationNode.nodeValue  'note - returns variant/string for duration
            sDuration = oAppUseDurationNode.nodeValue  'note - returns string for duration
            If ("" <> sDuration) Then
                iDuration = iDuration + CInt(sDuration)
            End If
        End If
    Next
    
catch:
    If (0 <> Err.Number) And (MIN_DEBUG <= DEBUG_LVL) Then
        Stop  '// break for debugging
        Dim lTemp As Long, sTemp As String
        lTemp = Err.Number
        If (91 = lTemp) Then  'Duration attribute was not found
            sDuration = ""
            Resume Next
        End If
        sTemp = Err.Source
        sTemp = Err.Description
    End If
    If Not (oAppUseNode Is Nothing) Then
        Set oAppUseNode = Nothing
    End If
    If Not (oAppUseNodeList Is Nothing) Then
        Set oAppUseNodeList = Nothing
    End If
    
    GetTotalDuration = iDuration
End Function


Private Sub SqlXmlTest()
    On Error GoTo catch  '// declare all purpose error handler
    
    If (MAX_DEBUG <= DEBUG_LVL) Then
        Stop  '// break for debugging
    End If
    
    Dim oDomDoc As DOMDocument
    Set oDomDoc = CreateObject("Msxml2.DOMDocument")
    'Set oDomDoc = CreateObject("Msxml2.FreeThreadedDOMDocument")
    oDomDoc.async = False
    ' oDomDoc.validateOnParse = False
    Dim br As Boolean
    br = oDomDoc.Load("D:\vssWorkFld\ops\monitoring\gnlPpsEvntCsmr\tests\dbGnlPpsEvntCsmr.xml")
    'note - full path is required for load to succeed
    
    Dim oXmlDomNode As IXMLDOMNode
    Dim oXmlDomNodeList As IXMLDOMNodeList
    
    Dim oNode0 As IXMLDOMNode, oAttribute0 As IXMLDOMAttribute
    oNode0 = oDomDoc.selectSingleNode("tblEvents")
       
    oNode0 = oDomDoc.createNode(1, "foo", "nspc")
    oNode0.Text = "foobar text"
    oAttribute0 = oNode0.Attributes(0)
    
    Dim oXMLHttpRequest As XMLHTTPRequest
    '// Dim oXMLHttpRequest As XMLHTTP30
    Set oXMLHttpRequest = CreateObject("MsXml2.XMLHTTP")
    '// Set oXMLHttpRequest = CreateObject("MsXml2.XMLHTTP.3.0")
    
    Dim bsUrl As String
    '// xml/http test svc event insert strings
    '// bad - bsUrl = "http://myRdms/dbXmlEvntLogr?template=<root+xmlns:sql='urn:schemas-microsoft-com:xml-sql'><sql:sync><sql:after><tblEvntLog+szHostName='MYDEVC'+szIpAddr='4.33.181.203'+szAgent='wmi'+szLgcCsmrName='lgcXelSvcEvents'+szLgcCsmrDescription='svcEvents'+sdtDateTime='2000-6-07 06:30:0'+szEvntPropertyA='OWSTimer'+szEvntPropertyB='Office Server Extensions Notification Service'+szEvntPropertyC='-1'+szEvntPropertyD='Running'+szEvntPropertyE='Manual'/></sql:after></sql:sync></root>"
    '// bsUrl = "http://myRdms/dbXmlEvntLogr?template=<root+xmlns:sql='urn:schemas-microsoft-com:xml-sql'><sql:sync><sql:after><tblEvntLog+szHostName='MYDEVC'+szIpAddr='4.33.181.203'+szAgent='wmi'+szLgcCsmrName='lgcXelSvcEvents'+szLgcCsmrDescription='svcEvents'+sdtDateTime='2000-06-07 06:30:00'+szEvntPropertyA='OWSTimer'+szEvntPropertyB='Office Server Extensions Notification Service'+szEvntPropertyC='-1'+szEvntPropertyD='Running'+szEvntPropertyE='Manual'/></sql:after></sql:sync></root>"
    
    '// xml/http test log event insert strings
    '// bad - bsUrl = "http://myRdms/dbXmlEvntLogr?template=<root+xmlns:sql='urn:schemas-microsoft-com:xml-sql'><sql:sync><sql:after><tblEvntLog+szHostName='MYDEVC'+szIpAddr='4.33.181.83'+szAgent='wmi'+szLgcCsmrName='lgcXelLogEvents'+szLgcCsmrDescription='logEvents'+sdtDateTime='20000607143000.000000-420'+szEvntPropertyA='Application'+szEvntPropertyB='TlntSvr'+szEvntPropertyC='information'+szEvntPropertyD='0'+szEvntPropertyE='1001'+szEvntPropertyF='The MS Telnet Service has shut down successfully.'/></sql:after></sql:sync></root>"
    bsUrl = "http://myRdms/dbXmlEvntLogr?template=<root+xmlns:sql='urn:schemas-microsoft-com:xml-sql'><sql:sync><sql:after><tblEvntLog+szHostName='MYDEVC'+szIpAddr='4.33.181.83'+szAgent='wmi'+szLgcCsmrName='lgcXelLogEvents'+szLgcCsmrDescription='logEvents'+sdtDateTime='2000-06-07 06:30:00'+szEvntPropertyA='Application'+szEvntPropertyB='TlntSvr'+szEvntPropertyC='information'+szEvntPropertyD='0'+szEvntPropertyE='1001'+szEvntPropertyF='The MS Telnet Service has shut down successfully.'/></sql:after></sql:sync></root>"
    
    '// Call oXMLHttpRequest.open("GET", bsUrl)
    Call oXMLHttpRequest.open("GET", bsUrl, True, "", "")
    '// Call oXMLHttpRequest.open("GET", bsUrl, False, "", "")
    '// Call oXMLHttpRequest.open("GET", bsUrl, False, "Administrator", "AdminPwd")
    Call oXMLHttpRequest.setRequestHeader("Content-Type", "text/xml")
    '// Call oXMLHttpRequest.setRequestHeader("Content-Type", "text/html")
    If (MIN_DEBUG <= DEBUG_LVL) Then
        Stop  '// break for debugging
    End If
    '// Call oXMLHttpRequest.send
    Call oXMLHttpRequest.send("")
          
    If (MIN_DEBUG <= DEBUG_LVL) Then
        Stop  '// break for debugging
    End If
    
    Dim lStatus As Long
    lStatus = oXMLHttpRequest.Status
    If (200 <> lStatus) Then
        Stop  '// break for debugging
    End If
    
    Dim bsStatusText As String
    bsStatusText = oXMLHttpRequest.statusText
    If ("OK" <> bsStatusText) Then
        Stop  '// break for debugging
    End If
    
    Dim bsBuffer As String
    bsBuffer = oXMLHttpRequest.responseText
    
    Dim oXMLDOMDocument As DOMDocument, bsDomDocXml As String
    Set oXMLDOMDocument = oXMLHttpRequest.responseXML
    '// bsBuffer = oXMLDOMDocument.xml - this is not available in c++
    '// <root xmlns:sql="urn:schemas-microsoft-com:xml-sql"><?MSSQLError HResult="0x80004005" Source="Microsoft SQL Server ISAPI  XML extension (ODBC) v1.0.1.2" Description="SQLState: 22007, Msg: [Microsoft][ODBC SQL Server Driver][SQL Server]Syntax error converting character string to smalldatetime data type."?></root>
    '// ??? HResult, Source, Description
    Dim lBuffer As Long
    lBuffer = oXMLDOMDocument.hasChildNodes  '// -1 or True if an error exists and if it does not
    '// lBuffer = oXMLDOMDocument.Attributes(0)
    Dim oDOMNodeList As IXMLDOMNodeList
    Set oDOMNodeList = oXMLDOMDocument.getElementsByTagName("root")
    Dim oFirstChild As IXMLDOMNode, oAttribute As IXMLDOMNode
    Set oFirstChild = oXMLDOMDocument.firstChild
    bsBuffer = oFirstChild.Text  '// success = "", failure = "HResult...."
    '// therefore use FirstChild.Text string as true indicator of failure or success
    If ("" <> bsBuffer) Then
        Call Err.Raise(vbObjectError + 512, "prjXmlEvntLogr.modMain.Main", bsBuffer)
    End If
    bsBuffer = oFirstChild.xml   '// success = "<root ...", success = "<root ..."
    Set oAttribute = oFirstChild.Attributes(0) '// sql
    bsBuffer = oAttribute.Text '// urn:schemas-...
    bsBuffer = oAttribute.xml  '// xmlns:sql="urn:schea
    Set oAttribute = Nothing
    Set oAttribute = oFirstChild.Attributes(1)  '// nothing
    If Not (oAttribute Is Nothing) Then
        bsBuffer = oAttribute.Text
        bsBuffer = oAttribute.xml
    End If

catch:
    If (0 <> Err.Number) And (MIN_DEBUG <= DEBUG_LVL) Then
        Stop  '// break for debugging
        Dim lTemp As Long, sTemp As String
        lTemp = Err.Number
        sTemp = Err.Source
        sTemp = Err.Description
    End If
    If Not (oDomDoc Is Nothing) Then
        Set oDomDoc = Nothing
    End If
    If Not (oXMLHttpRequest Is Nothing) Then
        Set oXMLHttpRequest = Nothing
    End If
End Sub

