<?xml version="1.0"?>

<!-- if using default setup ie5 / msxml.dll or msxml2.dll w/o xslt 1.0 support -->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/TR/WD-xsl">

<!-- if using sep2k msft xml parser release, msxml3.dll w/ xslt 1.0 support -->
<!-- xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0" -->

<!-- note - sql2k october 2000 web release does not support the full suite of xpath and xsl version 1.0 functionality
     see start / programs / microsoftSqlServer / booksOnly / contents / xmlAndInternetSupport / usingXpathQueries
     and guidelinesForUsingXpathQueries and http://msdn.microsoft.com/xml/default.asp for details on what is and 
     is not currently supported, some of the elements/statements shown below have been commented out due to these
     version compatibility issues -->

<!-- optional setting if using xslt 1.0 support -->
<!-- xsl:output method="html"/ -->

<xsl:template match="/">
<html>
<head>
<title>Application Usage Tracking Service</title>
<!-- link rel="stylesheet" type="text/css" href="default.css"></link -->
</head>
<body>
	<h1>Application Usage Tracking Service</h1>
	
	<p>
		<input id="btnClose" type="button" value="Close Report" onclick="window.close()"></input>
		<input id="btnRefresh" type="button" value="Refresh Report" onclick="window.navigate(window.document.URL)"></input>
	</p>

	<p>
	<br></br>
	</p>
	
    <h4>Total distinct <em style="color:blue">User</em> records found = <i><xsl:value-of select="//DistinctUsers"/></i></h4>
	<xsl:for-each select="//tblEvents[@User != '']">
		<xsl:value-of select="@User"/>
		<!-- xsl:if test="position()!=last()">, </xsl:if -->
		<!-- note - position(), last() and != comparison operator all require xslt 1.0 support
			 so we will use a dash instead, in all cases, to stay client compatible -->
		 - 
	</xsl:for-each>
	
	<h4>Total distinct <em style="color:blue">Application</em> records found = <i><xsl:value-of select="//DistinctApplications"/></i></h4>
    <xsl:for-each select="//tblEvents[@Application > '']">
		<xsl:value-of select="@Application"/>
		<!-- xsl:if test="position()!=last()">, </xsl:if -->
		<!-- note - position(), last() and != comparison operator all require xslt 1.0 support
			 so we will use a dash instead, in all cases, to stay client compatible -->
		 -  
	</xsl:for-each>
	
    <h4>Total distinct <em style="color:blue">Hostname</em> records found = <i><xsl:value-of select="//DistinctHostnames"/></i></h4>
	<xsl:for-each select="//tblEvents[@Hostname > '']">
		<xsl:value-of select="@Hostname"/>
		<!-- xsl:if test="position()!=last()">, </xsl:if -->
		<!-- note - position(), last() and != comparison operator all require xslt 1.0 support
			 so we will use a dash instead, in all cases, to stay client compatible -->
		 - 
	</xsl:for-each>
	
</body>
</html>
</xsl:template>

</xsl:stylesheet>
