// Wuos.h : Declaration of the CWuos

#ifndef __WUOS_H_
#define __WUOS_H_

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// CWuos
class ATL_NO_VTABLE CWuos : 
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<CWuos, &CLSID_Wuos>,
	public IWuos,
	public IWbemUnboundObjectSink
{
public:
	CWuos() {
		// initialize instance member variables
	}

	~CWuos() {
		// uninitialize instance member variables
	}

DECLARE_REGISTRY_RESOURCEID(IDR_WUOS)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CWuos)
	COM_INTERFACE_ENTRY(IWuos)
	COM_INTERFACE_ENTRY(IWbemUnboundObjectSink)
END_COM_MAP()

// IWuos
public:
	// inherited from IWbemUnboundObjectSink
	STDMETHOD(IndicateToConsumer)(/*[in]*/ IWbemClassObject *pLogicalConsumer, /*[in]*/ LONG lNumObjects, /*[in]*/ IWbemClassObject **apObjects);
};

#endif //__WUOS_H_
