/*	see function usage for version and script description */

var _DEBUG = 0;  // 0 = skip | 1 = stop at hardcoded break points in application

if (-1 == _DEBUG) debugger;

var S_OK = 0, S_FALSE = 1, E_ABORT = 2147483655, E_FAIL = 2147500037,
	DATE_SEP = "-", TIME_SEP = ":", DATE_TIME_SEP = " ",
	msiDoActionStatusSuccess = 1, msiDoActionStatusFailure = 3,
	wbemNoErr = 0, wbemErrFailed = 0x80041001, wbemErrNotFound = -2147217406 /* 0x80041002 */,
	wbemErrAccessDenied = 0x80041003, wbemErrInvalidClass = -2147217392 /* 0x80041010 */,
	wbemImpersonationLevelDelegate = 4, wbemImpersonationLevelImpersonate = 3,
	wbemAuthenticationLevelDefault = 0, wbemAuthenticationLevelNone = 1, 
	wbemPrivilegeDebug = 19, wbemPrivilegeIncreaseBasePriority = 13, wbemPrivilegeIncreaseQuota = 4,
	wbemPrivilegePrimaryToken = 2, wbemPrivilegeTakeOwnership = 8, wbemPrivilegeTcb = 6, 
	wbemPrivilegeProfileSingleProcess = 12, wbemPrivilegeCreateToken = 1, wbemPrivilegeEnableDelegation = 26,
	wbemCimtypeSint8 = 16, wbemCimtypeUint8 = 17, wbemCimtypeSint16 = 2, wbemCimtypeUint16 = 18,
	wbemCimtypeSint32 = 3, wbemCimtypeUint32 = 19, wbemCimtypeSint64 = 20, wbemCimtypeUint64 = 21,
	wbemCimtypeReal32 = 4, wbemCimtypeReal64 = 5, wbemCimtypeBoolean = 11, wbemCimtypeString = 8,
	wbemCimtypeDatetime = 101, wbemCimtypeReference = 102, bemCimtypeChar16 = 103, wbemCimtypeObject = 13,
	wbemCimtypeFlagArray = 8192, wbemChangeFlagCreateOrUpdate = 0,
	SQLDMOGrowth_MB = 0, SQLDMOExec_Default = 0, SQLDMOExec_ContinueOnError = 2, SQLDMOKey_Primary = 1;
	// see winerror.h, msi.dll/msidefs.h, wbemdisp.tlb/wbemcli.h, sqldmo.dll/sqldmo.h for more constant values
		
if (-1 == _DEBUG) debugger;

var oArgV = WScript.Arguments, iArgC = oArgV.Count();  
if (14 > iArgC) { var hr = usage(); WScript.Quit(1); }

if (15 == iArgC) _DEBUG = parseInt(oArgV.item(14));

if (-1 == _DEBUG) debugger;

// assign arguments passed to script to global variables for use later on
var sRdmsHost = oArgV.item(0);
var sRdmsDb = oArgV.item(1);
var sRdmsTbl = oArgV.item(2);
var sWmiAppNspc = oArgV.item(3);
var sWmiAppCsmr = oArgV.item(4);
var sWmiAppCsmrClsId = oArgV.item(5);
var sWmiAppPvdr = oArgV.item(6);
var sWmiAppPvdrClsId = oArgV.item(7);
var sWmiAppPvdrEvent = oArgV.item(8);
var sWmiAppsAdm = oArgV.item(9);
var sWmiAppsAsp = oArgV.item(10);
var sWmiLogEvents = oArgV.item(11);
var sWmiSvcEvents = oArgV.item(12);
var sWmiPlngItvl = oArgV.item(13);
  
if (-1 == _DEBUG) debugger;

var ir = main(iArgC, oArgV);
WScript.Quit(ir);


function main(iArgC, oArgV) {
	var hr = S_OK;
	try {
		if (-1 == _DEBUG) {
			debugger;
			var oShell = new ActiveXObject("WScript.Shell");
			oShell.Popup("Entering function main", 0, "DebugMessage");
			oShell = null;
		}
		if (!iArgC || !oArgV) { hr = E_FAIL; throw hr; }

		if (-1 == _DEBUG) {
			for (var iIndex = 0; iIndex < iArgC; iIndex++) {
				var vTemp = oArgV.item(iIndex);
				if ("foobar" == vTemp) var bTemp = true;
			}
		}

		if (-1 == _DEBUG) debugger;

		hr = AddWmiSettings();
		// if (hr) throw hr;
	}

	catch(xCptn) {
		var oShell = new ActiveXObject("WScript.Shell");
		if (isNaN(xCptn) /* or "number" == typeOf(xCptn) */) {
			oShell.Popup("main() exception handler caught an exception with error number " + xCptn.number.toString() + " with description " + xCptn.description + ".", 0, "DebugMessage");
			hr = xCptn.number; 
		}
		else {
			oShell.Popup("main() exception handler caught an exception with error number " + hr.toString(), 0, "DebugMessage");
		}
		oShell = null;
	}

	if (-1 == _DEBUG) {
		debugger;
		var oShell = new ActiveXObject("WScript.Shell");
		oShell.Popup("Leaving function main with result " + hr.toString(), 0, "DebugMessage");
		oShell = null;
	}
	
	if (msiDoActionStatusSuccess = hr) 
		return S_OK;
	else
		return S_FALSE;
}


function usage() {
	var hr = S_OK;
	try {
		if (-1 == _DEBUG) debugger;
		WScript.Echo("version = 31jan01\n");
		WScript.Echo("description");
		WScript.Echo("  This script provides support for jscript implemented msi custom actions.");
		WScript.Echo("  In this case specifically the addition of the necessary wmi settings.  When");
		WScript.Echo("  initiated from the command line it enables one to debug, using their default");
		WScript.Echo("  jit debugger, this same msi custom actions before calling it from msi.\n");
		WScript.Echo("usage = addWmiSettings.js \"[RDMSHOST]\" \"[RDMSDB]\" \"[RDMSTBL]\" \"[WMIAPPNSPC]\"\n");
		WScript.Echo("                          \"[WMIAPPCSMR]\" \"[WMIAPPCSMRCLSID]\"\n")
		WScript.Echo("                          \"[WMIAPPPVDR]\" \"[WMIAPPPVDRCLSID]\" \"[WMIAPPPVDREVENT]\"\n");
		WScript.Echo("                          \"[WMIAPPSADM]\" \"[WMIAPPSASP]\"");
		WScript.Echo("                          \"[WMILOGEVENTS]\" \"[WMISVCEVENTS]\" \"[WMIPLNGITVL]\"\n");
		WScript.Echo("                         [\"[DEBUG]\"]\n");
		WScript.Echo("where [...] = corresponding windows installer session properties");
	}

	catch(xCptn) {
		if (-1 == _DEBUG) debugger;
		if (isNaN(xCptn)) { var sTemp = xCptn.description; hr = xCptn.number; }
	}

	if (-1 == _DEBUG)	debugger;
	
	return hr;
}


function AddWmiSettings() {
	var hr = S_OK;
	try {
		if (1 == _DEBUG) {
			debugger;
			var oShell = new ActiveXObject("WScript.Shell");
			oShell.Popup("Entering function AddWmiSettings", 0, "DebugMessage");
			oShell = null;
		}

		/*
		// pull required msi session object properties
		var sRdmsHost = Session.Property("RDMSHOST"), sRdmsDb = Session.Property("RDMSDB"), 
			sRdmsTbl = Session.Property("RDMSTBL"), sWmiAppNspc = Session.Property("WMIAPPNSPC"),
			sWmiAppCsmr = Session.Property("WMIAPPCSMR"), sWmiAppCsmrClsId = Session.Property("WMIAPPCSMRCLSID"),
			sWmiAppPvdr = Session.Property("WMIAPPPVDR"), sWmiAppPvdrClsId = Session.Property("WMIAPPPVDRCLSID"),
			sWmiAppsAdm = Session.Property("WMIAPPSADM"), sWmiAppsAsp = Session.Property("WMIAPPSASP"),
			sWmiLogEvents = Session.Property("WMILOGEVENTS"), sWmiSvcEvents = Session.Property("WMISVCEVENTS"),
			sWmiPlngItvl = Session.Property("WMIPLNGITVL"), sWmiAppPvdrEvent = Session.Property("WMIAPPPVDREVENT");
		*/

		// dictionary elements will have format key = "<cim property name>" and item = "<cim property value>"
		var daProps = new ActiveXObject("Scripting.Dictionary");
		if (!daProps) { hr = E_FAIL; throw hr; }
		var daPropsType = new ActiveXObject("Scripting.Dictionary");
		if (!daPropsType) { hr = E_FAIL; throw hr; }
			
		if (-1 == _DEBUG) debugger;

		// note - currently authored to support non root\cimv2 namespace and subsequent ViewClass for Win32_Process 
		// events only, use of root\cimv2 space works for Win32_Process, Win32_EventLog and Win32_Service which will
		// be forward compatible with whistler installations

		if (("root" != sWmiAppNspc.toLowerCase()) && ("root\\cimv2" != sWmiAppNspc.toLowerCase())) {
		  // add __Namespace instance(s), if other than already existing "root" and "root\\cimv2" namespaces
		    if (-1 == _DEBUG) debugger;
			var sWmiAppNspcParent = sWmiAppNspc.substr(0, sWmiAppNspc.lastIndexOf("\\")),
				sWmiAppNspcSibling = sWmiAppNspc.substr(sWmiAppNspc.lastIndexOf("\\") + 1);
			daProps.Add("Name", sWmiAppNspcSibling);
			hr = AddWmiInst(sWmiAppNspcParent, "__Namespace", daProps);
			if (hr) throw hr;
		}

		if ("root\\cimv2" != sWmiAppNspc.toLowerCase()) {
	  	  // add view class union(s) __Win32Provider instance(s)
			if (-1 == _DEBUG) debugger;
			daProps.RemoveAll();
			daProps.Add("Name", "MS_VIEW_INSTANCE_PROVIDER");
			daProps.Add("CLSID", "{AA70DDF4-E11C-11D1-ABB0-00C04FD9159E}")
			daProps.Add("ImpersonationLevel", 1);
			daProps.Add("PerUserInitialization", "True");
			hr = AddWmiInst(sWmiAppNspc, "__Win32Provider", daProps);
			if (hr) throw hr;

		  // add view class union(s) __InstanceProviderRegistration instance(s)
			if (-1 == _DEBUG) debugger;
			var sTemp = "\\\\.\\" + sWmiAppNspc + ":__Win32Provider.Name=\"MS_VIEW_INSTANCE_PROVIDER\"";
			// e.g. "\\\\.\\root\\cimv2\\msftNsg:__Win32Provider.Name=\"MS_VIEW_INSTANCE_PROVIDER\""
			daProps.RemoveAll();
			daProps.Add("provider", sTemp);
			// daProps.Add("InteractionType", 0);
			daProps.Add("QuerySupportLevels", new Array("WQL:UnarySelect"));
			daProps.Add("SupportsDelete", true);
			daProps.Add("SupportsEnumeration", true);
			daProps.Add("SupportsGet", true);
			daProps.Add("SupportsPut", true);
			hr = AddWmiInst(sWmiAppNspc, "__InstanceProviderRegistration", daProps);
			if (hr) throw hr;

		  // add view class union(s) __MethodProviderRegistration instance(s)
			if (-1 == _DEBUG) debugger;
			sTemp = "\\\\.\\" + sWmiAppNspc + ":__Win32Provider.Name=\"MS_VIEW_INSTANCE_PROVIDER\"";
			// e.g. "\\\\.\\root\\cimv2\\msftNsg:__Win32Provider.Name=\"MS_VIEW_INSTANCE_PROVIDER\""
			daProps.RemoveAll();
			daProps.Add("provider", sTemp);
			hr = AddWmiInst(sWmiAppNspc, "__MethodProviderRegistration", daProps);
			if (hr) throw hr;

		  // add non-derived attributed, aka object qualifiers, view class(es)
			if (-1 == _DEBUG) debugger;
			// note 1 - it is assumed that item 0 is __CLASS value and item 1 requires "key" attribute applied, aka property qualifier
			// note 2 - each property item is assumed to require "PropertySources" attribute applied, aka property qualifier
			var daObjQlfs = new ActiveXObject("Scripting.Dictionary");
			if (!daObjQlfs) { hr = E_FAIL; throw hr; }
			daObjQlfs.Add("union", true);
			if (-1 == _DEBUG) debugger;
			daObjQlfs.Add("ViewSources", new Array("select CreationDate, CSName, ExecutablePath, Handle, Name, ProcessID, TerminationDate from Win32_Process"));
			daObjQlfs.Add("ViewSpaces", new Array("\\\\.\\root\\cimv2"));
			daObjQlfs.Add("dynamic", true);
			daObjQlfs.Add("provider", "MS_VIEW_INSTANCE_PROVIDER");
			daProps.RemoveAll(); daPropsType.RemoveAll();
			daProps.Add("__CLASS", "ViewClassUnionOfRootCimv2Win32Process");  daPropsType.Add("__CLASS", wbemCimtypeString);
			daProps.Add("Handle", "\0");  daPropsType.Add("Handle", wbemCimtypeString);
			daProps.Add("CreationDate", "20010124000000.000000-480");  daPropsType.Add("CreationDate", wbemCimtypeDatetime);
			daProps.Add("CSName", "\0");  daPropsType.Add("CSName", wbemCimtypeString);
			daProps.Add("ExecutablePath", "\0");  daPropsType.Add("ExecutablePath", wbemCimtypeString);
			daProps.Add("Name", "\0");  daPropsType.Add("Name", wbemCimtypeString);
			daProps.Add("ProcessID", 0);  daPropsType.Add("ProcessID", wbemCimtypeUint32);
			daProps.Add("TerminationDate", "20010124000000.000000-480");  daPropsType.Add("TerminationDate", wbemCimtypeDatetime);
			// note 1 - wmi datetime format = yyyymmddHHMMSS.mmmmmmsUUU, ranging from January 1, 1601 onward
			// note 2 - need to pass a valid wmidate time default value for Datetime properties or class creation request will
			// fail.  This doesn't seem to be an issue when creating the class from within a mof file.
			hr = AddWmiViewClass(sWmiAppNspc, null, daObjQlfs, daProps, daPropsType);
			if (hr) throw hr;
		}

	  // add __Win32Provider instance(s)
		if (-1 == _DEBUG) debugger;
		// general purpose event consumer provider from robertob@microsoft.com
		daProps.RemoveAll();
		daProps.Add("Name", "phy" + sWmiAppCsmr);
		daProps.Add("CLSID", sWmiAppCsmrClsId)
		hr = AddWmiInst(sWmiAppNspc, "__Win32Provider", daProps);
		if (hr) throw hr;
		
		if (-1 == _DEBUG) debugger;
		// general purpose event provider from robertob@microsoft.com
		daProps.RemoveAll();
		daProps.Add("Name", "phy" + sWmiAppPvdr);
		daProps.Add("CLSID", sWmiAppPvdrClsId)
		hr = AddWmiInst(sWmiAppNspc, "__Win32Provider", daProps);
		if (hr) throw hr;

	  // add __EventConsumerProviderRegistration instance(s)
	  	if (-1 == _DEBUG) debugger;
		var sTemp = "\\\\.\\" + sWmiAppNspc + ":__Win32Provider.Name=\"phy" + sWmiAppCsmr + "\"";
		// e.g. "\\\\.\\root\\cimv2:__Win32Provider.Name=\"phyGnlPpsEvntCsmr\""
		// or	"\\\\.\\root\\cimv2\\msftNsg:__Win32Provider.Name=\"phyGnlPpsEvntCsmr\""
		daProps.RemoveAll();
		daProps.Add("Provider", sTemp);
		daProps.Add("ConsumerClassNames", new Array("phy" + sWmiAppCsmr));
		hr = AddWmiInst(sWmiAppNspc, "__EventConsumerProviderRegistration", daProps);
		if (hr) throw hr;

	  // add __EventProviderRegistration instance(s)
	  	if (-1 == _DEBUG) debugger;
		var sTemp = "\\\\.\\" + sWmiAppNspc + ":__Win32Provider.Name=\"phy" + sWmiAppPvdr + "\"";
		// e.g. "\\\\.\\root\\cimv2:__Win32Provider.Name=\"phyGnlPpsEvntPvdr\""
		// or	"\\\\.\\root\\cimv2\\msftNsg:__Win32Provider.Name=\"phyGnlPpsEvntPvdr\""
		daProps.RemoveAll();
		daProps.Add("Provider", sTemp);
		daProps.Add("EventQueryList", new Array("select * from GpepEvent"));
		hr = AddWmiInst(sWmiAppNspc, "__EventProviderRegistration", daProps);
		if (hr) throw hr;

	  // add __EventConsumer class(es)
  		if (-1 == _DEBUG) debugger;
		// note - it is assumed that item 0 is __CLASS value and item 1 requires "key" attribute applied, aka property qualifier
		daProps.RemoveAll(); daPropsType.RemoveAll();
		daProps.Add("__CLASS", "phy" + sWmiAppCsmr);  daPropsType.Add("__CLASS", wbemCimtypeString);
		daProps.Add("name", "\0");  daPropsType.Add("name", wbemCimtypeString);
		daProps.Add("description", "\0");  daPropsType.Add("description", wbemCimtypeString);
		daProps.Add("rdmsHost", "\0");  daPropsType.Add("rdmsHost", wbemCimtypeString);
		daProps.Add("rdmsDb", "\0");  daPropsType.Add("rdmsDb", wbemCimtypeString);
		daProps.Add("rdmsTbl", "\0");  daPropsType.Add("rdmsTbl", wbemCimtypeString);
		daProps.Add("cmdLine", "\0");  daPropsType.Add("cmdLine", wbemCimtypeString);
		daProps.Add("showWindow", 0);  daPropsType.Add("showWindow", wbemCimtypeUint16);
		daProps.Add("propsAsArgs", false);  daPropsType.Add("propsAsArgs", wbemCimtypeBoolean);
		daProps.Add("hostnameProp", "\0");  daPropsType.Add("hostnameProp", wbemCimtypeString);
		daProps.Add("createProp", "\0");  daPropsType.Add("createProp", wbemCimtypeString);
		daProps.Add("terminateProp", "\0");  daPropsType.Add("terminateProp", wbemCimtypeString);
		daProps.Add("otherProps", "\0");  daPropsType.Add("otherProps", wbemCimtypeString);
		hr = AddWmiClass(sWmiAppNspc, "__EventConsumer", daProps, daPropsType);
		if (hr) throw hr;

	  // add __ExtrinsicEvent class(es)
		if (-1 == _DEBUG) debugger;
		// note - it is assumed that item 0 is __CLASS value and item 1 requires "key" attribute applied, aka property qualifier
		daProps.RemoveAll(); daPropsType.RemoveAll();
		daProps.Add("__CLASS", sWmiAppPvdrEvent);  daPropsType.Add("__CLASS", wbemCimtypeString);
		daProps.Add("Application", "\0");  daPropsType.Add("Application", wbemCimtypeString);
		daProps.Add("User", "\0");  daPropsType.Add("User", wbemCimtypeString);
		daProps.Add("NumberValue", 0);  daPropsType.Add("NumberValue", wbemCimtypeSint32);
		daProps.Add("StringValue", "\0");  daPropsType.Add("StringValue", wbemCimtypeString);
		daProps.Add("Hostname", "\0");  daPropsType.Add("Hostname", wbemCimtypeString);
		daProps.Add("CreationDate", "20010124000000.000000-480");  daPropsType.Add("CreationDate", wbemCimtypeDatetime);
		daProps.Add("TerminationDate", "20010124000000.000000-480");  daPropsType.Add("TerminationDate", wbemCimtypeDatetime);
		// note 1 - wmi datetime format = yyyymmddHHMMSS.mmmmmmsUUU, ranging from January 1, 1601 onward
		// note 2 - need to pass a valid wmidate time default value for Datetime properties or class creation request will
		// fail.  This doesn't seem to be an issue when creating the class from within a mof file.  This default setting
		// is tied to a manifest constent used to deal with null value dates in the gnlPpsEventPvdr CWuos::IndicateToConsumer
		// method, so if you change this default then you also need to change the constant setting in stdafx.h
		hr = AddWmiClass(sWmiAppNspc, "__ExtrinsicEvent", daProps, daPropsType);
		if (hr) throw hr;

	  // add "phy" + sWmiAppCsmr instance(s)
  		if (-1 == _DEBUG) debugger;
		daProps.RemoveAll();
		daProps.Add("name", "lgcGpecGpepEvent");  // | "lgc" + sWmiAppCsmr);
		daProps.Add("description", "gpepEvent");
		daProps.Add("rdmsHost", sRdmsHost);
		daProps.Add("rdmsDb", sRdmsDb);
		daProps.Add("rdmsTbl", sRdmsTbl);
		daProps.Add("hostnameProp", "Hostname");
		daProps.Add("createProp", "CreationDate");
		daProps.Add("terminateProp", "TerminationDate");
		daProps.Add("otherProps", "NumberValue Application StringValue");
		hr = AddWmiInst(sWmiAppNspc, "phy" + sWmiAppCsmr, daProps);
		if (hr) throw hr;

  		if (-1 == _DEBUG) debugger;
		daProps.RemoveAll();
		daProps.Add("name", "lgcGpecPrcCreateEvent");  // | "lgc" + sWmiAppCsmr);
		daProps.Add("description", "prcCreateEvent");
		daProps.Add("rdmsHost", sRdmsHost);
		daProps.Add("rdmsDb", sRdmsDb);
		daProps.Add("rdmsTbl", sRdmsTbl);
		daProps.Add("hostnameProp", "CSName");
		daProps.Add("createProp", "CreationDate");
		daProps.Add("terminateProp", "\0");
		daProps.Add("otherProps", "ProcessID Name ExecutablePath");
		// note - Name property contains the exe name w/o the path regardless of how the user initiated the process.  The 
		// event targetinstance object properties "Caption", "Description" and "ExecutablePath" also contain the exe name.
		hr = AddWmiInst(sWmiAppNspc, "phy" + sWmiAppCsmr, daProps);
		if (hr) throw hr;

		daProps.RemoveAll();
		daProps.Add("name", "lgcGpecPrcTerminateEvent");  // | "lgc" + sWmiAppCsmr);
		daProps.Add("description", "prcTerminateEvent");
		daProps.Add("rdmsHost", sRdmsHost);
		daProps.Add("rdmsDb", sRdmsDb);
		daProps.Add("rdmsTbl", sRdmsTbl);
		daProps.Add("hostnameProp", "CSName");
		daProps.Add("createProp", "CreationDate");
		daProps.Add("terminateProp", "\0");
		// note - the TerminationDate property does not get populated, CreationDate contains correct datetime when process
		// was created therefore we need to generate the terminateProp value based on the time that the event was received
		daProps.Add("otherProps", "ProcessID Name ExecutablePath")
		hr = AddWmiInst(sWmiAppNspc, "phy" + sWmiAppCsmr, daProps);
		if (hr) throw hr;

		//if ("1" == sWmiLogEvents) {
			daProps.RemoveAll();
			daProps.Add("name", "lgcGpecLogEvent");  // | "lgc" + sWmiAppCsmr);
			daProps.Add("description", "logEvent");
			daProps.Add("rdmsHost", sRdmsHost);
			daProps.Add("rdmsDb", sRdmsDb);
			daProps.Add("rdmsTbl", sRdmsTbl);
			daProps.Add("hostnameProp", "ComputerName");
			daProps.Add("createProp", "TimeGenerated");
			daProps.Add("otherProps", "LogFile SourceName Type Category EventCode Message")
			hr = AddWmiInst(sWmiAppNspc, "phy" + sWmiAppCsmr, daProps);
			if (hr) throw hr;
		//}

		//if ("1" == sWmiSvcEvents) {
			daProps.RemoveAll();
			daProps.Add("name", "lgcGpecSvcEvent");  // | "lgc" + sWmiAppCsmr);
			daProps.Add("description", "svcEvent");
			daProps.Add("rdmsHost", sRdmsHost);
			daProps.Add("rdmsDb", sRdmsDb);
			daProps.Add("rdmsTbl", sRdmsTbl);
			daProps.Add("hostnameProp", "SystemName");
			daProps.Add("otherProps", "Name DisplayName Started State StartMode")
			hr = AddWmiInst(sWmiAppNspc, "phy" + sWmiAppCsmr, daProps);
			if (hr) throw hr;
		//}

	  // add __EventFilter instance(s)
	  	if (-1 == _DEBUG) debugger;
		daProps.RemoveAll();
		daProps.Add("Name", "fltGpepEvent");
		daProps.Add("QueryLanguage", "wql");
		sTemp = "select * from ";
		sTemp += sWmiAppPvdrEvent;
		daProps.Add("Query", sTemp);
		hr = AddWmiInst(sWmiAppNspc, "__EventFilter", daProps);
		if (hr) throw hr;

	  	if (-1 == _DEBUG) debugger;
		daProps.RemoveAll();
		daProps.Add("Name", "fltPrcCreateEvent");
		daProps.Add("QueryLanguage", "wql");
		if ("root\\cimv2" != sWmiAppNspc.toLowerCase())
			sTemp = "select CreationDate, CSName, ExecutablePath, Name, ProcessID, TargetInstance, TerminationDate from ";
		else
			sTemp = "select * from ";
			// note - select named columns appears to only work against view classes provider and not against native provider
		sTemp += "__InstanceCreationEvent ";
		sTemp += "within " + parseInt(sWmiPlngItvl) + " where TargetInstance isa ";
		if ("root\\cimv2" != sWmiAppNspc.toLowerCase())
			sTemp += "\"ViewClassUnionOfRootCimv2Win32Process\"";
		else
			sTemp += "\"Win32_Process\"";
		// check if wildcard was specified 
		var iAppsAspWldCrdFnd = sWmiAppsAsp.indexOf("*"), iAppsAdmWldCrdFnd = sWmiAppsAdm.indexOf("*"),
			asAppsAsp, asAppsAll;
		if (-1 == _DEBUG) debugger;
		if ((-1 == iAppsAspWldCrdFnd) && (-1 == iAppsAdmWldCrdFnd)) {
			sTemp += " and (";
			asAppsAsp = sWmiAppsAsp.split(" ");
			asAppsAll = asAppsAsp.concat(sWmiAppsAdm.split(" "));  // combine application list
			for (var iIndex = 0; iIndex < asAppsAll.length; iIndex++) {
				sTemp += "TargetInstance.Name = \"" + asAppsAll[iIndex] + "\"";
				if ((iIndex + 1) < asAppsAll.length)
					sTemp += " or ";
				else
					sTemp += ")";
			}
		}
		daProps.Add("Query", sTemp);
		hr = AddWmiInst(sWmiAppNspc, "__EventFilter", daProps);
		if (hr) throw hr;

		daProps.RemoveAll();
		daProps.Add("Name", "fltPrcTerminateEvent");
		daProps.Add("QueryLanguage", "wql");
		if ("root\\cimv2" != sWmiAppNspc.toLowerCase())
			sTemp = "select CreationDate, CSName, ExecutablePath, Name, ProcessID, TargetInstance, TerminationDate from ";
		else
			sTemp = "select * from ";
			// note - select named columns appears to only work against view classes provider and not against native provider
		// note - select named columns appears to only work against view classes provider and not against native provider
		sTemp += "__InstanceDeletionEvent ";
		sTemp += "within " + parseInt(sWmiPlngItvl) + " where TargetInstance isa ";
		if ("root\\cimv2" != sWmiAppNspc.toLowerCase())
			sTemp += "\"ViewClassUnionOfRootCimv2Win32Process\"";
		else
			sTemp += "\"Win32_Process\"";
		if (-1 == _DEBUG) debugger;
		if ((-1 == iAppsAspWldCrdFnd) && (-1 == iAppsAdmWldCrdFnd)) {
			sTemp += " and (";
			for (var iIndex = 0; iIndex < asAppsAll.length; iIndex++) {
				sTemp += "TargetInstance.Name = \"" + asAppsAll[iIndex] + "\"";
				if ((iIndex + 1) < asAppsAll.length)
					sTemp += " or ";
				else
					sTemp += ")";
			}
		}
		daProps.Add("Query", sTemp);
		hr = AddWmiInst(sWmiAppNspc, "__EventFilter", daProps);
		if (hr) throw hr;

		//if ("1" == sWmiLogEvents) {
			daProps.RemoveAll();
			daProps.Add("Name", "fltLogEvent");
			daProps.Add("QueryLanguage", "wql");
			sTemp = "select * from ";
			sTemp += "__InstanceCreationEvent ";
			sTemp += "where TargetInstance isa \"Win32_NTLogEvent\"";
			daProps.Add("Query", sTemp);
			hr = AddWmiInst(sWmiAppNspc, "__EventFilter", daProps);
			if (hr) throw hr;
		//}

		// if ("1" == sWmiSvcEvents) {
			daProps.RemoveAll();
			daProps.Add("Name", "fltSvcEvent");
			daProps.Add("QueryLanguage", "wql");
			sTemp = "select * from ";
			sTemp += "__InstanceModificationEvent ";
			sTemp += "within " + parseInt(sWmiPlngItvl) + " where TargetInstance isa \"Win32_Service\"";
			daProps.Add("Query", sTemp);
			hr = AddWmiInst(sWmiAppNspc, "__EventFilter", daProps);
			if (hr) throw hr;
		//}

	  // add __FilterToConsumerBinding instance(s)
		if (-1 == _DEBUG) debugger;
		sTemp = "phy" + sWmiAppCsmr + ".Name=\"lgcGpecGpepEvent\"";
		// e.g. "phyGnlPpsEvntCsmr.Name=\"lgcGpecGpepEvent\""
		daProps.RemoveAll();
		daProps.Add("Consumer", sTemp);
		daProps.Add("Filter", "__EventFilter.Name=\"fltGpepEvent\"");
		daProps.Add("DeliverSynchronously", false);
		hr = AddWmiInst(sWmiAppNspc, "__FilterToConsumerBinding", daProps);
		if (hr) throw hr;

	    if (-1 == _DEBUG) debugger;
		sTemp = "phy" + sWmiAppCsmr + ".Name=\"lgcGpecPrcCreateEvent\"";
		// e.g. "phyGnlPpsEvntCsmr.Name=\"lgcGpecPrcCreateEvent\""
		daProps.RemoveAll();
		daProps.Add("Consumer", sTemp);
		daProps.Add("Filter", "__EventFilter.Name=\"fltPrcCreateEvent\"");
		daProps.Add("DeliverSynchronously", false);
		hr = AddWmiInst(sWmiAppNspc, "__FilterToConsumerBinding", daProps);
		if (hr) throw hr;

		sTemp = "phy" + sWmiAppCsmr + ".Name=\"lgcGpecPrcTerminateEvent\"";
		// e.g. "phyGnlPpsEvntCsmr.Name=\"lgcGpecPrcTerminateEvent\""
		daProps.RemoveAll();
		daProps.Add("Consumer", sTemp);
		daProps.Add("Filter", "__EventFilter.Name=\"fltPrcTerminateEvent\"");
		daProps.Add("DeliverSynchronously", false);
		hr = AddWmiInst(sWmiAppNspc, "__FilterToConsumerBinding", daProps);
		if (hr) throw hr;

		if ("1" == sWmiLogEvents) {
			sTemp = "phy" + sWmiAppCsmr + ".Name=\"lgcGpecLogEvent\"";
			// e.g. "phyGnlPpsEvntCsmr.Name=\"lgcGpecLogEvent\""
			daProps.RemoveAll();
			daProps.Add("Consumer", sTemp);
			daProps.Add("Filter", "__EventFilter.Name=\"fltLogEvent\"");
			daProps.Add("DeliverSynchronously", false);
			hr = AddWmiInst(sWmiAppNspc, "__FilterToConsumerBinding", daProps);
			if (hr) throw hr;
		}

		if ("1" == sWmiSvcEvents) {
			sTemp = "phy" + sWmiAppCsmr + ".Name=\"lgcGpecSvcEvent\"";
			// e.g. "phyGnlPpsEvntCsmr.Name=\"lgcGpecSvcEvent\""
			daProps.RemoveAll();
			daProps.Add("Consumer", sTemp);
			daProps.Add("Filter", "__EventFilter.Name=\"fltSvcEvent\"");
			daProps.Add("DeliverSynchronously", false);
			hr = AddWmiInst(sWmiAppNspc, "__FilterToConsumerBinding", daProps);
			if (hr) throw hr;
		}
	}

	catch(xCptn) {
		if (-1 == _DEBUG) debugger;
		if (isNaN(xCptn)) { var sTemp = xCptn.description; hr = xCptn.number; }	
	}

	if (1 == _DEBUG) {
		debugger;
		var oShell = new ActiveXObject("WScript.Shell");
		oShell.Popup("Leaving function AddWmiSettings with result " + hr.toString(), 0, "DebugMessage");
		oShell = null;
	}
	if (!hr)
		return msiDoActionStatusSuccess;
	else
		return msiDoActionStatusFailure;
}


function AddWmiViewClass(sNspc, sClass, daObjQlfs, daProps, daPropsType) {
	var hr = S_OK;
	try {
		if (2 == _DEBUG) debugger;
		if (!sNspc || ("" == sNspc) || /* !sClass || ("" == sClass) || */
			!daObjQlfs || !daObjQlfs.Count || !daProps || !daProps.Count || 
			!daPropsType || !daPropsType.Count || (daProps.Count != daPropsType.Count)) { hr = E_FAIL; throw hr }

		var oSWbemLocator = new ActiveXObject("WbemScripting.SWbemLocator");
		if (!oSWbemLocator) { hr = E_FAIL; throw hr; }

		/*
		if (-1 == _DEBUG) debugger;
		oSWbemLocator.Security_.ImpersonationLevel = wbemImpersonationLevelImpersonate;
		oSWbemLocator.Security_.AuthenticationLevel = wbemAuthenticationLevelDefault;
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeDebug, true);
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeIncreaseBasePriority, true);;
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeIncreaseQuota, true);
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegePrimaryToken, true);
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeTakeOwnership, true);
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeTcb, true);
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeProfileSingleProcess, true);
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeCreateToken, true);
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeEnableDelegation, true);
		var iTemp = oSWbemLocator.Security_.ImpersonationLevel;  // should now be = 3
		iTemp = oSWbemLocator.Security_.AuthenticationLevel;  // should now be = 0
		var oSWbemPrivilege = oSWbemLocator.Security_.Privileges.Item(wbemPrivilegeDebug);  // should now exist and = true
		*/
		
		var oSWbemServices = oSWbemLocator.ConnectServer(null, sNspc);
		if (!oSWbemServices) { hr = E_FAIL; throw hr; }

		if (-1 == _DEBUG) debugger;

		// obtain reference class object
		var oSWbemRefClass = oSWbemServices.Get(sClass, 0, null);
		if (!oSWbemRefClass) { hr = E_FAIL; throw hr; }

		var oSWbemClass;
		if (!sClass) {
			// create a new non-derived class
			oSWbemClass = oSWbemRefClass;  // i.e. oSWbemServices.Get("", 0, null);
			if (!oSWbemClass) { hr = E_FAIL; throw hr; }
		}
		else {
			// spawn a new class derived from the reference class
			oSWbemClass = oSWbemRefClass.SpawnDerivedClass_(0);
			if (!oSWbemClass) { hr = E_FAIL; throw hr; }
		}

		// apply view class attributes, aka object qualifiers
		var oSWbemQlfSet = oSWbemClass.Qualifiers_, oSWbemQlf;
		if (!oSWbemQlfSet) { hr = E_FAIL; throw hr; }
		var asKeys = new VBArray(daObjQlfs.Keys()).toArray();  // get the keys safearray
		for (var iIndex = 0; iIndex < daObjQlfs.Count; iIndex++) {
			if ((2 == _DEBUG) && ("ViewSources" == asKeys[iIndex])) {
				debugger;
				oSWbemQlf = oSWbemQlfSet.Add(asKeys[iIndex], daObjQlfs(asKeys[iIndex]), true, true, true, 0);
				// note - for this setting above it works when script run outside of msi custom action environment
				// but generates and exception -2147217407/0x80041001 == "Generic Failure" == wbemCli.h WBEM_E_FAILED
				// when run from within msi custom action environment, this may be due to the security context that
				// msi custom actions are run under, but what seems to be the trouble when looking a locals view while
				// debugging script when running as a customAction versus using cscript is that the locals are not
				// being properly initialized on this call.
			}
			else {
				oSWbemQlf = oSWbemQlfSet.Add(asKeys[iIndex], daObjQlfs(asKeys[iIndex]), true, true, true, 0);
			}
			if (!oSWbemQlf) { hr = E_FAIL; throw hr; }
		}

		// configure view class properties
		var oSWbemPropSet = oSWbemClass.Properties_;
		if (!oSWbemPropSet) { hr = E_FAIL; throw hr; }
		asKeys = new VBArray(daProps.Keys()).toArray();  // get the keys safearray
		for (var iIndex = 0; iIndex < daProps.Count; iIndex++) {
			if (0 == iIndex) {
				oSWbemClass.Path_.Class = daProps(asKeys[iIndex]);  // i.e. "__CLASS"
				// persist new class
				// var oSWbemObjPath = oSWbemClass.Put_();  // | (wbemChangeFlagCreateOrUpdate, null)
				// if (!oSWbemObjPath) { hr = E_FAIL; throw hr }
			}
			else
			{
				// add new property name and cim type to class definition
				var bArray = false;
				wbemCimtypeFlagArray & daPropsType(asKeys[iIndex]) ? bArray = true : bArray = false;
				var iCimType = 0;  
				wbemCimtypeFlagArray & daPropsType(asKeys[iIndex]) ? iCimType = daPropsType(asKeys[iIndex]) - wbemCimtypeFlagArray : iCimType = daPropsType(asKeys[iIndex]);

				if (-1 == _DEBUG) debugger;
				var oSWbemProp = oSWbemPropSet.Add(asKeys[iIndex], iCimType, bArray, 0);
				if (!oSWbemProp) { hr = E_FAIL; throw hr; }
		
				// set default value for new property
				// oSWbemProp.Value = daProps(asKeys[iIndex]);
	 			
				// apply "PropertySources" attribute, aka property qualifier
				var oSWbemQlfSet = oSWbemProp.Qualifiers_;
				if (!oSWbemQlfSet) { hr = E_FAIL; throw hr; }
				var oSWbemQlf = oSWbemQlfSet.Add("PropertySources", new Array(asKeys[iIndex]), false, false, true, 0);
				if (!oSWbemQlf) { hr = E_FAIL; throw hr; }

				// apply "key" attribute, aka property qualifier
				if (1 == iIndex) {  
					oSWbemQlfSet = oSWbemProp.Qualifiers_;
					oSWbemQlf = oSWbemQlfSet.Add("key", true, true, true, false, 0);
					if (!oSWbemQlf) { hr = E_FAIL; throw hr; }
				}
			}
		}

		if (-1 == _DEBUG) debugger;
	
		// persist new class updates
		var oSWbemObjPath = oSWbemClass.Put_();  // | (wbemChangeFlagCreateOrUpdate, null)
		if (!oSWbemObjPath) { hr = E_FAIL; throw hr }
		if (-1 == _DEBUG) { var sTemp = oSWbemObjPath.Path; sTemp = oSWbemObjPath.RelPath; }
	}

	catch(xCptn) {
		if (-1 == _DEBUG) debugger;
		if (isNaN(xCptn)) { var sTemp = xCptn.description; hr = xCptn.number; }	
	}

	if (-1 == _DEBUG) debugger;
	return hr;
}


function AddWmiClass(sNspc, sClass, daProps, daPropsType) {
	var hr = S_OK;
	try {
		if (-1 == _DEBUG) debugger;
		if (!sNspc || ("" == sNspc) || /* !sClass || ("" == sClass) || */
			!daProps || !daProps.Count || !daPropsType || !daPropsType.Count ||
			(daProps.Count != daPropsType.Count)) { hr = E_FAIL; throw hr }

		var oSWbemLocator = new ActiveXObject("WbemScripting.SWbemLocator");
		if (!oSWbemLocator) { hr = E_FAIL; throw hr; }

		/*
		if (-1 == _DEBUG) debugger;
		oSWbemLocator.Security_.ImpersonationLevel = wbemImpersonationLevelImpersonate;
		oSWbemLocator.Security_.AuthenticationLevel = wbemAuthenticationLevelDefault;
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeDebug, true);
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeIncreaseBasePriority, true);;
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeIncreaseQuota, true);
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegePrimaryToken, true);
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeTakeOwnership, true);
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeTcb, true);
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeProfileSingleProcess, true);
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeCreateToken, true);
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeEnableDelegation, true);
		var iTemp = oSWbemLocator.Security_.ImpersonationLevel;  // should now be = 3
		iTemp = oSWbemLocator.Security_.AuthenticationLevel;  // should now be = 0
		var oSWbemPrivilege = oSWbemLocator.Security_.Privileges.Item(wbemPrivilegeDebug);  // should now exist and = true
		*/

		var oSWbemServices = oSWbemLocator.ConnectServer(null, sNspc);
		if (!oSWbemServices) { hr = E_FAIL; throw hr; }

		// obtain reference class object
		var oSWbemRefClass = oSWbemServices.Get(sClass, 0, null);
		if (!oSWbemRefClass) { hr = E_FAIL; throw hr; }

		var oSWbemClass;
		if (!sClass) {
			// create a new non-derived class
			oSWbemClass = oSWbemRefClass;  // i.e. oSWbemServices.Get("", 0, null);
			if (!oSWbemClass) { hr = E_FAIL; throw hr; }
		}
		else {
			// spawn a new class derived from the reference class
			oSWbemClass = oSWbemRefClass.SpawnDerivedClass_(0);
			if (!oSWbemClass) { hr = E_FAIL; throw hr; }
		}

		var oSWbemPropSet = oSWbemClass.Properties_;
		if (!oSWbemPropSet) { hr = E_FAIL; throw hr; }
		
		var asKeys = new VBArray(daProps.Keys()).toArray();  // get the keys safearray
		for (var iIndex = 0; iIndex < daProps.Count; iIndex++) {
			if (0 == iIndex) {
				oSWbemClass.Path_.Class = daProps(asKeys[iIndex]);  // i.e. "__CLASS"
			}
			else
			{
				// add new property name and cim type to class definition
				var bArray = false;
				wbemCimtypeFlagArray & daPropsType(asKeys[iIndex]) ? bArray = true : bArray = false;
				var iCimType = 0;  
				wbemCimtypeFlagArray & daPropsType(asKeys[iIndex]) ? iCimType = daPropsType(asKeys[iIndex]) - wbemCimtypeFlagArray : iCimType = daPropsType(asKeys[iIndex]);
				var oSWbemProp = oSWbemPropSet.Add(asKeys[iIndex], iCimType, bArray, 0);
				if (!oSWbemProp) { hr = E_FAIL; throw hr; }
		
				// set default value for new property
				oSWbemProp.Value = daProps(asKeys[iIndex]);

				if (1 != iIndex) { 
					// apply "read" attribute, aka property qualifier
					var oSWbemQlfSet = oSWbemProp.Qualifiers_,
						oSWbemQlf = oSWbemQlfSet.Add("read", true, false, false, true, 0);
					if (!oSWbemQlf) { hr = E_FAIL; throw hr; }
				}
				else {  // 1 == iIndex	 			
					// apply "key" attribute, aka property qualifier
					var oSWbemQlfSet = oSWbemProp.Qualifiers_,
						oSWbemQlf = oSWbemQlfSet.Add("key", true, true, true, false, 0);
					if (!oSWbemQlf) { hr = E_FAIL; throw hr; }
				}
			}
		}

		if (-1 == _DEBUG) debugger;
		// persist new class
		var oSWbemObjPath = oSWbemClass.Put_();  // | (wbemChangeFlagCreateOrUpdate, null)
		if (!oSWbemObjPath) { hr = E_FAIL; throw hr }
		if (-1 == _DEBUG) { var sTemp = oSWbemObjPath.Path; sTemp = oSWbemObjPath.RelPath; }
	}

	catch(xCptn) {
		if (-1 == _DEBUG) debugger;
		if (isNaN(xCptn)) { var sTemp = xCptn.description; hr = xCptn.number; }	
	}

	if (-1 == _DEBUG) debugger;
	return hr;
}


function AddWmiInst(sNspc, sClass, daProps) {
	var hr = S_OK;
	try {
		if (2 == _DEBUG) debugger;
		if (!sNspc || ("" == sNspc) || !sClass || ("" == sClass) ||
			!daProps || !daProps.Count) { hr = E_FAIL; throw hr }

		var oSWbemLocator = new ActiveXObject("WbemScripting.SWbemLocator");
		if (!oSWbemLocator) { hr = E_FAIL; throw hr; }

		/*
		if (-1 == _DEBUG) debugger;
		oSWbemLocator.Security_.ImpersonationLevel = wbemImpersonationLevelImpersonate;
		oSWbemLocator.Security_.AuthenticationLevel = wbemAuthenticationLevelDefault;
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeDebug, true);
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeIncreaseBasePriority, true);;
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeIncreaseQuota, true);
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegePrimaryToken, true);
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeTakeOwnership, true);
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeTcb, true);
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeProfileSingleProcess, true);
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeCreateToken, true);
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeEnableDelegation, true);
		var iTemp = oSWbemLocator.Security_.ImpersonationLevel;  // should now be = 3
		iTemp = oSWbemLocator.Security_.AuthenticationLevel;  // should now be = 0
		var oSWbemPrivilege = oSWbemLocator.Security_.Privileges.Item(wbemPrivilegeDebug);  // should now exist and = true
		*/
	
		// var oSWbemServices = GetObject("winmgmts:{impersonationLevel=delegate,authority=kerberos:mydomainb\mydevb}!" + sNspc);
		// var oSWbemServices = oSWbemLocator.ConnectServer("localhost", sNspc);
		var oSWbemServices = oSWbemLocator.ConnectServer(null, sNspc);	
		if (!oSWbemServices) { hr = E_FAIL; throw hr; }

		// obtain reference class object
		var oSWbemRefClass = oSWbemServices.Get(sClass, 0, null);
		if (!oSWbemRefClass) { hr = E_FAIL; throw hr; }

		// spawn a new class derived from the reference class
		var oSWbemInst = oSWbemRefClass.SpawnInstance_(0);
		if (!oSWbemInst) { hr = E_FAIL; throw hr; }

		var oSWbemPropSet = oSWbemInst.Properties_;
		if (!oSWbemPropSet) { hr = E_FAIL; throw hr; }
		
		if (-1 == _DEBUG) debugger;
		var asKeys = new VBArray(daProps.Keys()).toArray();  // get the keys safearray
		for (var iIndex = 0; iIndex < daProps.Count; iIndex++) {
			// get property by name
			var oSWbemProp = oSWbemPropSet.Item(asKeys[iIndex], 0);
			if (!oSWbemProp) { hr = E_FAIL; throw hr; }
	
			if ((2 == _DEBUG) && ("QuerySupportLevels" == asKeys[iIndex])) {
				debugger;
				oSWbemProp.Value = daProps(asKeys[iIndex]);  // original approach
				// note - for this setting above it works when script run outside of msi custom action environment
				// but generates and exception -2147217407/0x80041001 == "Generic Failure" == wbemCli.h WBEM_E_FAILED
				// when run from within msi custom action environment, this may be due to the security context that
				// msi custom actions are run under, but what seems to be the trouble when looking a locals view while
				// debugging script when running as a customAction versus using cscript is that the locals are not
				// being properly initialized on this call.
			}
			else {
				// set default value of property
				oSWbemProp.Value = daProps(asKeys[iIndex]);
			}
		}

		// persist new class
		var oSWbemObjPath = oSWbemInst.Put_();  // | (wbemChangeFlagCreateOrUpdate, null)
		if (!oSWbemObjPath) { hr = E_FAIL; throw hr }
		if (-1 == _DEBUG) { var sTemp = oSWbemObjPath.Path; sTemp = oSWbemObjPath.RelPath; }
	}

	catch(xCptn) {
		if (-1 == _DEBUG) debugger;
		if (isNaN(xCptn)) { var sTemp = xCptn.description; hr = xCptn.number; }	
	}

	if (-1 == _DEBUG) debugger;
	return hr;
}
