/*	see function usage for version and script description */

/*	
	note 1 - cscript caller tested initiation commands
	  cscript //d msiCustomActions.js
	  bad = cscript //d msiCustomActions.js "d:\vssWorkFld\ops\monitoring\gnlPpsEvntCsmr\Product Configuration 1\Release 1\DiskImages\DISK1\AppUseTrkSvc.msi"
	  cscript //d msiCustomActions.js "..\Product Configuration 1\Release 1\DiskImages\DISK1\AppUseTrkSvc.msi"
	  cscript //d msiCustomActions.js "d:\vssWorkFld\ops\monitoring\gnlPpsEvntCsmr\Product Configuration 1\Release 1\DiskImages\DISK1\AppUseTrkSvc.msi" DspSsnPrps 1
	  cscript //d msiCustomActions.js "d:\vssWorkFld\ops\monitoring\gnlPpsEvntCsmr\Product Configuration 1\Release 1\DiskImages\DISK1\AppUseTrkSvc.msi" AddRdmsSettings 1
	  cscript //d msiCustomActions.js "d:\vssWorkFld\ops\monitoring\gnlPpsEvntCsmr\Product Configuration 1\Release 1\DiskImages\DISK1\AppUseTrkSvc.msi" DelRdmsSettings 1
	  cscript //d msiCustomActions.js "d:\vssWorkFld\ops\monitoring\gnlPpsEvntCsmr\Product Configuration 1\Release 1\DiskImages\DISK1\AppUseTrkSvc.msi" AddWebSettings 1
	  cscript //d msiCustomActions.js "d:\vssWorkFld\ops\monitoring\gnlPpsEvntCsmr\Product Configuration 1\Release 1\DiskImages\DISK1\AppUseTrkSvc.msi" DelWebSettings 1
	  cscript //d msiCustomActions.js "d:\vssWorkFld\ops\monitoring\gnlPpsEvntCsmr\Product Configuration 1\Release 1\DiskImages\DISK1\AppUseTrkSvc.msi" AddWmiSettings 1
	  cscript //d msiCustomActions.js "d:\vssWorkFld\ops\monitoring\gnlPpsEvntCsmr\Product Configuration 1\Release 1\DiskImages\DISK1\AppUseTrkSvc.msi" DelWmiSettings 1
	  cscript //d msiCustomActions.js "d:\vssWorkFld\ops\monitoring\gnlPpsEvntCsmr\Product Configuration 1\Release 1\DiskImages\DISK1\AppUseTrkSvc.msi" StartSvcWeb 1
	  cscript //d msiCustomActions.js "d:\vssWorkFld\ops\monitoring\gnlPpsEvntCsmr\Product Configuration 1\Release 1\DiskImages\DISK1\AppUseTrkSvc.msi" StopSvcWeb 1
	  if product is already installed on test system
	    cscript //d msiCustomActions.js "{F0B4195D-58AB-47C2-8A09-1F20EEE84EA4}" AddWmiSettings 1
	    cscript //d msiCustomActions.js "{F0B4195D-58AB-47C2-8A09-1F20EEE84EA4}" DelWmiSettings 1

	type "echo %errorlevel%" at command line afterwards to access script result code

	note 2 = to have interactive debugger run when vbscript "stop" or jscript "debugger;" statements are processed
	  set hkcu\software\microsoft\windows script\JITDebug = 1 (reg_dword), see msdn / search / "PRB: VBScript 'Stop' 
	  Statement Does Not Start Script Debugger" for more details 
*/

var _DEBUG = 0;  // 0 = skip | 1 = stop at hardcoded break points in application

if (1 == _DEBUG) debugger;

var _MSICALLER = 0;  // 0 = script being run by cscript caller, 1 = script being run by msi custom action caller
try {
	if (Session) _MSICALLER = 1;  
	// note - we require a try/catch clause because in the case of a cscript caller Session will be undefined
	// and an exception will be generated = -2146823279, "'Session' is undefined"	
	_DEBUG = parseInt(Session.Property("DEBUG"));
}
catch (xCptn) {  
	if (-1 == _DEBUG) debugger;	
	if (isNaN(xCptn)) { var sTemp = xCptn.description; var hrTemp = xCptn.number; }
}

if (-1 == _DEBUG) debugger;

var S_OK = 0, S_FALSE = 1, E_ABORT = 2147483655, E_FAIL = 2147500037,
	DATE_SEP = "-", TIME_SEP = ":", DATE_TIME_SEP = " ",
	msiDoActionStatusSuccess = 1, msiDoActionStatusFailure = 3,
	wbemNoErr = 0, wbemErrFailed = 0x80041001, wbemErrNotFound = -2147217406 /* 0x80041002 */, 
	wbemErrAccessDenied = 0x80041003, wbemErrInvalidClass = -2147217392 /* 0x80041010 */,
	wbemImpersonationLevelDelegate = 4, wbemImpersonationLevelImpersonate = 3,
	wbemAuthenticationLevelDefault = 0, wbemAuthenticationLevelNone = 1, 
	wbemPrivilegeDebug = 19, wbemPrivilegeIncreaseBasePriority = 13, wbemPrivilegeIncreaseQuota = 4,
	wbemPrivilegePrimaryToken = 2, wbemPrivilegeTakeOwnership = 8, wbemPrivilegeTcb = 6, 
	wbemPrivilegeProfileSingleProcess = 12, wbemPrivilegeCreateToken = 1, wbemPrivilegeEnableDelegation = 26,
	wbemCimtypeSint8 = 16, wbemCimtypeUint8 = 17, wbemCimtypeSint16 = 2, wbemCimtypeUint16 = 18,
	wbemCimtypeSint32 = 3, wbemCimtypeUint32 = 19, wbemCimtypeSint64 = 20, wbemCimtypeUint64 = 21,
	wbemCimtypeReal32 = 4, wbemCimtypeReal64 = 5, wbemCimtypeBoolean = 11, wbemCimtypeString = 8,
	wbemCimtypeDatetime = 101, wbemCimtypeReference = 102, bemCimtypeChar16 = 103, wbemCimtypeObject = 13,
	wbemCimtypeFlagArray = 8192, wbemChangeFlagCreateOrUpdate = 0,
	SQLDMOGrowth_MB = 0, SQLDMOExec_Default = 0, SQLDMOExec_ContinueOnError = 2, SQLDMOKey_Primary = 1;
	// see winerror.h, msi.dll/msidefs.h, wbemdisp.tlb/wbemcli.h, sqldmo.dll/sqldmo.h for more constant values
		
if (-1 == _DEBUG) debugger;

if (!_MSICALLER) {
	var oArgV = WScript.Arguments, iArgC = oArgV.Count();
	if (0 == iArgC) { var hr = usage(); WScript.Quit(1); }

	if (3 == iArgC) _DEBUG = parseInt(oArgV.item(2));

	// note - we cannot prefix Installer, Session or any other msi custom action intrinsic object with the 
	// keyword "var" because if we do it will tromp on the intrinsic objects when present.  This is not a problem
	// since jscript can dynamically create a new variable at runtime even if it wasn't already declared using the
	// "var" prefix
	Installer = new ActiveXObject("WindowsInstaller.Installer");

	if (-1 == _DEBUG) debugger;
	if ("{" == oArgV.item(0).charAt(0)) 
		Session = Installer.OpenProduct(oArgV.item(0));
	else {  // i.e. ":" == oArgV.item(0).charAt(1)
		var oFso = new ActiveXObject("Scripting.FileSystemObject");
		if (!oFso.FileExists(oArgV.item(0))) { var hr = usage(); WScript.Quit(1); }
		oFso = null;
		Session = Installer.OpenPackage(oArgV.item(0));
	}

	if (1 == _DEBUG) debugger;
	// note - for debugging purposes of product set any session properties that you expect to be dynamically populated by an interactive
	// or unattended setup so you can validate that script routines work before being called by msi custom actions.  
	// Entries that have static defaults set in property database are commented out so that default values will be used.
	Session.Property("INSTALLDIR") = Session.Property("ProgramFilesFolder") + "MsftNsp\\AppUseTrkSvc\\";
	// Session.Property("SourceDir") = 
	Session.Property("ROOTDRIVE") = Session.Property("%systemdrive") + "\\";
	// Session.SetInstallLevel(0);  // resets all selected components to whatever the default is for current INSTALLLEVEL
	// Session.SetInstallLevel(50);  // sets INSTALLLEVEL = 50
	Session.Property("RDMSHOST") = Session.Property("ComputerName");
	// Session.Property("RDMSDB") = "dbGnlPpsEvntCsmr";
	// Session.Property("RDMSTBL") = "tblEvents";
	// Session.Property("RDMSRPTSVDIR") = "reports";
	// Session.Property("RDMSUSR") = "sa";
	Session.Property("RDMSPWD") = "sa";
	// Session.Property("RDMSCREDS") = "sql";
	// Session.Property("WMIAPPNSPC") = "root\\cimv2\\msftNsp";
	// Session.Property("WMIAPPNSPC") = "root\\cimv2";
	// Session.Property("WMIAPPCSMR") = "GnlPpsEvntCsmr";
	// Session.Property("WMIAPPCSMRCLSID") = "{745A7B74-DD94-4107-BB68-9703824A66B7}";
	// Session.Property("WMIAPPPVDR") = "GnlPpsEvntPvdr";
	// Session.Property("WMIAPPPVDRCLSID") = "{00000000-0000-0000-0000-000000000000}";
	// Session.Property("WMIAPPSADM") = "cmd.exe cscript.exe kill.exe isql.exe isqlw.exe mmc.exe mofcomp.exe msiexec.exe net.exe netsh.exe pview.exe regedit.exe regedt32.exe robocopy.exe shutdown.exe taskmgr.exe tlist.exe wbemtest.exe wscript.exe xcopy.exe";
	// Session.Property("WMIAPPSADM") = "*";
	// Session.Property("WMIAPPSASP") = "explorer.exe excel.exe iexplore.exe msaccess.exe notepad.exe outlook.exe powerpnt.exe winword.exe";
	Session.Property("WMIAPPSASP") = "*";
	Session.Property("WMIPLNGITVL") = "5";  // default setting is 15 seconds, 5 is better for debugging purposes
}
  
if (-1 == _DEBUG) debugger;

/*  note - moved to DspSsnPrps function
if ((1 == _DEBUG) && Session) {
	// test extraction of various msi session object properties
	var oShell = new ActiveXObject("WScript.Shell"),
			sTemp = "PackageName = " + Session.Property("PackageName") + ", ProductName = " + Session.Property("ProductName") +
			", Installed = " + Session.Property("Installed") + ", ProductState = " + Session.Property("ProductState") + 
			", INSTALLLEVEL = " + Session.Property("INSTALLLEVEL") + ", INSTALLDIR = " + Session.Property("INSTALLDIR") + 
			", TARGETDIR = " + Session.Property("TARGETDIR") + ", SourceDir = " + Session.Property("SourceDir") +
			", WindowsFolder = " + Session.Property("WindowsFolder") + ", SystemFolder = " + Session.Property("SystemFolder") +
			", ROOTDRIVE = " + Session.Property("ROOTDRIVE") + ", SystemDrive environment = " + Session.Property("%systemdrive") +
			", ComputerName = " + Session.Property("ComputerName") + ", ComputerName environment = " + Session.Property("%computername");
			", session _DEBUG " + Session.Property("DEBUG") + ", script _DEBUG = " + _DEBUG.toString();
			if (_MSICALLER) {
				sTemp += ", &AppUseTrkSvc feature action state = " + Session.FeatureRequestState("AppUseTrkSvc") +
				", !AppUseTrkSvc feature installed state = " + Session.FeatureCurrentState("AppUseTrkSvc") +
				", $WmiEvntGnrt component action state = " + Session.ComponentRequestState("WmiEvntGnrt") +
				", ?WmiEvntGnrt component installed state = " + Session.ComponentCurrentState("WmiEvntGnrt") +
				", &CtrlRdmsCfg feature action state = " + Session.FeatureRequestState("CtrlRdmsCfg") +
				", !CtrlRdmsCfg feature installed state = " + Session.FeatureCurrentState("CtrlRdmsCfg") +
				", $DbXmlRpts component action state = " + Session.ComponentRequestState("DbXmlRpts") +
				", ?DbXmlRpts component installed state = " + Session.ComponentCurrentState("DbXmlRpts");
			}
			sTemp += ", WMIAPPNSPC = " + Session.Property("WMIAPPNSPC") + 
			", WMIAPPCSMR = " + Session.Property("WMIAPPCSMR") + ", WMIAPPCSMRCLSID = " + Session.Property("WMIAPPCSMRCLSID") +
			", WMIAPPPVDR = " + Session.Property("WMIAPPPVDR") + ", WMIAPPPVDRCLSID = " + Session.Property("WMIAPPPVDRCLSID") + 
			", WMIAPPPVDREVENT = " + Session.Property("WMIAPPPVDREVENT") + ", WMIPLNGITVL = " + Session.Property("WMIPLNGITVL") + 
			", WMILOGEVENTS = " + Session.Property("WMILOGEVENTS") + ", WMISVCEVENTS = " + Session.Property("WMISVCEVENTS") + 
			", RDMSHOST = " + Session.Property("RDMSHOST") + ", RDMSDB = " + Session.Property("RDMSDB") + 
			", RDMSRPTSVDIR = " + Session.Property("RDMSRPTSVDIR") + ", RDMSDUSR = " + Session.Property("RDMSUSR") + 
			", RDMSPWD = " + Session.Property("RDMSPWD") + ", RDMSCREDS = " + Session.Property("RDMSCREDS");
	oShell.Popup(sTemp, 0, "DebugMessage");
	oShell = null;
}
*/

if (-1 == _DEBUG) debugger;

if (!_MSICALLER) {
	var ir = main(iArgC, oArgV);
	WScript.Quit(ir);
}


function main(iArgC, oArgV) {
	var hr = S_OK;
	try {
		if (-1 == _DEBUG) {
			debugger;
			var oShell = new ActiveXObject("WScript.Shell");
			oShell.Popup("Entering function main", 0, "DebugMessage");
			oShell = null;
		}
		if (!iArgC || !oArgV) { hr = E_FAIL; throw hr; }

		if (-1 == _DEBUG) {
			for (var iIndex = 0; iIndex < iArgC; iIndex++) {
				var vTemp = oArgV.item(iIndex);
				if ("foobar" == vTemp) var bTemp = true;
			}
		}

		if (-1 == _DEBUG) debugger;

		var bFoundFunction = false;

		if ((2 <= iArgC) && ("DspSsnPrps" == oArgV.item(1))) {
			bFoundFunction = true;
			hr = DspSsnPrps();
			if (hr) throw hr;
		}

		if ((2 <= iArgC) && ("AddWmiSettings" == oArgV.item(1))) {
			bFoundFunction = true;
			hr = AddWmiSettings();
			if (hr) throw hr;
		}

		if ((2 <= iArgC) && ("DelWmiSettings" == oArgV.item(1))) {
			bFoundFunction = true;
			hr = DelWmiSettings();
			if (hr) throw hr;
		}

		if ((2 <= iArgC) && ("AddWebSettings" == oArgV.item(1))) {
			bFoundFunction = true;
			hr = AddWebSettings();
			if (hr) throw hr;
		}

		if ((2 <= iArgC) && ("DelWebSettings" == oArgV.item(1))) {
			bFoundFunction = true;
			hr = DelWebSettings();
			if (hr) throw hr;
		}

		if ((2 <= iArgC) && ("AddRdmsSettings" == oArgV.item(1))) {
			bFoundFunction = true;
			hr = AddRdmsSettings();
			if (hr) throw hr;
		}

		if ((2 <= iArgC) && ("DelRdmsSettings" == oArgV.item(1))) {
			bFoundFunction = true;
			hr = DelRdmsSettings();
			if (hr) throw hr;
		}

		if ((2 <= iArgC) && ("StartSvcWmi" == oArgV.item(1))) {
			bFoundFunction = true;
			hr = StartSvcWeb();
			if (hr) throw hr;
		}

		if ((2 <= iArgC) && ("StopSvcWmi" == oArgV.item(1))) {
			bFoundFunction = true;
			hr = StopSvcWeb();
			if (hr) throw hr;
		}

		if ((2 <= iArgC) && ("StartSvcWeb" == oArgV.item(1))) {
			bFoundFunction = true;
			hr = StartSvcWeb();
			if (hr) throw hr;
		}

		if ((2 <= iArgC) && ("StopSvcWeb" == oArgV.item(1))) {
			bFoundFunction = true;
			hr = StopSvcWeb();
			if (hr) throw hr;
		}

		if ((2 <= iArgC) && ("StartSvcRdms" == oArgV.item(1))) {
			bFoundFunction = true;
			hr = StartSvcRdms();
			if (hr) throw hr;
		}

		if ((2 <= iArgC) && ("StopSvcRdms" == oArgV.item(1))) {
			bFoundFunction = true;
			hr = StopSvcRdms();
			if (hr) throw hr;
		}

		if (!bFoundFunction) var hr = usage();
	}

	catch(xCptn) {
		var oShell = new ActiveXObject("WScript.Shell");
		if (isNaN(xCptn) /* or "number" == typeOf(xCptn) */) {
			oShell.Popup("main() exception handler caught an exception with error number " + xCptn.number.toString() + " with description " + xCptn.description + ".", 0, "DebugMessage");
			hr = xCptn.number; 
		}
		else {
			oShell.Popup("main() exception handler caught an exception with error number " + hr.toString(), 0, "DebugMessage");
		}
		oShell = null;
	}

	if (-1 == _DEBUG) {
		debugger;
		var oShell = new ActiveXObject("WScript.Shell");
		oShell.Popup("Leaving function main with result " + hr.toString(), 0, "DebugMessage");
		oShell = null;
	}
	
	return hr;
}


function usage() {
	var hr = S_OK;
	try {
		if (-1 == _DEBUG) debugger;
		WScript.Echo("version = 31jan01\n");
		WScript.Echo("description");
		WScript.Echo("  This script provides support for jscript implemented msi custom actions. When");
		WScript.Echo("  initiated from the command line it enables one to debug, using their default");
		WScript.Echo("  jit debugger, these same msi custom actions before calling them from msi.\n");
		WScript.Echo("usage = msiCustomActions.js <msiFile> <customAction>\n");
		WScript.Echo("where <msiFile> = full path and name of valid msi file to debug");
		WScript.Echo("      <customAction> = name of custom action function to debug");
	}

	catch(xCptn) {
		if (-1 == _DEBUG) debugger;
		if (isNaN(xCptn)) { var sTemp = xCptn.description; hr = xCptn.number; }
	}

	if (-1 == _DEBUG) debugger;
	
	return hr;
}


function DspSsnPrps() {
	var hr = S_OK;
	try {
		if (1 == _DEBUG) {
			debugger;
			var oShell = new ActiveXObject("WScript.Shell");
			oShell.Popup("Entering function DspSsnPrps", 0, "DebugMessage");
			oShell = null;
		}

		if (-1 == _DEBUG)	debugger;

		// TODO: post any addition session property data you would like to display here
		// or just rely on default session properties that will be displayed by global
		// script initialization section

		// test extraction of various msi session object properties
		var oShell = new ActiveXObject("WScript.Shell"),
			sTemp = "PackageName = " + Session.Property("PackageName") + ", ProductName = " + Session.Property("ProductName") +
			", Installed = " + Session.Property("Installed") + ", ProductState = " + Session.Property("ProductState") + 
			", INSTALLLEVEL = " + Session.Property("INSTALLLEVEL") + ", INSTALLDIR = " + Session.Property("INSTALLDIR") + 
			", TARGETDIR = " + Session.Property("TARGETDIR") + ", SourceDir = " + Session.Property("SourceDir") +
			", WindowsFolder = " + Session.Property("WindowsFolder") + ", SystemFolder = " + Session.Property("SystemFolder") +
			", ROOTDRIVE = " + Session.Property("ROOTDRIVE") + ", SystemDrive environment = " + Session.Property("%systemdrive") +
			", ComputerName = " + Session.Property("ComputerName") + ", ComputerName environment = " + Session.Property("%computername");
			", session _DEBUG " + Session.Property("DEBUG") + ", script _DEBUG = " + _DEBUG.toString();
			if (_MSICALLER) {
				sTemp += ", &AppUseTrkSvc feature action state = " + Session.FeatureRequestState("AppUseTrkSvc") +
				", !AppUseTrkSvc feature installed state = " + Session.FeatureCurrentState("AppUseTrkSvc") +
				", $WmiEvntGnrt component action state = " + Session.ComponentRequestState("WmiEvntGnrt") +
				", ?WmiEvntGnrt component installed state = " + Session.ComponentCurrentState("WmiEvntGnrt") +
				", &CtrlRdmsCfg feature action state = " + Session.FeatureRequestState("CtrlRdmsCfg") +
				", !CtrlRdmsCfg feature installed state = " + Session.FeatureCurrentState("CtrlRdmsCfg") +
				", $DbXmlRpts component action state = " + Session.ComponentRequestState("DbXmlRpts") +
				", ?DbXmlRpts component installed state = " + Session.ComponentCurrentState("DbXmlRpts");
			}
			sTemp += ", WMIAPPNSPC = " + Session.Property("WMIAPPNSPC") + 
			", WMIAPPCSMR = " + Session.Property("WMIAPPCSMR") + ", WMIAPPCSMRCLSID = " + Session.Property("WMIAPPCSMRCLSID") +
			", WMIAPPPVDR = " + Session.Property("WMIAPPPVDR") + ", WMIAPPPVDRCLSID = " + Session.Property("WMIAPPPVDRCLSID") + 
			", WMIAPPPVDREVENT = " + Session.Property("WMIAPPPVDREVENT") + ", WMIPLNGITVL = " + Session.Property("WMIPLNGITVL") + 
			", WMILOGEVENTS = " + Session.Property("WMILOGEVENTS") + ", WMISVCEVENTS = " + Session.Property("WMISVCEVENTS") + 
			", RDMSHOST = " + Session.Property("RDMSHOST") + ", RDMSDB = " + Session.Property("RDMSDB") + 
			", RDMSRPTSVDIR = " + Session.Property("RDMSRPTSVDIR") + ", RDMSDUSR = " + Session.Property("RDMSUSR") + 
			", RDMSPWD = " + Session.Property("RDMSPWD") + ", RDMSCREDS = " + Session.Property("RDMSCREDS");
		oShell.Popup(sTemp, 0, "DebugMessage");
		oShell = null;

	}

	catch(xCptn) {
		if (-1 == _DEBUG) debugger;
		if (isNaN(xCptn)) { var sTemp = xCptn.description; hr = xCptn.number; }	
	}

	if (1 == _DEBUG) {
		debugger;
		var oShell = new ActiveXObject("WScript.Shell");
		oShell.Popup("Leaving function DspSsnPrps with result " + hr.toString(), 0, "DebugMessage");
		oShell = null;
	}
	if (!hr)
		return msiDoActionStatusSuccess;
	else
		return msiDoActionStatusFailure;
}


function AddWmiSettings() {
	var hr = S_OK;
	try {
		if (1 == _DEBUG) {
			debugger;
			var oShell = new ActiveXObject("WScript.Shell");
			oShell.Popup("Entering function AddWmiSettings", 0, "DebugMessage");
			oShell = null;
		}

		// pull required msi session object properties
		var sRdmsHost = Session.Property("RDMSHOST"), sRdmsDb = Session.Property("RDMSDB"), 
			sRdmsTbl = Session.Property("RDMSTBL"), sWmiAppNspc = Session.Property("WMIAPPNSPC"),
			sWmiAppCsmr = Session.Property("WMIAPPCSMR"), sWmiAppCsmrClsId = Session.Property("WMIAPPCSMRCLSID"),
			sWmiAppPvdr = Session.Property("WMIAPPPVDR"), sWmiAppPvdrClsId = Session.Property("WMIAPPPVDRCLSID"),
			sWmiAppsAdm = Session.Property("WMIAPPSADM"), sWmiAppsAsp = Session.Property("WMIAPPSASP"),
			sWmiLogEvents = Session.Property("WMILOGEVENTS"), sWmiSvcEvents = Session.Property("WMISVCEVENTS"),
			sWmiPlngItvl = Session.Property("WMIPLNGITVL"), sWmiAppPvdrEvent = Session.Property("WMIAPPPVDREVENT");

		// dictionary elements will have format key = "<cim property name>" and item = "<cim property value>"
		var daProps = new ActiveXObject("Scripting.Dictionary");
		if (!daProps) { hr = E_FAIL; throw hr; }
		var daPropsType = new ActiveXObject("Scripting.Dictionary");
		if (!daPropsType) { hr = E_FAIL; throw hr; }
			
		if (-1 == _DEBUG) debugger;

		// note - currently authored to support non root\cimv2 namespace and subsequent ViewClass for Win32_Process 
		// events only, use of root\cimv2 space works for Win32_Process, Win32_EventLog and Win32_Service which will
		// be forward compatible with whistler installations

		if (("root" != sWmiAppNspc.toLowerCase()) && ("root\\cimv2" != sWmiAppNspc.toLowerCase())) {
		  // add __Namespace instance(s), if other than already existing "root" and "root\\cimv2" namespaces
		    if (-1 == _DEBUG) debugger;
			var sWmiAppNspcParent = sWmiAppNspc.substr(0, sWmiAppNspc.lastIndexOf("\\")),
				sWmiAppNspcSibling = sWmiAppNspc.substr(sWmiAppNspc.lastIndexOf("\\") + 1);
			daProps.Add("Name", sWmiAppNspcSibling);
			hr = AddWmiInst(sWmiAppNspcParent, "__Namespace", daProps);
			if (hr) throw hr;
		}

		if ("root\\cimv2" != sWmiAppNspc.toLowerCase()) {
	  	  // add view class union(s) __Win32Provider instance(s)
			if (-1 == _DEBUG) debugger;
			daProps.RemoveAll();
			daProps.Add("Name", "MS_VIEW_INSTANCE_PROVIDER");
			daProps.Add("CLSID", "{AA70DDF4-E11C-11D1-ABB0-00C04FD9159E}")
			daProps.Add("ImpersonationLevel", 1);
			daProps.Add("PerUserInitialization", "True");
			hr = AddWmiInst(sWmiAppNspc, "__Win32Provider", daProps);
			if (hr) throw hr;

		  // add view class union(s) __InstanceProviderRegistration instance(s)
			if (-1 == _DEBUG) debugger;
			var sTemp = "\\\\.\\" + sWmiAppNspc + ":__Win32Provider.Name=\"MS_VIEW_INSTANCE_PROVIDER\"";
			// e.g. "\\\\.\\root\\cimv2\\msftNsg:__Win32Provider.Name=\"MS_VIEW_INSTANCE_PROVIDER\""
			daProps.RemoveAll();
			daProps.Add("provider", sTemp);
			// daProps.Add("InteractionType", 0);
			daProps.Add("QuerySupportLevels", new Array("WQL:UnarySelect"));
			daProps.Add("SupportsDelete", true);
			daProps.Add("SupportsEnumeration", true);
			daProps.Add("SupportsGet", true);
			daProps.Add("SupportsPut", true);
			hr = AddWmiInst(sWmiAppNspc, "__InstanceProviderRegistration", daProps);
			if (hr) throw hr;

		  // add view class union(s) __MethodProviderRegistration instance(s)
			if (-1 == _DEBUG) debugger;
			sTemp = "\\\\.\\" + sWmiAppNspc + ":__Win32Provider.Name=\"MS_VIEW_INSTANCE_PROVIDER\"";
			// e.g. "\\\\.\\root\\cimv2\\msftNsg:__Win32Provider.Name=\"MS_VIEW_INSTANCE_PROVIDER\""
			daProps.RemoveAll();
			daProps.Add("provider", sTemp);
			hr = AddWmiInst(sWmiAppNspc, "__MethodProviderRegistration", daProps);
			if (hr) throw hr;

		  // add non-derived attributed, aka object qualifiers, view class(es)
			if (-1 == _DEBUG) debugger;
			// note 1 - it is assumed that item 0 is __CLASS value and item 1 requires "key" attribute applied, aka property qualifier
			// note 2 - each property item is assumed to require "PropertySources" attribute applied, aka property qualifier
			var daObjQlfs = new ActiveXObject("Scripting.Dictionary");
			if (!daObjQlfs) { hr = E_FAIL; throw hr; }
			daObjQlfs.Add("union", true);
			if (-1 == _DEBUG) debugger;
			daObjQlfs.Add("ViewSources", new Array("select CreationDate, CSName, ExecutablePath, Handle, Name, ProcessID, TerminationDate from Win32_Process"));
			daObjQlfs.Add("ViewSpaces", new Array("\\\\.\\root\\cimv2"));
			daObjQlfs.Add("dynamic", true);
			daObjQlfs.Add("provider", "MS_VIEW_INSTANCE_PROVIDER");
			daProps.RemoveAll(); daPropsType.RemoveAll();
			daProps.Add("__CLASS", "ViewClassUnionOfRootCimv2Win32Process");  daPropsType.Add("__CLASS", wbemCimtypeString);
			daProps.Add("Handle", "\0");  daPropsType.Add("Handle", wbemCimtypeString);
			daProps.Add("CreationDate", "20010124000000.000000-480");  daPropsType.Add("CreationDate", wbemCimtypeDatetime);
			daProps.Add("CSName", "\0");  daPropsType.Add("CSName", wbemCimtypeString);
			daProps.Add("ExecutablePath", "\0");  daPropsType.Add("ExecutablePath", wbemCimtypeString);
			daProps.Add("Name", "\0");  daPropsType.Add("Name", wbemCimtypeString);
			daProps.Add("ProcessID", 0);  daPropsType.Add("ProcessID", wbemCimtypeUint32);
			daProps.Add("TerminationDate", "20010124000000.000000-480");  daPropsType.Add("TerminationDate", wbemCimtypeDatetime);
			// note 1 - wmi datetime format = yyyymmddHHMMSS.mmmmmmsUUU, ranging from January 1, 1601 onward
			// note 2 - need to pass a valid wmidate time default value for Datetime properties or class creation request will
			// fail.  This doesn't seem to be an issue when creating the class from within a mof file.
			hr = AddWmiViewClass(sWmiAppNspc, null, daObjQlfs, daProps, daPropsType);
			if (hr) throw hr;
		}

	  // add __Win32Provider instance(s)
		if (-1 == _DEBUG) debugger;
		// general purpose event consumer provider from robertob@microsoft.com
		daProps.RemoveAll();
		daProps.Add("Name", "phy" + sWmiAppCsmr);
		daProps.Add("CLSID", sWmiAppCsmrClsId)
		hr = AddWmiInst(sWmiAppNspc, "__Win32Provider", daProps);
		if (hr) throw hr;
		
		if (-1 == _DEBUG) debugger;
		// general purpose event provider from robertob@microsoft.com
		daProps.RemoveAll();
		daProps.Add("Name", "phy" + sWmiAppPvdr);
		daProps.Add("CLSID", sWmiAppPvdrClsId)
		hr = AddWmiInst(sWmiAppNspc, "__Win32Provider", daProps);
		if (hr) throw hr;


	  // add __EventConsumerProviderRegistration instance(s)
	  	if (-1 == _DEBUG) debugger;
		var sTemp = "\\\\.\\" + sWmiAppNspc + ":__Win32Provider.Name=\"phy" + sWmiAppCsmr + "\"";
		// e.g. "\\\\.\\root\\cimv2:__Win32Provider.Name=\"phyGnlPpsEvntCsmr\""
		// or	"\\\\.\\root\\cimv2\\msftNsg:__Win32Provider.Name=\"phyGnlPpsEvntCsmr\""
		daProps.RemoveAll();
		daProps.Add("Provider", sTemp);
		daProps.Add("ConsumerClassNames", new Array("phy" + sWmiAppCsmr));
		hr = AddWmiInst(sWmiAppNspc, "__EventConsumerProviderRegistration", daProps);
		if (hr) throw hr;

	  // add __EventProviderRegistration instance(s)
	  	if (-1 == _DEBUG) debugger;
		var sTemp = "\\\\.\\" + sWmiAppNspc + ":__Win32Provider.Name=\"phy" + sWmiAppPvdr + "\"";
		// e.g. "\\\\.\\root\\cimv2:__Win32Provider.Name=\"phyGnlPpsEvntPvdr\""
		// or	"\\\\.\\root\\cimv2\\msftNsg:__Win32Provider.Name=\"phyGnlPpsEvntPvdr\""
		daProps.RemoveAll();
		daProps.Add("Provider", sTemp);
		daProps.Add("EventQueryList", new Array("select * from GpepEvent"));
		hr = AddWmiInst(sWmiAppNspc, "__EventProviderRegistration", daProps);
		if (hr) throw hr;

	  // add __EventConsumer class(es)
  		if (-1 == _DEBUG) debugger;
		// note - it is assumed that item 0 is __CLASS value and item 1 requires "key" attribute applied, aka property qualifier
		daProps.RemoveAll(); daPropsType.RemoveAll();
		daProps.Add("__CLASS", "phy" + sWmiAppCsmr);  daPropsType.Add("__CLASS", wbemCimtypeString);
		daProps.Add("name", "\0");  daPropsType.Add("name", wbemCimtypeString);
		daProps.Add("description", "\0");  daPropsType.Add("description", wbemCimtypeString);
		daProps.Add("rdmsHost", "\0");  daPropsType.Add("rdmsHost", wbemCimtypeString);
		daProps.Add("rdmsDb", "\0");  daPropsType.Add("rdmsDb", wbemCimtypeString);
		daProps.Add("rdmsTbl", "\0");  daPropsType.Add("rdmsTbl", wbemCimtypeString);
		daProps.Add("cmdLine", "\0");  daPropsType.Add("cmdLine", wbemCimtypeString);
		daProps.Add("showWindow", 0);  daPropsType.Add("showWindow", wbemCimtypeUint16);
		daProps.Add("propsAsArgs", false);  daPropsType.Add("propsAsArgs", wbemCimtypeBoolean);
		daProps.Add("hostnameProp", "\0");  daPropsType.Add("hostnameProp", wbemCimtypeString);
		daProps.Add("createProp", "\0");  daPropsType.Add("createProp", wbemCimtypeString);
		daProps.Add("terminateProp", "\0");  daPropsType.Add("terminateProp", wbemCimtypeString);
		daProps.Add("otherProps", "\0");  daPropsType.Add("otherProps", wbemCimtypeString);
		hr = AddWmiClass(sWmiAppNspc, "__EventConsumer", daProps, daPropsType);
		if (hr) throw hr;

	  // add __ExtrinsicEvent class(es)
		if (-1 == _DEBUG) debugger;
		// note - it is assumed that item 0 is __CLASS value and item 1 requires "key" attribute applied, aka property qualifier
		daProps.RemoveAll(); daPropsType.RemoveAll();
		daProps.Add("__CLASS", sWmiAppPvdrEvent);  daPropsType.Add("__CLASS", wbemCimtypeString);
		daProps.Add("Application", "\0");  daPropsType.Add("Application", wbemCimtypeString);
		daProps.Add("User", "\0");  daPropsType.Add("User", wbemCimtypeString);
		daProps.Add("NumberValue", 0);  daPropsType.Add("NumberValue", wbemCimtypeSint32);
		daProps.Add("StringValue", "\0");  daPropsType.Add("StringValue", wbemCimtypeString);
		daProps.Add("Hostname", "\0");  daPropsType.Add("Hostname", wbemCimtypeString);
		daProps.Add("CreationDate", "20010124000000.000000-480");  daPropsType.Add("CreationDate", wbemCimtypeDatetime);
		daProps.Add("TerminationDate", "20010124000000.000000-480");  daPropsType.Add("TerminationDate", wbemCimtypeDatetime);
		// note 1 - wmi datetime format = yyyymmddHHMMSS.mmmmmmsUUU, ranging from January 1, 1601 onward
		// note 2 - need to pass a valid wmidate time default value for Datetime properties or class creation request will
		// fail.  This doesn't seem to be an issue when creating the class from within a mof file.  This default setting
		// is tied to a manifest constent used to deal with null value dates in the gnlPpsEventPvdr CWuos::IndicateToConsumer
		// method, so if you change this default then you also need to change the constant setting in stdafx.h
		hr = AddWmiClass(sWmiAppNspc, "__ExtrinsicEvent", daProps, daPropsType);
		if (hr) throw hr;

	  // add "phy" + sWmiAppCsmr instance(s)
  		if (-1 == _DEBUG) debugger;
		daProps.RemoveAll();
		daProps.Add("name", "lgcGpecGpepEvent");  // | "lgc" + sWmiAppCsmr);
		daProps.Add("description", "gpepEvent");
		daProps.Add("rdmsHost", sRdmsHost);
		daProps.Add("rdmsDb", sRdmsDb);
		daProps.Add("rdmsTbl", sRdmsTbl);
		daProps.Add("hostnameProp", "Hostname");
		daProps.Add("createProp", "CreationDate");
		daProps.Add("terminateProp", "TerminationDate");
		daProps.Add("otherProps", "NumberValue Application StringValue");
		hr = AddWmiInst(sWmiAppNspc, "phy" + sWmiAppCsmr, daProps);
		if (hr) throw hr;

  		if (-1 == _DEBUG) debugger;
		daProps.RemoveAll();
		daProps.Add("name", "lgcGpecPrcCreateEvent");  // | "lgc" + sWmiAppCsmr);
		daProps.Add("description", "prcCreateEvent");
		daProps.Add("rdmsHost", sRdmsHost);
		daProps.Add("rdmsDb", sRdmsDb);
		daProps.Add("rdmsTbl", sRdmsTbl);
		daProps.Add("hostnameProp", "CSName");
		daProps.Add("createProp", "CreationDate");
		daProps.Add("terminateProp", "\0");
		daProps.Add("otherProps", "ProcessID Name ExecutablePath");
		// note - Name property contains the exe name w/o the path regardless of how the user initiated the process.  The 
		// event targetinstance object properties "Caption", "Description" and "ExecutablePath" also contain the exe name.
		hr = AddWmiInst(sWmiAppNspc, "phy" + sWmiAppCsmr, daProps);
		if (hr) throw hr;

		daProps.RemoveAll();
		daProps.Add("name", "lgcGpecPrcTerminateEvent");  // | "lgc" + sWmiAppCsmr);
		daProps.Add("description", "prcTerminateEvent");
		daProps.Add("rdmsHost", sRdmsHost);
		daProps.Add("rdmsDb", sRdmsDb);
		daProps.Add("rdmsTbl", sRdmsTbl);
		daProps.Add("hostnameProp", "CSName");
		daProps.Add("createProp", "CreationDate");
		daProps.Add("terminateProp", "\0");
		// note - the TerminationDate property does not get populated, CreationDate contains correct datetime when process
		// was created therefore we need to generate the terminateProp value based on the time that the event was received
		daProps.Add("otherProps", "ProcessID Name ExecutablePath")
		hr = AddWmiInst(sWmiAppNspc, "phy" + sWmiAppCsmr, daProps);
		if (hr) throw hr;

		//if ("1" == sWmiLogEvents) {
			daProps.RemoveAll();
			daProps.Add("name", "lgcGpecLogEvent");  // | "lgc" + sWmiAppCsmr);
			daProps.Add("description", "logEvent");
			daProps.Add("rdmsHost", sRdmsHost);
			daProps.Add("rdmsDb", sRdmsDb);
			daProps.Add("rdmsTbl", sRdmsTbl);
			daProps.Add("hostnameProp", "ComputerName");
			daProps.Add("createProp", "TimeGenerated");
			daProps.Add("otherProps", "LogFile SourceName Type Category EventCode Message")
			hr = AddWmiInst(sWmiAppNspc, "phy" + sWmiAppCsmr, daProps);
			if (hr) throw hr;
		//}

		//if ("1" == sWmiSvcEvents) {
			daProps.RemoveAll();
			daProps.Add("name", "lgcGpecSvcEvent");  // | "lgc" + sWmiAppCsmr);
			daProps.Add("description", "svcEvent");
			daProps.Add("rdmsHost", sRdmsHost);
			daProps.Add("rdmsDb", sRdmsDb);
			daProps.Add("rdmsTbl", sRdmsTbl);
			daProps.Add("hostnameProp", "SystemName");
			daProps.Add("otherProps", "Name DisplayName Started State StartMode")
			hr = AddWmiInst(sWmiAppNspc, "phy" + sWmiAppCsmr, daProps);
			if (hr) throw hr;
		//}

	  // add __EventFilter instance(s)
		if (-1 == _DEBUG) debugger;
		daProps.RemoveAll();
		daProps.Add("Name", "fltGpepEvent");
		daProps.Add("QueryLanguage", "wql");
		sTemp = "select * from ";
		sTemp += sWmiAppPvdrEvent;
		daProps.Add("Query", sTemp);
		hr = AddWmiInst(sWmiAppNspc, "__EventFilter", daProps);
		if (hr) throw hr;

	  	if (-1 == _DEBUG) debugger;
		daProps.RemoveAll();
		daProps.Add("Name", "fltPrcCreateEvent");
		daProps.Add("QueryLanguage", "wql");
		if ("root\\cimv2" != sWmiAppNspc.toLowerCase())
			sTemp = "select CreationDate, CSName, ExecutablePath, Name, ProcessID, TargetInstance, TerminationDate from ";
		else
			sTemp = "select * from ";
			// note - select named columns appears to only work against view classes provider and not against native provider
		sTemp += "__InstanceCreationEvent ";
		sTemp += "within " + parseInt(sWmiPlngItvl) + " where TargetInstance isa ";
		if ("root\\cimv2" != sWmiAppNspc.toLowerCase())
			sTemp += "\"ViewClassUnionOfRootCimv2Win32Process\"";
		else
			sTemp += "\"Win32_Process\"";
		// check if wildcard was specified 
		var iAppsAspWldCrdFnd = sWmiAppsAsp.indexOf("*"), iAppsAdmWldCrdFnd = sWmiAppsAdm.indexOf("*"),
			asAppsAsp, asAppsAll;
		if (-1 == _DEBUG) debugger;
		if ((-1 == iAppsAspWldCrdFnd) && (-1 == iAppsAdmWldCrdFnd)) {
			sTemp += " and (";
			asAppsAsp = sWmiAppsAsp.split(" ");
			asAppsAll = asAppsAsp.concat(sWmiAppsAdm.split(" "));  // combine application list
			for (var iIndex = 0; iIndex < asAppsAll.length; iIndex++) {
				sTemp += "TargetInstance.Name = \"" + asAppsAll[iIndex] + "\"";
				if ((iIndex + 1) < asAppsAll.length)
					sTemp += " or ";
				else
					sTemp += ")";
			}
		}
		daProps.Add("Query", sTemp);
		hr = AddWmiInst(sWmiAppNspc, "__EventFilter", daProps);
		if (hr) throw hr;

		daProps.RemoveAll();
		daProps.Add("Name", "fltPrcTerminateEvent");
		daProps.Add("QueryLanguage", "wql");
		if ("root\\cimv2" != sWmiAppNspc.toLowerCase())
			sTemp = "select CreationDate, CSName, ExecutablePath, Name, ProcessID, TargetInstance, TerminationDate from ";
		else
			sTemp = "select * from ";
			// note - select named columns appears to only work against view classes provider and not against native provider
		sTemp += "__InstanceDeletionEvent ";
		sTemp += "within " + parseInt(sWmiPlngItvl) + " where TargetInstance isa ";
		if ("root\\cimv2" != sWmiAppNspc.toLowerCase())
			sTemp += "\"ViewClassUnionOfRootCimv2Win32Process\"";
		else
			sTemp += "\"Win32_Process\"";
		if (-1 == _DEBUG) debugger;
		if ((-1 == iAppsAspWldCrdFnd) && (-1 == iAppsAdmWldCrdFnd)) {
			sTemp += " and (";
			for (var iIndex = 0; iIndex < asAppsAll.length; iIndex++) {
				sTemp += "TargetInstance.Name = \"" + asAppsAll[iIndex] + "\"";
				if ((iIndex + 1) < asAppsAll.length)
					sTemp += " or ";
				else
					sTemp += ")";
			}
		}
		daProps.Add("Query", sTemp);
		hr = AddWmiInst(sWmiAppNspc, "__EventFilter", daProps);
		if (hr) throw hr;

		//if ("1" == sWmiLogEvents) {
			daProps.RemoveAll();
			daProps.Add("Name", "fltLogEvent");
			daProps.Add("QueryLanguage", "wql");
			sTemp = "select * from ";
			sTemp += "__InstanceCreationEvent ";
			sTemp += "where TargetInstance isa \"Win32_NTLogEvent\"";
			daProps.Add("Query", sTemp);
			hr = AddWmiInst(sWmiAppNspc, "__EventFilter", daProps);
			if (hr) throw hr;
		//}

		// if ("1" == sWmiSvcEvents) {
			daProps.RemoveAll();
			daProps.Add("Name", "fltSvcEvent");
			daProps.Add("QueryLanguage", "wql");
			sTemp = "select * from ";
			sTemp += "__InstanceModificationEvent ";
			sTemp += "within " + parseInt(sWmiPlngItvl) + " where TargetInstance isa \"Win32_Service\"";
			daProps.Add("Query", sTemp);
			hr = AddWmiInst(sWmiAppNspc, "__EventFilter", daProps);
			if (hr) throw hr;
		//}

	  // add __FilterToConsumerBinding instance(s)
		if (-1 == _DEBUG) debugger;
		sTemp = "phy" + sWmiAppCsmr + ".Name=\"lgcGpecGpepEvent\"";
		// e.g. "phyGnlPpsEvntCsmr.Name=\"lgcGpecGpepEvent\""
		daProps.RemoveAll();
		daProps.Add("Consumer", sTemp);
		daProps.Add("Filter", "__EventFilter.Name=\"fltGpepEvent\"");
		daProps.Add("DeliverSynchronously", false);
		hr = AddWmiInst(sWmiAppNspc, "__FilterToConsumerBinding", daProps);
		if (hr) throw hr;

	    if (-1 == _DEBUG) debugger;
		sTemp = "phy" + sWmiAppCsmr + ".Name=\"lgcGpecPrcCreateEvent\"";
		// e.g. "phyGnlPpsEvntCsmr.Name=\"lgcGpecPrcCreateEvent\""
		daProps.RemoveAll();
		daProps.Add("Consumer", sTemp);
		daProps.Add("Filter", "__EventFilter.Name=\"fltPrcCreateEvent\"");
		daProps.Add("DeliverSynchronously", false);
		hr = AddWmiInst(sWmiAppNspc, "__FilterToConsumerBinding", daProps);
		if (hr) throw hr;

		sTemp = "phy" + sWmiAppCsmr + ".Name=\"lgcGpecPrcTerminateEvent\"";
		// e.g. "phyGnlPpsEvntCsmr.Name=\"lgcGpecPrcTerminateEvent\""
		daProps.RemoveAll();
		daProps.Add("Consumer", sTemp);
		daProps.Add("Filter", "__EventFilter.Name=\"fltPrcTerminateEvent\"");
		daProps.Add("DeliverSynchronously", false);
		hr = AddWmiInst(sWmiAppNspc, "__FilterToConsumerBinding", daProps);
		if (hr) throw hr;

		if ("1" == sWmiLogEvents) {
			sTemp = "phy" + sWmiAppCsmr + ".Name=\"lgcGpecLogEvent\"";
			// e.g. "phyGnlPpsEvntCsmr.Name=\"lgcGpecLogEvent\""
			daProps.RemoveAll();
			daProps.Add("Consumer", sTemp);
			daProps.Add("Filter", "__EventFilter.Name=\"fltLogEvent\"");
			daProps.Add("DeliverSynchronously", false);
			hr = AddWmiInst(sWmiAppNspc, "__FilterToConsumerBinding", daProps);
			if (hr) throw hr;
		}

		if ("1" == sWmiSvcEvents) {
			sTemp = "phy" + sWmiAppCsmr + ".Name=\"lgcGpecSvcEvent\"";
			// e.g. "phyGnlPpsEvntCsmr.Name=\"lgcGpecSvcEvent\""
			daProps.RemoveAll();
			daProps.Add("Consumer", sTemp);
			daProps.Add("Filter", "__EventFilter.Name=\"fltSvcEvent\"");
			daProps.Add("DeliverSynchronously", false);
			hr = AddWmiInst(sWmiAppNspc, "__FilterToConsumerBinding", daProps);
			if (hr) throw hr;
		}
	}

	catch(xCptn) {
		if (-1 == _DEBUG) debugger;
		if (isNaN(xCptn)) { var sTemp = xCptn.description; hr = xCptn.number; }	
	}

	if (1 == _DEBUG) {
		debugger;
		var oShell = new ActiveXObject("WScript.Shell");
		oShell.Popup("Leaving function AddWmiSettings with result " + hr.toString(), 0, "DebugMessage");
		oShell = null;
	}
	if (!hr)
		return msiDoActionStatusSuccess;
	else
		return msiDoActionStatusFailure;
}


function DelWmiSettings() {
	var hr = S_OK;
	try {
		if (1 == _DEBUG) {
			debugger;
			var oShell = new ActiveXObject("WScript.Shell");
			oShell.Popup("Entering function DelWmiSettings", 0, "DebugMessage");
			oShell = null;
		}

		// pull required msi session object properties
		var sWmiAppNspc = Session.Property("WMIAPPNSPC"),
			sWmiAppCsmr = Session.Property("WMIAPPCSMR"), sWmiAppCsmrClsId = Session.Property("WMIAPPCSMRCLSID"),
			sWmiAppPvdr = Session.Property("WMIAPPPVDR"), sWmiAppPvdrClsId = Session.Property("WMIAPPPVDRCLSID"),
			sWmiLogEvents = Session.Property("WMILOGEVENTS"), sWmiSvcEvents = Session.Property("WMISVCEVENTS"),
			sWmiAppPvdrEvent = Session.Property("WMIAPPPVDREVENT");

		if (("root" != sWmiAppNspc.toLowerCase()) && ("root\\cimv2" != sWmiAppNspc.toLowerCase())) {
		  // del __Namespace instance, which will take everything else with it
			var sWmiAppNspcParent = sWmiAppNspc.substr(0, sWmiAppNspc.lastIndexOf("\\"));
			var sWmiAppNspcSibling = sWmiAppNspc.substr(sWmiAppNspc.lastIndexOf("\\") + 1);
			var sRelPath = "__Namespace.Name=\"" + sWmiAppNspcSibling + "\"";  // e.g. "__Namespace.Name=\"msftNsg\""
			hr = DelWmiInst(sWmiAppNspcParent, sRelPath);
			if (wbemErrNotFound == hr) hr = S_OK;  // object could not be found
			if (hr) throw hr;
		}
		else {
  		  // del __FilterToConsumerBinding instance(s)
		    if (-1 == _DEBUG) debugger;
			if ("1" == sWmiSvcEvents) {
				var sRelPath = "__FilterToConsumerBinding.Consumer=\"phy" + sWmiAppCsmr + ".name=\\\"lgcGpecSvcEvent\\\"\"," +
							   "Filter=\"__EventFilter.Name=\\\"fltSvcEvent\\\"\"";
				// e.g. __FilterToConsumerBinding.Consumer="phyGnlPpsEvntCsmr.name=\"lgcGpecSvcEvent\"",Filter="__EventFilter.Name=\"fltSvcEvent\""
				hr = DelWmiInst(sWmiAppNspc, sRelPath);
				if (wbemErrNotFound == hr) hr = S_OK;  // object could not be found
				if (hr) throw hr;
			}
					
			if ("1" == sWmiLogEvents) {
				sRelPath = "__FilterToConsumerBinding.Consumer=\"phy" + sWmiAppCsmr + ".name=\\\"lgcGpecLogEvent\\\"\"," +
						   "Filter=\"__EventFilter.Name=\\\"fltLogEvent\\\"\"";
				hr = DelWmiInst(sWmiAppNspc, sRelPath);
				if (wbemErrNotFound == hr) hr = S_OK;  // object could not be found
				if (hr) throw hr;
			}

			sRelPath = "__FilterToConsumerBinding.Consumer=\"phy" + sWmiAppCsmr + ".name=\\\"lgcGpecPrcTerminateEvent\\\"\"," +
					   "Filter=\"__EventFilter.Name=\\\"fltPrcTerminateEvent\\\"\"";
			hr = DelWmiInst(sWmiAppNspc, sRelPath);
			if (wbemErrNotFound == hr) hr = S_OK;  // object could not be found
			if (hr) throw hr;

			sRelPath = "__FilterToConsumerBinding.Consumer=\"phy" + sWmiAppCsmr + ".name=\\\"lgcGpecPrcCreateEvent\\\"\"," +
					   "Filter=\"__EventFilter.Name=\\\"fltPrcCreateEvent\\\"\"";
			hr = DelWmiInst(sWmiAppNspc, sRelPath);
			if (wbemErrNotFound == hr) hr = S_OK;  // object could not be found
			if (hr) throw hr;

			sRelPath = "__FilterToConsumerBinding.Consumer=\"phy" + sWmiAppCsmr + ".name=\\\"lgcGpecGpepEvent\\\"\"," +
					   "Filter=\"__EventFilter.Name=\\\"fltGpepEvent\\\"\"";
			hr = DelWmiInst(sWmiAppNspc, sRelPath);
			if (wbemErrNotFound == hr) hr = S_OK;  // object could not be found
			if (hr) throw hr;

  		  // del __EventFilter instance(s)
		    if (-1 == _DEBUG) debugger;
			if ("1" == sWmiSvcEvents) {
				sRelPath = "__EventFilter.Name=\"fltSvcEvent\"";  // e.g. __EventFilter.Name="fltSvcEvent"
				hr = DelWmiInst(sWmiAppNspc, sRelPath);
				if (wbemErrNotFound == hr) hr = S_OK;  // object could not be found
				if (hr) throw hr;
			}
			
			if ("1" == sWmiLogEvents) {			
				sRelPath = "__EventFilter.Name=\"fltLogEvent\"";
				hr = DelWmiInst(sWmiAppNspc, sRelPath);
				if (wbemErrNotFound == hr) hr = S_OK;  // object could not be found
				if (hr) throw hr;
			}

			sRelPath = "__EventFilter.Name=\"fltPrcTerminateEvent\"";
			hr = DelWmiInst(sWmiAppNspc, sRelPath);
			if (wbemErrNotFound == hr) hr = S_OK;  // object could not be found
			if (hr) throw hr;

			sRelPath = "__EventFilter.Name=\"fltPrcCreateEvent\"";
			hr = DelWmiInst(sWmiAppNspc, sRelPath);
			if (wbemErrNotFound == hr) hr = S_OK;  // object could not be found
			if (hr) throw hr;

			sRelPath = "__EventFilter.Name=\"fltGpepEvent\"";
			hr = DelWmiInst(sWmiAppNspc, sRelPath);
			if (wbemErrNotFound == hr) hr = S_OK;  // object could not be found
			if (hr) throw hr;

  	      // del "phy" + sWmiAppCsmr instance(s)
		    if (-1 == _DEBUG) debugger;
			if ("1" == sWmiSvcEvents) {
				sRelPath = "phy" + sWmiAppCsmr + ".name=\"lgcGpecSvcEvent\"";  // e.g. phyGnlPpsEvntCsmr.name="lgcGpecSvcEvent"
				hr = DelWmiInst(sWmiAppNspc, sRelPath);
				if (wbemErrNotFound == hr || wbemErrInvalidClass == hr) hr = S_OK;  // object could not be found
				if (hr) throw hr;
			}
			
			if ("1" == sWmiLogEvents) {		
				sRelPath = "phy" + sWmiAppCsmr + ".name=\"lgcGpecLogEvent\"";  
				hr = DelWmiInst(sWmiAppNspc, sRelPath);
				if (wbemErrNotFound == hr || wbemErrInvalidClass == hr) hr = S_OK;  // object could not be found
				if (hr) throw hr;
			}

			sRelPath = "phy" + sWmiAppCsmr + ".name=\"lgcGpecPrcTerminateEvent\"";  
			hr = DelWmiInst(sWmiAppNspc, sRelPath);
			if (wbemErrNotFound == hr || wbemErrInvalidClass == hr) hr = S_OK;  // object could not be found
			if (hr) throw hr;

			sRelPath = "phy" + sWmiAppCsmr + ".name=\"lgcGpecPrcCreateEvent\"";  
			hr = DelWmiInst(sWmiAppNspc, sRelPath);
			if (wbemErrNotFound == hr || wbemErrInvalidClass == hr) hr = S_OK;  // object could not be found
			if (hr) throw hr;

			sRelPath = "phy" + sWmiAppCsmr + ".name=\"lgcGpecGpepEvent\"";  
			hr = DelWmiInst(sWmiAppNspc, sRelPath);
			if (wbemErrNotFound == hr || wbemErrInvalidClass == hr) hr = S_OK;  // object could not be found
			if (hr) throw hr;

 	      // del __ExtrinsicEvent class(es)
		    if (-1 == _DEBUG) debugger;
			sRelPath = sWmiAppPvdrEvent;  // e.g. GpepEvent
			hr = DelWmiClass(sWmiAppNspc, sRelPath);
			if (wbemErrNotFound == hr) hr = S_OK;  // object could not be found
			if (hr) throw hr;
	
 	      // del __EventConsumer class(es)
		    if (-1 == _DEBUG) debugger;
			sRelPath = "phy" + sWmiAppCsmr;  // e.g. phyGnlPpsEvntCsmr
			hr = DelWmiClass(sWmiAppNspc, sRelPath);
			if (wbemErrNotFound == hr) hr = S_OK;  // object could not be found
			if (hr) throw hr;

 	      // del __EventProviderRegistration instance(s)
		    if (-1 == _DEBUG) debugger;
			// sRelPath = "__EventProviderRegistration.provider=\"\\\\\\\\.\\\\" + sWmiAppNspc + ":__Win32Provider.Name=\\\"phy" + sWmiAppPvdr + "\\\"\"";  
			sRelPath = "__EventProviderRegistration.provider=\"\\\\\\\\.\\\\" + "root\\\\cimv2" + ":__Win32Provider.Name=\\\"phy" + sWmiAppPvdr + "\\\"\"";  
			// e.g. __EventConsumerProviderRegistration.provider="\\\\.\\root\\cimv2:__Win32Provider.Name=\"phyGnlPpsEvntPvdr\""
			hr = DelWmiInst(sWmiAppNspc, sRelPath);
			if (wbemErrNotFound == hr) hr = S_OK;  // object could not be found
			if (hr) throw hr;
				
 	      // del __EventConsumerProviderRegistration instance(s)
		    if (-1 == _DEBUG) debugger;
			// sRelPath = "__EventConsumerProviderRegistration.provider=\"\\\\\\\\.\\\\" + sWmiAppNspc + ":__Win32Provider.Name=\\\"phy" + sWmiAppCsmr + "\\\"\"";  
			sRelPath = "__EventConsumerProviderRegistration.provider=\"\\\\\\\\.\\\\" + "root\\\\cimv2" + ":__Win32Provider.Name=\\\"phy" + sWmiAppCsmr + "\\\"\"";  
			// e.g. __EventConsumerProviderRegistration.provider="\\\\.\\root\\cimv2:__Win32Provider.Name=\"phyGnlPpsEvntCsmr\""
			hr = DelWmiInst(sWmiAppNspc, sRelPath);
			if (wbemErrNotFound == hr) hr = S_OK;  // object could not be found
			if (hr) throw hr;

		  // del __Win32Provider instance(s)
		    if (-1 == _DEBUG) debugger;
			sRelPath = "__Win32Provider.Name=\"phy" + sWmiAppPvdr + "\"";
			// e.g. __Win32Provider.Name="phyGnlPpsEvntPvdr"
			hr = DelWmiInst(sWmiAppNspc, sRelPath);
			if (wbemErrNotFound == hr) hr = S_OK;  // object could not be found
			if (hr) throw hr;

		    if (-1 == _DEBUG) debugger;
			sRelPath = "__Win32Provider.Name=\"phy" + sWmiAppCsmr + "\"";
			// e.g. __Win32Provider.Name="phyGnlPpsEvntCsmr"
			hr = DelWmiInst(sWmiAppNspc, sRelPath);
			if (wbemErrNotFound == hr) hr = S_OK;  // object could not be found
			if (hr) throw hr;
		}
	}

	catch(xCptn) {
		if (-1 == _DEBUG) debugger;
		if (isNaN(xCptn)) { var sTemp = xCptn.description; hr = xCptn.number; }	
	}

	if (1 == _DEBUG) {
		debugger;
		var oShell = new ActiveXObject("WScript.Shell");
		oShell.Popup("Leaving function DelWmiSettings with result " + hr.toString(), 0, "DebugMessage");
		oShell = null;
	}
	if (!hr)
		return msiDoActionStatusSuccess;
	else
		return msiDoActionStatusFailure;
}


function AddWebSettings() {
	var hr = S_OK;
	try {
		if (1 == _DEBUG) {
			debugger;
			var oShell = new ActiveXObject("WScript.Shell");
			oShell.Popup("Entering function AddWebSettings", 0, "DebugMessage");
			oShell = null
		}

		// pull required msi session object properties
		var sRdmsHost = Session.Property("RDMSHOST"), sRdmsRptsVdir = Session.Property("RDMSRPTSVDIR"), 
			sInstallDir = Session.Property("INSTALLDIR"), sWebAppVdir = Session.Property("WEBAPPVDIR"),
			sWebAppInstallDir = sInstallDir + "WebApp";
		
		if (-1 == _DEBUG) debugger;	
		hr = AddWebVdir(sRdmsHost, sRdmsRptsVdir, sInstallDir, false);
		if (-2147024893 == hr) hr = S_OK;  // the webdir already exists
		if (hr) throw hr;

		hr = AddWebVdir(sRdmsHost, sWebAppVdir, sWebAppInstallDir, true);
		if (-2147024893 == hr) hr = S_OK;  // the webdir already exists
		if (hr) throw hr;

		// ensure that "default web site", against which we configured our vdirs, is up and running so that users
		// are not confused by webvdir not being operational right away, state options are start | stop | pause
		if (-1 == _DEBUG) debugger;	
		hr = ChangeWebSrvState(sRdmsHost, ":80:", "Default Web Site", "start");
		if (hr) throw hr;
	}

	catch(xCptn) {
		if (-1 == _DEBUG) debugger;
		if (isNaN(xCptn)) { var sTemp = xCptn.description; hr = xCptn.number; }	
	}

	if (1 == _DEBUG) {
		debugger;
		var oShell = new ActiveXObject("WScript.Shell");
		oShell.Popup("Leaving function AddWebSettings with result " + hr.toString(), 0, "DebugMessage");
		oShell = null;
	}
	if (!hr)
		return msiDoActionStatusSuccess;
	else
		return msiDoActionStatusFailure;
}


function DelWebSettings() {
	var hr = S_OK;
	try {
		if (1 == _DEBUG) {
			debugger;
			var oShell = new ActiveXObject("WScript.Shell");
			oShell.Popup("Entering function DelWebSettings", 0, "DebugMessage");
			oShell = null
		}

		// pull required msi session object properties
		var sRdmsHost = Session.Property("RDMSHOST"), sRdmsRptsVdir = Session.Property("RDMSRPTSVDIR"), 
			sInstallDir = Session.Property("INSTALLDIR"), sWebAppVdir = Session.Property("WEBAPPVDIR"),
			sWebAppInstallDir = sInstallDir + "WebApp";
					
		if (-1 == _DEBUG) debugger;
		hr = DelWebVdir(sRdmsHost, sWebAppVdir);
		if (-2147024893 == hr /* || 2147500037 == hr */) hr = S_OK;  // the webdir doesn't exist
		if (hr) throw hr;

		hr = DelWebVdir(sRdmsHost, sRdmsRptsVdir);
		if (-2147024893 == hr) hr = S_OK;  // the webvdir doesn't exist
		if (hr) throw hr;

		// ensure that "default web site", against which we configured our vdirs, is up and running so that users
		// are not confused by webvdir not being operational right away, state options are start | stop | pause
		if (-1 == _DEBUG) debugger;	
		hr = ChangeWebSrvState(sRdmsHost, ":80:", "Default Web Site", "start");
		if (hr) throw hr;
	}

	catch(xCptn) {
		if (-1 == _DEBUG) debugger;
		if (isNaN(xCptn)) { var sTemp = xCptn.description; hr = xCptn.number; }	
	}

	if (1 == _DEBUG) {
		debugger;
		var oShell = new ActiveXObject("WScript.Shell");
		oShell.Popup("Leaving function DelWebSettings with result " + hr.toString(), 0, "DebugMessage");
		oShell = null;
	}
	if (!hr)
		return msiDoActionStatusSuccess;
	else
		return msiDoActionStatusFailure;
}


function AddRdmsSettings() {
	var hr = S_OK;
	try {
		if (1 == _DEBUG) {
			debugger;
			var oShell = new ActiveXObject("WScript.Shell");
			oShell.Popup("Entering function AddRdmsSettings", 0, "DebugMessage");
			oShell = null
		}
		// pull required msi session object properties
		var sRdmsHost = Session.Property("RDMSHOST"), sRdmsUsr = Session.Property("RDMSUSR"), 
			sRdmsPwd = Session.Property("RDMSPWD"),	sRdmsCreds = Session.Property("RDMSCREDS"),
			sRdmsDb = Session.Property("RDMSDB"), sRdmsTbl = Session.Property("RDMSTBL"),
			sInstallDir = Session.Property("INSTALLDIR");

		hr = AddRdmsDb(sRdmsHost, sRdmsUsr, sRdmsPwd, sRdmsCreds, sRdmsDb)
		if ((E_ABORT == hr) || (-2146823118 == hr)) hr = S_OK;  // the rdmsdb already exists
		if (hr) throw hr;

		if (-1 == _DEBUG) debugger;

		// dictionary elements will have format key = "<column name>" and item = "<column type>"
		var daClms = new ActiveXObject("Scripting.Dictionary");
		if (!daClms) { hr = E_FAIL; throw hr; }

		// dictionary elements will have format key = "<column name>" and item = "<column length, 0 if inappropriate>"
		var daClmsLgth = new ActiveXObject("Scripting.Dictionary");
		if (!daClmsLgth) { hr = E_FAIL; throw hr; }

		// dictionary elements will have format key = "<column name>" and item = "<allow nulls false | true>"
		var daClmsAlwNul = new ActiveXObject("Scripting.Dictionary");
		if (!daClmsAlwNul) { hr = E_FAIL; throw hr; }

		// note - it is assumed that item 0 is an identity column and is the primary key with to be indexed
		// daClms.RemoveAll(); daClmsLgth.RemoveAll(); daClmsAlwNul.RemoveAll();
		daClms.Add("idEvent", "int");  daClmsLgth.Add("idEvent", 4); daClmsAlwNul.Add("idEvent", false);
		daClms.Add("vcHostname", "varchar");  daClmsLgth.Add("vcHostname", 100); daClmsAlwNul.Add("vcHostname", false);
		daClms.Add("vcIpAddress", "varchar");  daClmsLgth.Add("vcIpAddress", 16); daClmsAlwNul.Add("vcIpAddress", false);
		daClms.Add("vcAgent", "varchar");  daClmsLgth.Add("vcAgent", 25); daClmsAlwNul.Add("vcAgent", false);
		daClms.Add("vcName", "varchar");  daClmsLgth.Add("vcName", 25); daClmsAlwNul.Add("vcName", false);
		daClms.Add("vcDescription", "varchar");  daClmsLgth.Add("vcDescription", 100); daClmsAlwNul.Add("vcDescription", false);
		daClms.Add("dtCreate", "datetime");  daClmsLgth.Add("dtCreate", 8); daClmsAlwNul.Add("dtCreate", false);
		daClms.Add("dtTerminate", "datetime");  daClmsLgth.Add("dtTerminate", 8); daClmsAlwNul.Add("dtTerminate", true);
		daClms.Add("iDuration", "int");  daClmsLgth.Add("iDuration", 4); daClmsAlwNul.Add("iDuration", true);
		daClms.Add("vcUser", "varchar");  daClmsLgth.Add("vcUser", 50); daClmsAlwNul.Add("vcUser", true);
		daClms.Add("vcOtherPropA", "varchar");  daClmsLgth.Add("vcOtherPropA", 50); daClmsAlwNul.Add("vcOtherPropA", true);
		daClms.Add("vcOtherPropB", "varchar");  daClmsLgth.Add("vcOtherPropB", 50); daClmsAlwNul.Add("vcOtherPropB", true);
		daClms.Add("vcOtherPropC", "varchar");  daClmsLgth.Add("vcOtherPropC", 75); daClmsAlwNul.Add("vcOtherPropC", true);
		daClms.Add("vcOtherPropD", "varchar");  daClmsLgth.Add("vcOtherPropD", 50); daClmsAlwNul.Add("vcOtherPropD", true);
		daClms.Add("vcOtherPropE", "varchar");  daClmsLgth.Add("vcOtherPropE", 50); daClmsAlwNul.Add("vcOtherPropE", true);
		// daClms.Add("vcOtherPropF", "varchar");  daClmsLgth.Add("vcOtherPropF", 50); daClmsAlwNul.Add("vcOtherPropF", true);
		// TODO: testing the bumping up of this column to varchar 384 to try and accomodate lengthy EventLog 
		// Message/Description property, alternatively could update consumer to check if property is > ## chars and if so
		// truncate so that we know it will always fit into database
		daClms.Add("vcOtherPropF", "varchar");  daClmsLgth.Add("vcOtherPropF", 384); daClmsAlwNul.Add("vcOtherPropF", true);

		if (-1 == _DEBUG) debugger;
		
		hr = AddRdmsTbl(sRdmsHost, sRdmsUsr, sRdmsPwd, sRdmsCreds, sRdmsDb, sRdmsTbl, daClms, daClmsLgth, daClmsAlwNul)
		if ((E_ABORT == hr) || (-2146823118 == hr)) hr = S_OK;  // the rdmstbl already exists
		// -2146807295/0x800A5201 == some column setting is wrong
		// -2146820177/0x800A1FAF == "[Microsoft][ODBC SQL Server Driver][SQL Server]Cannot define PRIMARY KEY 
		// constraint on nullable column in table '<sTbl>'. [Microsoft][ODBC SQL Server Driver][SQL Server]Could not 
		// create constraint. See previous errors."
		if (hr) throw hr;

		if (-1 == _DEBUG) debugger;
		var asTsql = new Array();
		asTsql[0] = "insert tblEvents (vcHostname, vcIpAddress, vcAgent, vcName, vcDescription, dtCreate, vcUser, " +
					"vcOtherPropA, vcOtherPropB, vcOtherPropC) values ('MYDEVB', '4.33.175.45', 'gpec24jan01', " + 
					"'lgcGpecPrcCreateEvent', 'prcCreateEvent', '2000-09-22 08:26:09.471', 'johnd@mydistdom', " +
					"'59884', 'IEXPLORE.EXE', 'C:\\Program Files\\Internet Explorer\\IEXPLORE.EXE')";
		asTsql[1] = "insert tblEvents (vcHostname, vcIpAddress, vcAgent, vcName, vcDescription, dtCreate, dtTerminate, " +
					"iDuration, vcUser, vcOtherPropA, vcOtherPropB, vcOtherPropC) values ('MYDEVA', '4.33.181.83', " +
					"'gpec24jan01', 'lgcGpecPrcTerminateEvent', 'prcTerminateEvent', '2000-09-22 08:25:12.123', " +
					"'2000-09-22 08:30:32.413', '320','eddiem@mydistdom', '58112', 'notepad.exe', " +
					"'C:\\OS\\System32\\notepad.exe')";
		asTsql[2] = "insert tblEvents (vcHostname, vcIpAddress, vcAgent, vcName, vcDescription, dtCreate, dtTerminate, " +
					"iDuration, vcUser, vcOtherPropA, vcOtherPropB, vcOtherPropC) values ('MYDEVB', '4.33.175.45', " +
					"'gpec24jan01', 'lgcGpecPrcCreateEvent', 'prcCreateEvent', '2000-09-22 08:26:09.471', '', '', " +
					"'coryh@mydistdom', '59884', 'IEXPLORE.EXE', 'C:\\Program Files\\Internet Explorer\\IEXPLORE.EXE')";
		asTsql[3] = "insert tblEvents (vcHostname, vcIpAddress, vcAgent, vcName, vcDescription, dtCreate, dtTerminate, " +
					"iDuration, vcUser, vcOtherPropA, vcOtherPropB, vcOtherPropC) values ('MYDEVA', '4.33.181.83', " +
					"'gpec24jan01', 'lgcGpecPrcCreateEvent', 'prcCreateEvent', '2000-09-22 08:26:09.471', '', '', " +
					"'rickyc@mydistdom', '72504', 'WINWORD.EXE', 'C:\\PROGRA~1\\MI1933~1\\Office\\WINWORD.EXE')";
		asTsql[4] = "insert tblEvents (vcHostname, vcIpAddress, vcAgent, vcName, vcDescription, dtCreate, dtTerminate, " +
					"iDuration, vcUser, vcOtherPropA, vcOtherPropB, vcOtherPropC) values ('MYDEVB', '4.33.175.45', " +
					"'gpec24jan01', 'lgcGpecPrcTerminateEvent', 'prcTerminateEvent', '2000-09-22 09:42:38.660', " +
					"'2000-09-22 10:40:10.912', '3459','travisp@mydistdom', '72504', 'mmc.exe', " +
					"'C:\\OS\\System32\\mmc.exe')";
		asTsql[5] = "update tblEvents set vcName = 'lgcGpecPrcTerminateEvent', vcDescription = 'prcTerminateEvent', " +
					"dtTerminate = '2000-09-22 08:36:34.213', iDuration = '625' where  vcOtherPropA = '72504' and " +
					"vcHostname = 'MYDEVA' and iDuration = '0' and vcOtherPropB = 'WINWORD.EXE'";
		hr = ExecRdmsTsql(sRdmsHost, sRdmsUsr, sRdmsPwd, sRdmsCreds, sRdmsDb, asTsql)
		if (hr) throw hr;

		if (-1 == _DEBUG) debugger;
		hr = AddRdmsVdir(sRdmsHost, sRdmsDb, sInstallDir, sRdmsUsr, sRdmsPwd, sRdmsCreds);
		if (-2147024713 == hr) hr = S_OK;  // the rdmsvdir already exists
		if (hr) throw hr;
	}

	catch(xCptn) {
		if (-1 == _DEBUG) debugger;
		if (isNaN(xCptn)) { var sTemp = xCptn.description; hr = xCptn.number; }	
	}

	if (1 == _DEBUG) {
		debugger;
		var oShell = new ActiveXObject("WScript.Shell");
		oShell.Popup("Leaving function AddRdmsSettings with result " + hr.toString(), 0, "DebugMessage");
		oShell = null;
	}
	if (!hr)
		return msiDoActionStatusSuccess;
	else
		return msiDoActionStatusFailure;
}


function DelRdmsSettings() {
	var hr = S_OK;
	try {
		if (1 == _DEBUG) {
			debugger;
			var oShell = new ActiveXObject("WScript.Shell");
			oShell.Popup("Entering function DelRdmsSettings", 0, "DebugMessage");
			oShell = null
		}
		// pull required msi session object properties
		var sRdmsHost = Session.Property("RDMSHOST"), sRdmsUsr = Session.Property("RDMSUSR"), 
			sRdmsPwd = Session.Property("RDMSPWD"),	sRdmsCreds = Session.Property("RDMSCREDS"),
			sRdmsDb = Session.Property("RDMSDB"), sRdmsTbl = Session.Property("RDMSTBL"),
			sInstallDir = Session.Property("INSTALLDIR");

		// for now just delete the entire database since we don't expect tables to be in there
		// but if and when we want to allow for user additions deleting just the table would be
		// the safer thing to do
		/*
		hr = DelRdmsTbl(sRdmsHost, sRdmsUsr, sRdmsPwd, sRdmsCreds, sRdmsDb, sRdmsTbl)
		if (E_ABORT == hr) hr = S_OK;  // the rdmstbl doesn't exist
		// -2146823218/0x800A13CE == "[Microsoft][ODBC SQL Server Driver][SQL Server]Database state cannot be changed 
		// while other users are using the database '<sDb>' [Microsoft][ODBC SQL Server Driver][SQL Server]ALTER 
		// DATABASE statement failed. [Microsoft][ODBC SQL Server Driver][SQL Server]sp_dboption command failed."
		if (hr) throw hr;
		*/

		hr = DelRdmsDb(sRdmsHost, sRdmsUsr, sRdmsPwd, sRdmsCreds, sRdmsDb)
		if (E_ABORT == hr) hr = S_OK;  // the rdmsdb doesn't exist
		// -2146823218/0x800A13CE == "[Microsoft][ODBC SQL Server Driver][SQL Server]Database state cannot be changed 
		// while other users are using the database '<sDb>' [Microsoft][ODBC SQL Server Driver][SQL Server]ALTER 
		// DATABASE statement failed. [Microsoft][ODBC SQL Server Driver][SQL Server]sp_dboption command failed."
		if (-2146823218 == hr) {
			var oShell = new ActiveXObject("WScript.Shell");
			oShell.Popup(sRdmsHost + " rdms database " + sRdmsDb + " state cannot be changed while other users are using the database, please try again later or take server offline and use Sql Enterprise Manager to remove this database", 0, "Information");
			oShell = null;
		}
		if (hr) throw hr;

		if (-1 == _DEBUG) debugger;

		hr = DelRdmsVdir(sRdmsHost, sRdmsDb);
		if (-2147196928 == hr) hr = S_OK;  // the rdmsvdir doesn't exist
		if (hr) throw hr;

		// if sqlvdir services are note 100% cleaning up vdir in iis metabase the following
		// additional call can be used to take care of the left over settings that were missed
		hr = DelWebVdir(sRdmsHost, sRdmsDb);
		if (-2147024893 == hr) hr = S_OK;  // the webvdir doesn't exist
		if (hr) throw hr;
	}

	catch(xCptn) {
		if (-1 == _DEBUG) debugger;
		if (isNaN(xCptn)) { var sTemp = xCptn.description; hr = xCptn.number; }
	}

	if (1 == _DEBUG) {
		debugger;
		var oShell = new ActiveXObject("WScript.Shell");
		oShell.Popup("Leaving function DelRdmsSettings with result " + hr.toString(), 0, "DebugMessage");
		oShell = null;
	}
	if (!hr)
		return msiDoActionStatusSuccess;
	else
		return msiDoActionStatusFailure;
}


function StartSvcWmi() {
	var hr = S_OK;
	try {
		if (1 == _DEBUG) {
			debugger;
			var oShell = new ActiveXObject("WScript.Shell");
			oShell.Popup("Entering function StartSvcWeb", 0, "DebugMessage");
			oShell = null
		}

		// pull required msi session object properties
		var sRdmsHost = Session.Property("RDMSHOST");
			
		hr = WmiSvcCtrl(sRdmsHost, null, null, "winmgmt", true);
		if ((5 == hr) || (2147500037 == hr)) hr = S_OK;  // service already started or stopped
		if (hr) throw hr;
	}

	catch(xCptn) {
		if (-1 == _DEBUG) debugger;
		if (isNaN(xCptn)) { var sTemp = xCptn.description; hr = xCptn.number; }	
	}

	if (1 == _DEBUG) {
		debugger;
		var oShell = new ActiveXObject("WScript.Shell");
		oShell.Popup("Leaving function StartSvcWeb with result " + hr.toString(), 0, "DebugMessage");
		oShell = null;
	}
	if (!hr)
		return msiDoActionStatusSuccess;
	else
		return msiDoActionStatusFailure;
}


function StopSvcWmi() {
	var hr = S_OK;
	try {
		if (1 == _DEBUG) {
			debugger;
			var oShell = new ActiveXObject("WScript.Shell");
			oShell.Popup("Entering function StopSvcWeb", 0, "DebugMessage");
			oShell = null
		}

		// pull required msi session object properties
		var sRdmsHost = Session.Property("RDMSHOST");

		hr = WmiSvcCtrl(sRdmsHost, null, null, "winmgmt", false);
		if ((5 == hr) || (2147500037 == hr)) hr = S_OK;  // service already started or stopped
		if (hr) throw hr;
					
		hr = WmiSvcCtrl(sRdmsHost, null, null, "iisadmin", false);
		if (5 == hr) hr = S_OK;  // service already started or stopped
		if (hr) throw hr;
	}

	catch(xCptn) {
		if (-1 == _DEBUG) debugger;
		if (isNaN(xCptn)) { var sTemp = xCptn.description; hr = xCptn.number; }	
	}

	if (1 == _DEBUG) {
		debugger;
		var oShell = new ActiveXObject("WScript.Shell");
		oShell.Popup("Leaving function StopSvcWeb with result " + hr.toString(), 0, "DebugMessage");
		oShell = null;
	}
	if (!hr)
		return msiDoActionStatusSuccess;
	else
		return msiDoActionStatusFailure;
}


function StartSvcWeb() {
	var hr = S_OK;
	try {
		if (1 == _DEBUG) {
			debugger;
			var oShell = new ActiveXObject("WScript.Shell");
			oShell.Popup("Entering function StartSvcWeb", 0, "DebugMessage");
			oShell = null
		}

		// pull required msi session object properties
		var sRdmsHost = Session.Property("RDMSHOST");
			
		hr = WmiSvcCtrl(sRdmsHost, null, null, "w3svc", true);
		if ((5 == hr) || (2147500037 == hr)) hr = S_OK;  // service already started or stopped
		if (hr) throw hr;
	}

	catch(xCptn) {
		if (-1 == _DEBUG) debugger;
		if (isNaN(xCptn)) { var sTemp = xCptn.description; hr = xCptn.number; }	
	}

	if (1 == _DEBUG) {
		debugger;
		var oShell = new ActiveXObject("WScript.Shell");
		oShell.Popup("Leaving function StartSvcWeb with result " + hr.toString(), 0, "DebugMessage");
		oShell = null;
	}
	if (!hr)
		return msiDoActionStatusSuccess;
	else
		return msiDoActionStatusFailure;
}


function StopSvcWeb() {
	var hr = S_OK;
	try {
		if (1 == _DEBUG) {
			debugger;
			var oShell = new ActiveXObject("WScript.Shell");
			oShell.Popup("Entering function StopSvcWeb", 0, "DebugMessage");
			oShell = null
		}

		// pull required msi session object properties
		var sRdmsHost = Session.Property("RDMSHOST");

		hr = WmiSvcCtrl(sRdmsHost, null, null, "w3svc", false);
		if ((5 == hr) || (2147500037 == hr)) hr = S_OK;  // service already started or stopped
		if (hr) throw hr;
					
		hr = WmiSvcCtrl(sRdmsHost, null, null, "iisadmin", false);
		if (5 == hr) hr = S_OK;  // service already started or stopped
		if (hr) throw hr;
	}

	catch(xCptn) {
		if (-1 == _DEBUG) debugger;
		if (isNaN(xCptn)) { var sTemp = xCptn.description; hr = xCptn.number; }	
	}

	if (1 == _DEBUG) {
		debugger;
		var oShell = new ActiveXObject("WScript.Shell");
		oShell.Popup("Leaving function StopSvcWeb with result " + hr.toString(), 0, "DebugMessage");
		oShell = null;
	}
	if (!hr)
		return msiDoActionStatusSuccess;
	else
		return msiDoActionStatusFailure;
}


function StartSvcRdms() {
	var hr = S_OK;
	try {
		if (1 == _DEBUG) {
			debugger;
			var oShell = new ActiveXObject("WScript.Shell");
			oShell.Popup("Entering function StartSvcRdms", 0, "DebugMessage");
			oShell = null
		}

		// pull required msi session object properties
		var sRdmsHost = Session.Property("RDMSHOST");
			
		hr = WmiSvcCtrl(sRdmsHost, null, null, "mssqlserver", true);
		if ((5 == hr) || (2147500037 == hr)) hr = S_OK;  // service already started or stopped
		if (hr) throw hr;
	}

	catch(xCptn) {
		if (-1 == _DEBUG) debugger;
		if (isNaN(xCptn)) { var sTemp = xCptn.description; hr = xCptn.number; }	
	}

	if (1 == _DEBUG) {
		debugger;
		var oShell = new ActiveXObject("WScript.Shell");
		oShell.Popup("Leaving function StartSvcRdms with result " + hr.toString(), 0, "DebugMessage");
		oShell = null;
	}
	if (!hr)
		return msiDoActionStatusSuccess;
	else
		return msiDoActionStatusFailure;
}


function StopSvcRdms() {
	var hr = S_OK;
	try {
		if (1 == _DEBUG) {
			debugger;
			var oShell = new ActiveXObject("WScript.Shell");
			oShell.Popup("Entering function StopSvcRdms", 0, "DebugMessage");
			oShell = null
		}

		// pull required msi session object properties
		var sRdmsHost = Session.Property("RDMSHOST");

		hr = WmiSvcCtrl(sRdmsHost, null, null, "sqlserveragent", false);
		if (5 == hr) hr = S_OK;  // service already started or stopped
		if (hr) throw hr;
					
		hr = WmiSvcCtrl(sRdmsHost, null, null, "mssqlserver", false);
		if ((5 == hr) || (2147500037 == hr)) hr = S_OK;  // service already started or stopped
		if (hr) throw hr;
	}

	catch(xCptn) {
		if (-1 == _DEBUG) debugger;
		if (isNaN(xCptn)) { var sTemp = xCptn.description; hr = xCptn.number; }	
	}

	if (1 == _DEBUG) {
		debugger;
		var oShell = new ActiveXObject("WScript.Shell");
		oShell.Popup("Leaving function StopSvcRdms with result " + hr.toString(), 0, "DebugMessage");
		oShell = null;
	}
	if (!hr)
		return msiDoActionStatusSuccess;
	else
		return msiDoActionStatusFailure;
}


function StartSvcMsDtc() {
	var hr = S_OK;
	try {
		if (1 == _DEBUG) {
			debugger;
			var oShell = new ActiveXObject("WScript.Shell");
			oShell.Popup("Entering function StartSvcRdms", 0, "DebugMessage");
			oShell = null
		}

		// pull required msi session object properties
		var sRdmsHost = Session.Property("RDMSHOST");
			
		hr = WmiSvcCtrl(sRdmsHost, null, null, "msdtc", true);
		if ((5 == hr) || (2147500037 == hr)) hr = S_OK;  // service already started or stopped
		if (hr) throw hr;
	}

	catch(xCptn) {
		if (-1 == _DEBUG) debugger;
		if (isNaN(xCptn)) { var sTemp = xCptn.description; hr = xCptn.number; }	
	}

	if (1 == _DEBUG) {
		debugger;
		var oShell = new ActiveXObject("WScript.Shell");
		oShell.Popup("Leaving function StartSvcRdms with result " + hr.toString(), 0, "DebugMessage");
		oShell = null;
	}
	if (!hr)
		return msiDoActionStatusSuccess;
	else
		return msiDoActionStatusFailure;
}


function StopSvcMsDtc() {
	var hr = S_OK;
	try {
		if (1 == _DEBUG) {
			debugger;
			var oShell = new ActiveXObject("WScript.Shell");
			oShell.Popup("Entering function StopSvcRdms", 0, "DebugMessage");
			oShell = null
		}

		// pull required msi session object properties
		var sRdmsHost = Session.Property("RDMSHOST");

		hr = WmiSvcCtrl(sRdmsHost, null, null, "sqlserveragent", false);
		if (5 == hr) hr = S_OK;  // service already started or stopped
		if (hr) throw hr;
					
		hr = WmiSvcCtrl(sRdmsHost, null, null, "msdtc", false);
		if ((5 == hr) || (2147500037 == hr)) hr = S_OK;  // service already started or stopped
		if (hr) throw hr;
	}

	catch(xCptn) {
		if (-1 == _DEBUG) debugger;
		if (isNaN(xCptn)) { var sTemp = xCptn.description; hr = xCptn.number; }	
	}

	if (1 == _DEBUG) {
		debugger;
		var oShell = new ActiveXObject("WScript.Shell");
		oShell.Popup("Leaving function StopSvcRdms with result " + hr.toString(), 0, "DebugMessage");
		oShell = null;
	}
	if (!hr)
		return msiDoActionStatusSuccess;
	else
		return msiDoActionStatusFailure;
}


function AddMsiToInstallDir() {
	var hr = S_OK;
	try {
		if (1 == _DEBUG) {
			debugger;
			var oShell = new ActiveXObject("WScript.Shell");
			oShell.Popup("Entering function AddMsiToInstallDir", 0, "DebugMessage");
			oShell = null
		}

		// pull required msi session object properties
		var sSourceDir = Session.Property("SourceDir"), sInstallDir = Session.Property("INSTALLDIR"),
			sInstallerFile = Session.Property("ProductName") + ".msi";

		var	sSourceFile = sSourceDir + sInstallerFile, 
			sDestinationFile = sInstallDir + sInstallerFile;

		var oFso = new ActiveXObject("Scripting.FileSystemObject")
		if (!oFso.FolderExists(sSourceDir) || !oFso.FileExists(sSourceFile) ||
			!oFso.FolderExists(sInstallDir)) { hr = E_FAIL; throw hr }

		oFso.CopyFile(sSourceFile, sDestinationFile, false);
		if (!oFso.FileExists(sDestinationFile)) { hr = E_FAIL; throw hr }
	}

	catch(xCptn) {
		if (-1 == _DEBUG) debugger;
		if (isNaN(xCptn)) { var sTemp = xCptn.description; hr = xCptn.number; }	
	}

	if (1 == _DEBUG) {
		debugger;
		var oShell = new ActiveXObject("WScript.Shell");
		oShell.Popup("Leaving function AddMsiToInstallDir with result " + hr.toString(), 0, "DebugMessage");
		oShell = null;
	}
	if (!hr)
		return msiDoActionStatusSuccess;
	else
		return msiDoActionStatusFailure;
}


function DelMsiFromInstallDir() {
	var hr = S_OK;
	try {
		if (1 == _DEBUG) {
			debugger;
			var oShell = new ActiveXObject("WScript.Shell");
			oShell.Popup("Entering function DelMsiFromInstallDir", 0, "DebugMessage");
			oShell = null
		}

		// pull required msi session object properties
		var sSourceDir = Session.Property("SourceDir"), sInstallDir = Session.Property("INSTALLDIR"),
			sInstallerFile = Session.Property("ProductName") + ".msi";

		var	sSourceFile = sSourceDir + sInstallerFile, 
			sDestinationFile = sInstallDir + sInstallerFile;

		var oFso = new ActiveXObject("Scripting.FileSystemObject")
		// if (!oFso.FolderExists(sSourceDir) || !oFso.FileExists(sSourceFile) ||
		// 	   !oFso.FolderExists(sInstallDir)) { hr = E_FAIL; throw hr }

		// oFso.CopyFile(sSourceFile, sDestinationFile, false);
		if (oFso.FileExists(sDestinationFile))
			oFso.DeleteFile(sDestinationFile, false);  // true = force deletion
	}

	catch(xCptn) {
		if (-1 == _DEBUG) debugger;
		if (isNaN(xCptn)) { var sTemp = xCptn.description; hr = xCptn.number; }	
	}

	if (1 == _DEBUG) {
		debugger;
		var oShell = new ActiveXObject("WScript.Shell");
		oShell.Popup("Leaving function DelMsiFromInstallDir with result " + hr.toString(), 0, "DebugMessage");
		oShell = null;
	}
	if (!hr)
		return msiDoActionStatusSuccess;
	else
		return msiDoActionStatusFailure;
}


function AddWmiViewClass(sNspc, sClass, daObjQlfs, daProps, daPropsType) {
	var hr = S_OK;
	try {
		if (-1 == _DEBUG) debugger;
		if (!sNspc || ("" == sNspc) || /* !sClass || ("" == sClass) || */
			!daObjQlfs || !daObjQlfs.Count || !daProps || !daProps.Count || 
			!daPropsType || !daPropsType.Count || (daProps.Count != daPropsType.Count)) { hr = E_FAIL; throw hr }

		var oSWbemLocator = new ActiveXObject("WbemScripting.SWbemLocator");
		if (!oSWbemLocator) { hr = E_FAIL; throw hr; }

		/*
		if (-1 == _DEBUG) debugger;
		oSWbemLocator.Security_.ImpersonationLevel = wbemImpersonationLevelImpersonate;
		oSWbemLocator.Security_.AuthenticationLevel = wbemAuthenticationLevelDefault;
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeDebug, true);
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeIncreaseBasePriority, true);;
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeIncreaseQuota, true);
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegePrimaryToken, true);
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeTakeOwnership, true);
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeTcb, true);
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeProfileSingleProcess, true);
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeCreateToken, true);
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeEnableDelegation, true);
		var iTemp = oSWbemLocator.Security_.ImpersonationLevel;  // should now be = 3
		iTemp = oSWbemLocator.Security_.AuthenticationLevel;  // should now be = 0
		var oSWbemPrivilege = oSWbemLocator.Security_.Privileges.Item(wbemPrivilegeDebug);  // should now exist and = true
		*/
		
		var oSWbemServices = oSWbemLocator.ConnectServer(null, sNspc);
		if (!oSWbemServices) { hr = E_FAIL; throw hr; }

		if (-1 == _DEBUG) debugger;

		// obtain reference class object
		var oSWbemRefClass = oSWbemServices.Get(sClass, 0, null);
		if (!oSWbemRefClass) { hr = E_FAIL; throw hr; }

		var oSWbemClass;
		if (!sClass) {
			// create a new non-derived class
			oSWbemClass = oSWbemRefClass;  // i.e. oSWbemServices.Get("", 0, null);
			if (!oSWbemClass) { hr = E_FAIL; throw hr; }
		}
		else {
			// spawn a new class derived from the reference class
			oSWbemClass = oSWbemRefClass.SpawnDerivedClass_(0);
			if (!oSWbemClass) { hr = E_FAIL; throw hr; }
		}

		// apply view class attributes, aka object qualifiers
		var oSWbemQlfSet = oSWbemClass.Qualifiers_, oSWbemQlf;
		if (!oSWbemQlfSet) { hr = E_FAIL; throw hr; }
		var asKeys = new VBArray(daObjQlfs.Keys()).toArray();  // get the keys safearray
		for (var iIndex = 0; iIndex < daObjQlfs.Count; iIndex++) {
			if ((2 == _DEBUG) && ("ViewSources" == asKeys[iIndex])) {
				debugger;
				oSWbemQlf = oSWbemQlfSet.Add(asKeys[iIndex], daObjQlfs(asKeys[iIndex]), true, true, true, 0);
				// note - for this setting above it works when script run outside of msi custom action environment
				// but generates and exception -2147217407/0x80041001 == "Generic Failure" == wbemCli.h WBEM_E_FAILED
				// when run from within msi custom action environment, this may be due to the security context that
				// msi custom actions are run under, but what seems to be the trouble when looking a locals view while
				// debugging script when running as a customAction versus using cscript is that the locals are not
				// being properly initialized on this call.
			}
			else {
				oSWbemQlf = oSWbemQlfSet.Add(asKeys[iIndex], daObjQlfs(asKeys[iIndex]), true, true, true, 0);
			}
			if (!oSWbemQlf) { hr = E_FAIL; throw hr; }
		}

		// configure view class properties
		var oSWbemPropSet = oSWbemClass.Properties_;
		if (!oSWbemPropSet) { hr = E_FAIL; throw hr; }
		asKeys = new VBArray(daProps.Keys()).toArray();  // get the keys safearray
		for (var iIndex = 0; iIndex < daProps.Count; iIndex++) {
			if (0 == iIndex) {
				oSWbemClass.Path_.Class = daProps(asKeys[iIndex]);  // i.e. "__CLASS"
				// persist new class
				// var oSWbemObjPath = oSWbemClass.Put_();  // | (wbemChangeFlagCreateOrUpdate, null)
				// if (!oSWbemObjPath) { hr = E_FAIL; throw hr }
			}
			else
			{
				// add new property name and cim type to class definition
				var bArray = false;
				wbemCimtypeFlagArray & daPropsType(asKeys[iIndex]) ? bArray = true : bArray = false;
				var iCimType = 0;  
				wbemCimtypeFlagArray & daPropsType(asKeys[iIndex]) ? iCimType = daPropsType(asKeys[iIndex]) - wbemCimtypeFlagArray : iCimType = daPropsType(asKeys[iIndex]);

				if (-1 == _DEBUG) debugger;
				var oSWbemProp = oSWbemPropSet.Add(asKeys[iIndex], iCimType, bArray, 0);
				if (!oSWbemProp) { hr = E_FAIL; throw hr; }
		
				// set default value for new property
				// oSWbemProp.Value = daProps(asKeys[iIndex]);
	 			
				// apply "PropertySources" attribute, aka property qualifier
				var oSWbemQlfSet = oSWbemProp.Qualifiers_;
				if (!oSWbemQlfSet) { hr = E_FAIL; throw hr; }
				var oSWbemQlf = oSWbemQlfSet.Add("PropertySources", new Array(asKeys[iIndex]), false, false, true, 0);
				if (!oSWbemQlf) { hr = E_FAIL; throw hr; }

				// apply "key" attribute, aka property qualifier
				if (1 == iIndex) {  
					oSWbemQlfSet = oSWbemProp.Qualifiers_;
					oSWbemQlf = oSWbemQlfSet.Add("key", true, true, true, false, 0);
					if (!oSWbemQlf) { hr = E_FAIL; throw hr; }
				}
			}
		}

		if (-1 == _DEBUG) debugger;
	
		// persist new class updates
		var oSWbemObjPath = oSWbemClass.Put_();  // | (wbemChangeFlagCreateOrUpdate, null)
		if (!oSWbemObjPath) { hr = E_FAIL; throw hr }
		if (-1 == _DEBUG) { var sTemp = oSWbemObjPath.Path; sTemp = oSWbemObjPath.RelPath; }
	}

	catch(xCptn) {
		if (-1 == _DEBUG) debugger;
		if (isNaN(xCptn)) { var sTemp = xCptn.description; hr = xCptn.number; }	
	}

	if (-1 == _DEBUG) debugger;
	return hr;
}


function AddWmiClass(sNspc, sClass, daProps, daPropsType) {
	var hr = S_OK;
	try {
		if (-1 == _DEBUG) debugger;
		if (!sNspc || ("" == sNspc) || /* !sClass || ("" == sClass) || */
			!daProps || !daProps.Count || !daPropsType || !daPropsType.Count ||
			(daProps.Count != daPropsType.Count)) { hr = E_FAIL; throw hr }

		var oSWbemLocator = new ActiveXObject("WbemScripting.SWbemLocator");
		if (!oSWbemLocator) { hr = E_FAIL; throw hr; }

		/*
		if (-1 == _DEBUG) debugger;
		oSWbemLocator.Security_.ImpersonationLevel = wbemImpersonationLevelImpersonate;
		oSWbemLocator.Security_.AuthenticationLevel = wbemAuthenticationLevelDefault;
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeDebug, true);
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeIncreaseBasePriority, true);;
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeIncreaseQuota, true);
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegePrimaryToken, true);
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeTakeOwnership, true);
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeTcb, true);
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeProfileSingleProcess, true);
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeCreateToken, true);
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeEnableDelegation, true);
		var iTemp = oSWbemLocator.Security_.ImpersonationLevel;  // should now be = 3
		iTemp = oSWbemLocator.Security_.AuthenticationLevel;  // should now be = 0
		var oSWbemPrivilege = oSWbemLocator.Security_.Privileges.Item(wbemPrivilegeDebug);  // should now exist and = true
		*/

		var oSWbemServices = oSWbemLocator.ConnectServer(null, sNspc);
		if (!oSWbemServices) { hr = E_FAIL; throw hr; }

		// obtain reference class object
		var oSWbemRefClass = oSWbemServices.Get(sClass, 0, null);
		if (!oSWbemRefClass) { hr = E_FAIL; throw hr; }

		var oSWbemClass;
		if (!sClass) {
			// create a new non-derived class
			oSWbemClass = oSWbemRefClass;  // i.e. oSWbemServices.Get("", 0, null);
			if (!oSWbemClass) { hr = E_FAIL; throw hr; }
		}
		else {
			// spawn a new class derived from the reference class
			oSWbemClass = oSWbemRefClass.SpawnDerivedClass_(0);
			if (!oSWbemClass) { hr = E_FAIL; throw hr; }
		}

		var oSWbemPropSet = oSWbemClass.Properties_;
		if (!oSWbemPropSet) { hr = E_FAIL; throw hr; }
		
		var asKeys = new VBArray(daProps.Keys()).toArray();  // get the keys safearray
		for (var iIndex = 0; iIndex < daProps.Count; iIndex++) {
			if (0 == iIndex) {
				oSWbemClass.Path_.Class = daProps(asKeys[iIndex]);  // i.e. "__CLASS"
			}
			else
			{
				// add new property name and cim type to class definition
				var bArray = false;
				wbemCimtypeFlagArray & daPropsType(asKeys[iIndex]) ? bArray = true : bArray = false;
				var iCimType = 0;  
				wbemCimtypeFlagArray & daPropsType(asKeys[iIndex]) ? iCimType = daPropsType(asKeys[iIndex]) - wbemCimtypeFlagArray : iCimType = daPropsType(asKeys[iIndex]);
				var oSWbemProp = oSWbemPropSet.Add(asKeys[iIndex], iCimType, bArray, 0);
				if (!oSWbemProp) { hr = E_FAIL; throw hr; }
		
				// set default value for new property
				oSWbemProp.Value = daProps(asKeys[iIndex]);

				if (1 != iIndex) { 
					// apply "read" attribute, aka property qualifier
					var oSWbemQlfSet = oSWbemProp.Qualifiers_,
						oSWbemQlf = oSWbemQlfSet.Add("read", true, false, false, true, 0);
					if (!oSWbemQlf) { hr = E_FAIL; throw hr; }
				}
				else {  // 1 == iIndex	 			
					// apply "key" attribute, aka property qualifier
					var oSWbemQlfSet = oSWbemProp.Qualifiers_,
						oSWbemQlf = oSWbemQlfSet.Add("key", true, true, true, false, 0);
					if (!oSWbemQlf) { hr = E_FAIL; throw hr; }
				}
			}
		}

		if (-1 == _DEBUG) debugger;
		// persist new class
		var oSWbemObjPath = oSWbemClass.Put_();  // | (wbemChangeFlagCreateOrUpdate, null)
		if (!oSWbemObjPath) { hr = E_FAIL; throw hr }
		if (-1 == _DEBUG) { var sTemp = oSWbemObjPath.Path; sTemp = oSWbemObjPath.RelPath; }
	}

	catch(xCptn) {
		if (-1 == _DEBUG) debugger;
		if (isNaN(xCptn)) { var sTemp = xCptn.description; hr = xCptn.number; }	
	}

	if (-1 == _DEBUG) debugger;
	return hr;
}


function AddWmiInst(sNspc, sClass, daProps) {
	var hr = S_OK;
	try {
		if (2 == _DEBUG) debugger;
		if (!sNspc || ("" == sNspc) || !sClass || ("" == sClass) ||
			!daProps || !daProps.Count) { hr = E_FAIL; throw hr }

		var oSWbemLocator = new ActiveXObject("WbemScripting.SWbemLocator");
		if (!oSWbemLocator) { hr = E_FAIL; throw hr; }

		/*
		if (-1 == _DEBUG) debugger;
		oSWbemLocator.Security_.ImpersonationLevel = wbemImpersonationLevelImpersonate;
		oSWbemLocator.Security_.AuthenticationLevel = wbemAuthenticationLevelDefault;
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeDebug, true);
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeIncreaseBasePriority, true);;
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeIncreaseQuota, true);
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegePrimaryToken, true);
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeTakeOwnership, true);
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeTcb, true);
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeProfileSingleProcess, true);
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeCreateToken, true);
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeEnableDelegation, true);
		var iTemp = oSWbemLocator.Security_.ImpersonationLevel;  // should now be = 3
		iTemp = oSWbemLocator.Security_.AuthenticationLevel;  // should now be = 0
		var oSWbemPrivilege = oSWbemLocator.Security_.Privileges.Item(wbemPrivilegeDebug);  // should now exist and = true
		*/
	
		// var oSWbemServices = GetObject("winmgmts:{impersonationLevel=delegate,authority=kerberos:mydomainb\mydevb}!" + sNspc);
		// var oSWbemServices = oSWbemLocator.ConnectServer("localhost", sNspc);
		var oSWbemServices = oSWbemLocator.ConnectServer(null, sNspc);		
		if (!oSWbemServices) { hr = E_FAIL; throw hr; }
		
		// obtain reference class object
		var oSWbemRefClass = oSWbemServices.Get(sClass, 0, null);
		if (!oSWbemRefClass) { hr = E_FAIL; throw hr; }

		// spawn a new class derived from the reference class
		var oSWbemInst = oSWbemRefClass.SpawnInstance_(0);
		if (!oSWbemInst) { hr = E_FAIL; throw hr; }

		var oSWbemPropSet = oSWbemInst.Properties_;
		if (!oSWbemPropSet) { hr = E_FAIL; throw hr; }
		
		if (-1 == _DEBUG) debugger;
		var asKeys = new VBArray(daProps.Keys()).toArray();  // get the keys safearray
		for (var iIndex = 0; iIndex < daProps.Count; iIndex++) {
			// get property by name
			var oSWbemProp = oSWbemPropSet.Item(asKeys[iIndex], 0);
			if (!oSWbemProp) { hr = E_FAIL; throw hr; }
	
			if ((2 == _DEBUG) && ("QuerySupportLevels" == asKeys[iIndex])) {
				debugger;
				oSWbemProp.Value = daProps(asKeys[iIndex]);  // original approach
				// note - for this setting above it works when script run outside of msi custom action environment
				// but generates and exception -2147217407/0x80041001 == "Generic Failure" == wbemCli.h WBEM_E_FAILED
				// when run from within msi custom action environment, this may be due to the security context that
				// msi custom actions are run under, but what seems to be the trouble when looking a locals view while
				// debugging script when running as a customAction versus using cscript is that the locals are not
				// being properly initialized on this call.
			}
			else {
				// set default value of property
				oSWbemProp.Value = daProps(asKeys[iIndex]);
			}
		}

		// persist new class
		var oSWbemObjPath = oSWbemInst.Put_();  // | (wbemChangeFlagCreateOrUpdate, null)
		if (!oSWbemObjPath) { hr = E_FAIL; throw hr }
		if (-1 == _DEBUG) { var sTemp = oSWbemObjPath.Path; sTemp = oSWbemObjPath.RelPath; }
	}

	catch(xCptn) {
		if (-1 == _DEBUG) debugger;
		if (isNaN(xCptn)) { var sTemp = xCptn.description; hr = xCptn.number; }	
	}

	if (-1 == _DEBUG) debugger;
	return hr;
}


function DelWmiClass(sNspc, sRelPath) {
	var hr = S_OK;
	try {
		if (-1 == _DEBUG) debugger;
		if (!sNspc || ("" == sNspc) || !sRelPath || ("" == sRelPath)) { hr = E_FAIL; throw hr }

		/* note - use of (undefined == sSomeStringVar) or ("undefined" == typeOf(sSomeStringVar)) tests generate
		   exceptions 0x800A1391, "'undefined' is undefined" and 0x800A138F, "Object Expected" respectively */
		
		var oSWbemLocator = new ActiveXObject("WbemScripting.SWbemLocator");
		if (!oSWbemLocator) { hr = E_FAIL; throw hr; }
	
		/*
		if (-1 == _DEBUG) debugger;
		oSWbemLocator.Security_.ImpersonationLevel = wbemImpersonationLevelImpersonate;
		oSWbemLocator.Security_.AuthenticationLevel = wbemAuthenticationLevelDefault;
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeDebug, true);
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeIncreaseBasePriority, true);;
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeIncreaseQuota, true);
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegePrimaryToken, true);
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeTakeOwnership, true);
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeTcb, true);
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeProfileSingleProcess, true);
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeCreateToken, true);
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeEnableDelegation, true);
		var iTemp = oSWbemLocator.Security_.ImpersonationLevel;  // should now be = 3
		iTemp = oSWbemLocator.Security_.AuthenticationLevel;  // should now be = 0
		var oSWbemPrivilege = oSWbemLocator.Security_.Privileges.Item(wbemPrivilegeDebug);  // should now exist and = true
		*/

		var oSWbemServices = oSWbemLocator.ConnectServer(null, sNspc);
		if (!oSWbemServices) { hr = E_FAIL; throw hr; }

		if (-1 == _DEBUG) debugger;
		oSWbemServices.Delete(sRelPath);
	}

	catch(xCptn) {
		if (-1 == _DEBUG) debugger;
		if (isNaN(xCptn)) { var sTemp = xCptn.description; hr = xCptn.number; }	
	}

	if (-1 == _DEBUG) debugger;
	return hr;
}


function DelWmiInst(sNspc, sRelPath) {
	var hr = S_OK;
	try {
		if (2 == _DEBUG) debugger;
		if (!sNspc || ("" == sNspc) || !sRelPath || ("" == sRelPath)) { hr = E_FAIL; throw hr }

		/* note - use of (undefined == sSomeStringVar) or ("undefined" == typeOf(sSomeStringVar)) tests generate
		   exceptions 0x800A1391, "'undefined' is undefined" and 0x800A138F, "Object Expected" respectively */
		
		var oSWbemLocator = new ActiveXObject("WbemScripting.SWbemLocator");
		if (!oSWbemLocator) { hr = E_FAIL; throw hr; }
	
		/*
		if (-1 == _DEBUG) debugger;
		oSWbemLocator.Security_.ImpersonationLevel = wbemImpersonationLevelImpersonate;
		oSWbemLocator.Security_.AuthenticationLevel = wbemAuthenticationLevelDefault;
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeDebug, true);
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeIncreaseBasePriority, true);;
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeIncreaseQuota, true);
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegePrimaryToken, true);
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeTakeOwnership, true);
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeTcb, true);
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeProfileSingleProcess, true);
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeCreateToken, true);
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeEnableDelegation, true);
		var iTemp = oSWbemLocator.Security_.ImpersonationLevel;  // should now be = 3
		iTemp = oSWbemLocator.Security_.AuthenticationLevel;  // should now be = 0
		var oSWbemPrivilege = oSWbemLocator.Security_.Privileges.Item(wbemPrivilegeDebug);  // should now exist and = true
		*/

		var oSWbemServices = oSWbemLocator.ConnectServer(null, sNspc);
		if (!oSWbemServices) { hr = E_FAIL; throw hr; }

		if (-1 == _DEBUG) debugger;
		oSWbemServices.Delete(sRelPath);
	}

	catch(xCptn) {
		if (-1 == _DEBUG) debugger;
		if (isNaN(xCptn)) { var sTemp = xCptn.description; hr = xCptn.number; }	
	}

	if (-1 == _DEBUG) debugger;
	return hr;
}


function GetWebSrvNum(sHost, sServerBinding, sWebSrvName) {
	var hr = S_OK;
	var iWebSrvNum = 0;  // initialize return value
	try {
		if (-1 == _DEBUG) debugger;
		if (!sHost || ("" == sHost) || !sServerBinding || ("" == sServerBinding) ||
			!sWebSrvName || ("" == sWebSrvName)) { hr = E_FAIL; throw hr }

		// optionally flip serverbinding string value into array type used by websrv objects
		// var asServerBindings = new Array(sServerBinding);  // single element array

		var oWebSvc = GetObject("IIS://" + sHost + "/w3svc");
		if (!oWebSvc) { hr = E_FAIL; throw hr; }
		
		// find web server number with matching sServerBinding and WebSrvName
		// note - for the "Default Web Site" the ServerBindings(0) property == "" so you will always
		// find that web site number, which always is 1, using sWebSrvName = "Default Web Site"
		if (-1 == _DEBUG) debugger;
		var caWebSvc = new Enumerator(oWebSvc);  // create enumerator against oWebSvc
		for (  ; !caWebSvc.atEnd() && !iWebSrvNum;  caWebSvc.moveNext()) {  // iterate through enumerator
			var oWebSrv = caWebSvc.item();
			if ("IIsWebServer" == oWebSrv.Class) {
				if ((oWebSrv.ServerBindings(0) == sServerBinding) ||
					(oWebSrv.ServerComment == sWebSrvName)) {
					iWebSrvNum = parseInt(oWebSrv.Name);
					if (-1 == _DEBUG) debugger;
					if (isNaN(iWebSrvNum)) { hr = E_FAIL; throw hr; }
				}
			}
		}
	}

	catch(xCptn) {
		if (1 == _DEBUG) debugger;
		if (isNaN(xCptn)) { var sTemp = xCptn.description; hr = xCptn.number; }	
	}

	if (-1 == _DEBUG) debugger;
	// return hr;
	return iWebSrvNum;
}


function GetNextWebSrvNum(sHost) {
	var hr = S_OK;
	var iWebSrvNum = 0;  // initialize return value
	try {
		if (-1 == _DEBUG) debugger;
		if (!sHost || ("" == sHost)) { hr = E_FAIL; throw hr }

		// optionally flip serverbinding string value into array type used by websrv objects
		// var asServerBindings = new Array(sServerBinding);  // single element array

		var oWebSvc = GetObject("IIS://" + sHost + "/w3svc");
		if (!oWebSvc) { hr = E_FAIL; throw hr; }
		
		// find web server number with matching sServerBinding and WebSrvName
		var caWebSvc = new Enumerator(oWebSvc);  // create enumerator against oWebSvc
		for (  ; !caWebSvc.atEnd();  caWebSvc.moveNext()) {  // iterate through enumerator
			var oWebSrv = caWebSvc.item();
			if ("IIsWebServer" == oWebSrv.Class) {
				var iCrntWebSrvNum = parseInt(oWebSrv.Name);
				if (-1 == _DEBUG) debugger;
				if (isNaN(iCrntWebSrvNum)) { hr = E_FAIL; throw hr; }
				if (iWebSrvNum < iCrntWebSrvNum) iWebSrvNum = iCrntWebSrvNum;
			}
		}

		// increment web server number so we return number one higher than highest one found
		iWebSrvNum++;
	}

	catch(xCptn) {
		if (1 == _DEBUG) debugger;
		if (isNaN(xCptn)) { var sTemp = xCptn.description; hr = xCptn.number; }
		iWebSrvNum = 0;  // reinitialize return value to zero so user can detect an exception	
	}

	if (-1 == _DEBUG) debugger;
	// return hr;
	return iWebSrvNum;
}


function DelWebSrvApp(sHost, sServerBinding, sWebSrvName) {
	var hr = S_OK;
	try {
		if (-1 == _DEBUG) debugger;
		if (!sHost || ("" == sHost) || !sServerBinding || ("" == sServerBinding) ||
			!sWebSrvName || ("" == sWebSrvName) || !sWebVdirName || ("" == sWebVdirName))
			{ hr = E_FAIL; throw hr }

		var oWebSvc = GetObject("IIS://" + sHost + "/w3svc");
		if (!oWebSvc) { hr = E_FAIL; throw hr; }

		if (-1 == _DEBUG) debugger;
		var iWebSrvNum = GetWebSrvNum(sHost, sServerBinding, sWebSrvName)
		if (!iWebSrvNum) { hr = E_FAIL; throw hr; }

		var oWebSrv = oWebSvc.GetObject("IIsWebServer", iWebSrvNum.toString()); 
		if (!oWebSrv) { hr = E_FAIL; throw hr; }

		var oWebRoot = oWebSrv.GetObject("IIsWebVirtualDir", "Root");
		if (!oWebRoot) { hr = E_FAIL; throw hr; }

		if (-1 == _DEBUG) debugger;
		oWebRoot.AppDelete;  // removes application if previously created
		// oWebSrv.FrontPageWeb = false;
		// oWebSrv.SetInfo;  // persist the websrv specific setting just made
		oWebRoot.SetInfo;  // presist root vdir settings
	}

	catch(xCptn) {
		if (1 == _DEBUG) debugger;
		if (isNaN(xCptn)) { var sTemp = xCptn.description; hr = xCptn.number; }	
	}

	if (-1 == _DEBUG) debugger;
	return hr;
}


function DelWebVdirApp(sHost, sServerBinding, sWebSrvName, sWebVdirName) {
	var hr = S_OK;
	try {
		if (-1 == _DEBUG) debugger;
		if (!sHost || ("" == sHost) || !sServerBinding || ("" == sServerBinding) ||
			!sWebSrvName || ("" == sWebSrvName) || !sWebVdirName || ("" == sWebVdirName))
			{ hr = E_FAIL; throw hr }

		var oWebSvc = GetObject("IIS://" + sHost + "/w3svc");
		if (!oWebSvc) { hr = E_FAIL; throw hr; }

		if (-1 == _DEBUG) debugger;
		var iWebSrvNum = 0;
		if ("Default Web Site" != sWebSrvName) {
			iWebSrvNum = GetWebSrvNum(sHost, sServerBinding, sWebSrvName)
			if (!iWebSrvNum) { hr = E_FAIL; throw hr; }
		}
		else
			iWebSrvNum = 1;

		var oWebSrv = oWebSvc.GetObject("IIsWebServer", iWebSrvNum.toString()); 
		if (!oWebSrv) { hr = E_FAIL; throw hr; }

		if (-1 == _DEBUG) debugger;
		var oWebRoot = oWebSrv.GetObject("IIsWebVirtualDir", "Root");
		if (!oWebRoot) { hr = E_FAIL; throw hr; }

		var oWebVdir = oWebRoot.GetObject("IIsWebDirectory", sWebVdirName);
		if (!oWebVdir) { hr = E_FAIL; throw hr; }

		if (-1 == _DEBUG) debugger;
		oWebVdir.AppDelete;  // removes Application if previously created
		// oWebSrv.FrontPageWeb = false;
		// oWebSrv.SetInfo;  // persist the websrv specific setting just made
		oWebVdir.SetInfo;  // presist vdir settings
	}

	catch(xCptn) {
		if (1 == _DEBUG) debugger;
		if (isNaN(xCptn)) { var sTemp = xCptn.description; hr = xCptn.number; }	
	}

	if (-1 == _DEBUG) debugger;
	return hr;
}


function ChangeWebSrvState(sHost, sServerBinding, sWebSrvName, sState) {
	var hr = S_OK;
	try {
		if (-1 == _DEBUG) debugger;
		if (!sHost || ("" == sHost) || !sServerBinding || ("" == sServerBinding) ||
			!sWebSrvName || ("" == sWebSrvName)) { hr = E_FAIL; throw hr }

		// optionally flip serverbinding string value into array type used by websrv objects
		// var asServerBindings = new Array(sServerBinding);  // single element array

		var oWebSvc = GetObject("IIS://" + sHost + "/w3svc");
		if (!oWebSvc) { hr = E_FAIL; throw hr; }
		
		var iWebSrvNum = GetWebSrvNum(sHost, sServerBinding, sWebSrvName)
		if (!iWebSrvNum) { hr = E_FAIL; throw hr; }

		// get websrv object
		var oWebSrv = oWebSvc.GetObject("IIsWebServer", iWebSrvNum.toString());

		// change websrv state to requested status
		if (-1 == _DEBUG) debugger;
		switch (sState.toLowerCase()) {
			case "start":
				oWebSrv.Start();
				break;

			case "stop":
				oWebSrv.Stop();
				break;

			case "pause":
				oWebSrv.Pause();
				break;

			default:
				// do nothing
				break;
		}
	}

	catch(xCptn) {
		if (1 == _DEBUG) debugger;
		if (isNaN(xCptn)) { var sTemp = xCptn.description; hr = xCptn.number; }	
	}

	if (-1 == _DEBUG) debugger;
	return hr;
}


function AddWebSrv(sHost, sServerBinding, sWebSrvName, sPath, bCreateApp) {
	var hr = S_OK;
	try {
		if (-1 == _DEBUG) debugger;
		if (!sHost || ("" == sHost) || !sServerBinding || (":80:" == sServerBinding) ||
			!sWebSrvName || ("" == sWebSrvName) || !sPath || ("" == sPath) ||
			(true != bCreateApp && false != bCreateApp)) { hr = E_FAIL; throw hr }

		// noye - sServerBinding parameter takes format <ipAddress:port:hostHeader>, if user passes ":80:" then this
		// overlaps with the default web site's setting and so we will return a failure since we don't want two websrvs
		// attempting to respond to the same serverbinding

		// check that we are not being asked to create a websrv that already exists
		var iWebSrvNum = GetWebSrvNum(sHost, sServerBinding, sWebSrvName);
		if (iWebSrvNum) { hr = E_FAIL; throw hr; }

		// now get the next available websrv number
		iWebSrvNum = GetNextWebSrvNum(sHost);
		if (!iWebSrvNum) { hr = E_FAIL; throw hr; }

		var oWebSvc = GetObject("IIS://" + sHost + "/w3svc");
		if (!oWebSvc) { hr = E_FAIL; throw hr; }

		/*
		// optionally ensure physical path exists
		var oFso = new ActiveXObject("Scripting.FileSystemObject")
		if (!oFso.FolderExists(sPath)) 
			oFso.CreateFolder(sPath);
		oFso = null;
		*/

		var oWebSrv = oWebSvc.Create("IIsWebServer", iWebSrvNum.toString());
		// note - throws exception -2147024893 if for some reason we goofed and the websrv already exists
		oWebSrv.ServerSize = 1;  // fewer than 100k Or medium sized server
		var asServerBindings = new Array(sServerBinding);  // single element array
		oWebSrv.ServerBindings(0) = asServerBindings(0);
		oWebSrv.ServerComment = sWebSrvName;

		// optionally apply authorization flags overriding inherited settings from parent
		oWebSrv.AuthAnonymous = true;
		// oWebSrv.AuthBasic = true;
		// oWebSrv.AuthNtlm = true;
		oWebSrv.SetInfo
    
		// create root virtual dir on new web server
		var oWebRoot = oWebSrv.Create("IIsWebVirtualDir", "Root");
		if (!oWebRoot) { hr = E_FAIL; throw hr; }

		// set websrv root vdir physical path
		oWebRoot.Path = sPath;
    
		// optionally apply access settings overriding inherited settings from parent
		if (-1 == _DEBUG) debugger;
		oWebRoot.AccessRead = true;
		// oWebRoot.AccessWrite = true;
		// if (bAppCreate) oWebRoot.AccessExecute = true;  // == scripts and executables
		if (bAppCreate) oWebRoot.AccessScript = true;  // == scripts only
		// oWebRoot.AppCreate(true);  // in proc
		if (bAppCreate) oWebRoot.AppCreate(false);  // out of proc
		if (bAppCreate) oWebRoot.AppFriendlyName = sWebSrvName;  // or "Default Application";
		// oWebRoot.AppDelete;  // delete application if previously created
		// oWebRoot.EnableDirBrowsing = true;
		// oWebSrv.FrontPageWeb = true;
		// persist the websrv specific setting just made
		// oWebSrv.SetInfo;
		// oWebRoot.ContentIndexed = true;
		// oWebRoot.DontLog = false;

		// persist settings and we are done
		oWebRoot.SetInfo
         
	}
	catch(xCptn) {
		if (-1 == _DEBUG) debugger;
		if (isNaN(xCptn)) { var sTemp = xCptn.description; hr = xCptn.number; }	
	}

	if (-1 == _DEBUG) debugger;
	return hr;
}


function DelWebSrv(sHost, sServerBinding, sWebSrvName) {
	var hr = S_OK;
	try {
		if (-1 == _DEBUG) debugger;
		if (!sHost || ("" == sHost) || !sServerBinding || ("" == sServerBinding)  || (":80:" == sServerBinding) ||
			!sWebSrvName || ("" == sWebSrvName)) { hr = E_FAIL; throw hr }

		// noye - sServerBinding parameter takes format <ipAddress:port:hostHeader>, if user passes ":80:" then this
		// overlaps with the default web site's setting and so we will return a failure since we don't want two websrvs
		// attempting to respond to the same serverbinding

		// flip serverbinding string value into array type used by websrv objects
		var asServerBindings = new Array(sServerBinding);  // single element array

		// check that we are not being asked to delete a websrv that exists
		// note 1 == iWebSrvNum indicates we were asked to delete the Default Web Site which we will pass on doing
		var iWebSrvNum = GetWebSrvNum(sHost, sServerBinding, sWebSrvName);
		if (0 == iWebSrvNum || 1 == iWebSrvNum) { hr = E_FAIL; throw hr; }

		var oWebSvc = GetObject("IIS://" + sHost + "/w3svc");
		if (!oWebSvc) { hr = E_FAIL; throw hr; }

		// first ensure that we remove websrv app if it exists, so comPlus config doesn't become full of stranded web
		// application configuration settings, using sServerBinding = ":80:" and sWebSrvName = "Default Web Site" will
		// delete the default web site websrv app
		if (-1 == _DEBUG) debugger;
		hr = DelWebSrvApp(sHost, sServerBinding, sWebSrvName);
		if (hr && (-2147024893 != hr) && (-2147463160 != hr)) throw hr;
		// -2147024893 == object not found
		// -2147463160 == object does not have an application defined

		if (-1 == _DEBUG) debugger;
		oWebSvc.Delete("IIsWebServer", iWebSrvNum.toString());
	}
		  
	catch(xCptn) {
		if (-1 == _DEBUG) debugger;
		if (isNaN(xCptn)) { var sTemp = xCptn.description; hr = xCptn.number; }	
	}

	if (-1 == _DEBUG) debugger;
	return hr;
}


function AddWebVdir(sHost, sWebVdir, sPath, bCreateApp) {
	var hr = S_OK;
	try {
		if (-1 == _DEBUG) debugger;
		if (!sHost || ("" == sHost) || !sWebVdir || ("" == sWebVdir) || !sPath || ("" == sPath) ||
			(true != bCreateApp && false != bCreateApp)) { hr = E_FAIL; throw hr }

		var oWebSvc = GetObject("IIS://" + sHost + "/w3svc");
		if (!oWebSvc) { hr = E_FAIL; throw hr; }

		// use WebSrvNum = 1, ServerComment = "Default Web Site", ServerBindings(0) = ":80:", VirtualDir = "Root"
		// see w2ks reskit metaedit for more details
		var oWebSrv = oWebSvc.GetObject("IIsWebServer", "1"); 
		if (!oWebSrv) { hr = E_FAIL; throw hr; }

		var oWebRoot = oWebSrv.GetObject("IIsWebVirtualDir", "Root");
		if (!oWebRoot) { hr = E_FAIL; throw hr; }

		/*
		// optionally ensure physical path exists
		var oFso = new ActiveXObject("Scripting.FileSystemObject")
		if (!oFso.FolderExists(sPath)) 
			oFso.CreateFolder(sPath);
		oFso = null;
		*/

		var oWebVdir = oWebRoot.Create("IIsWebVirtualDir", sWebVdir)
		// note - throws exception -2147024893 if the webvdir already exists
		if (!oWebVdir) { hr = E_FAIL; throw hr; }

		// set vdir physical path
		oWebVdir.Path = sPath

		// optionally apply authorization flags overriding inherited settings from parent
		oWebVdir.AuthAnonymous = true;
		// oWebVdir.AuthBasic = true;
		// oWebVdir.AuthNtlm = true;

		// optionally apply access settings overriding inherited settings from parent
		if (-1 == _DEBUG) debugger;
		oWebVdir.AccessRead = true;
		// oWebVdir.AccessWrite = true;
		// if (bCreateApp) oWebVdir.AccessExecute = true;  // == scripts and executables
		if (bCreateApp) oWebVdir.AccessScript = true;  // == scripts only
		if (bCreateApp) oWebVdir.AppCreate(true);  // in proc
		// if (bCreateApp) oWebVdir.AppCreate(false);	// out of proc
		if (bCreateApp) oWebVdir.AppFriendlyName = sWebVdir;  // or "Default Application";
		// oWebVdir.AppDelete;  // removes Application if previously created
		// oWebVdir.EnableDirBrowsing = true;
		// oWebVdir.ContentIndexed = true;
		// oWebVdir.DontLog = false;

		// persist settings and we are done
		oWebVdir.SetInfo();
	}

	catch(xCptn) {
		if (-1 == _DEBUG) debugger;
		if (isNaN(xCptn)) { var sTemp = xCptn.description; hr = xCptn.number; }	
	}

	if (-1 == _DEBUG) debugger;
	return hr;
}


function DelWebVdir(sHost, sWebVdir) {
	var hr = S_OK;
	try {
		if (-1 == _DEBUG) debugger;
		if (!sHost || ("" == sHost) || !sWebVdir || ("" == sWebVdir)) { hr = E_FAIL; throw hr }

		var oWebSvc = GetObject("IIS://" + sHost + "/w3svc");
		if (!oWebSvc) { hr = E_FAIL; throw hr; }

		// using WebSrvNum = 1, ServerComment = "Default Web Site", ServerBindings(0) = ":80:", VirtualDir = "Root"
		// see w2ks reskit metaedit for more details
		var oWebSrv = oWebSvc.GetObject("IIsWebServer", "1"); 
		if (!oWebSrv) { hr = E_FAIL; throw hr; }

		var oWebRoot = oWebSrv.GetObject("IIsWebVirtualDir", "Root");
		if (!oWebRoot) { hr = E_FAIL; throw hr; }

		if (-1 == _DEBUG) {
			debugger;
			// check to see that it exists
			var oWebVdir = oWebRoot.GetObject("IIsWebDirectory", sWebVdir);
			// note - throws exception -2147024893 if the webvdir doesn't exist
			if (oWebVdir) { hr = E_FAIL; throw hr; }
		}

		// first ensure that we remove webvdir app if it exists, so comPlus config doesn't become full of stranded web
		// application configuration settings, use sServerBinding = ":80:" and sWebSrvName = "Default Web Site" for
		// default web site hosted vdirs
		if (1 == _DEBUG) debugger;
		hr = DelWebVdirApp(sHost, ":80:", "Default Web Site", sWebVdir);
		if (hr && (-2147024893 != hr) && (-2147463160 != hr)) throw hr;
		// -2147024893 == object not found
		// -2147463160 == object does not have an application defined

		oWebRoot.Delete("IIsWebVirtualDir", sWebVdir); 
		// note - throws exception -2147024893 if the webvdir doesn't exist

		if (-1 == _DEBUG) {
			debugger;
			// check to see that it is gone
			oWebVdir = oWebRoot.GetObject("IIsWebDirectory", sWebVdir);
			if (oWebVdir) { hr = E_FAIL; throw hr; }
		}
	}
		  
	catch(xCptn) {
		if (-1 == _DEBUG) debugger;
		if (isNaN(xCptn)) { var sTemp = xCptn.description; hr = xCptn.number; }	
	}

	if (-1 == _DEBUG) debugger;
	return hr;
}


function AddRdmsDb(sHost, sUsr, sPwd, sCreds, sDb) {
	var hr = S_OK;
	try {
		if (-1 == _DEBUG) debugger;
		if (!sHost || ("" == sHost) || !sUsr || ("" == sUsr) || !sPwd || ("" == sPwd) ||
			!sCreds || ("" == sCreds) || !sDb || ("" == sDb)) { hr = E_FAIL; throw hr }
	
		var oSqlSvr = new ActiveXObject("SQLDMO.SQLServer");
		if (!oSqlSvr) { hr = E_FAIL; throw hr; }
		
		// connect to the Server
		oSqlSvr.LoginTimeout = -1;  // -1 is the ODBC default (60) seconds

		if ("sql" == sCreds) {
			oSqlSvr.LoginSecure = false;  // use sql authentication
			oSqlSvr.AutoReConnect = false;  // do not reconnect automatically
			oSqlSvr.Connect(sHost, sUsr, sPwd);
		}
		else  { // "wnd" == sCreds
			oSqlSvr.LoginSecure = true;  // use windows authentication
			oSqlSvr.AutoReConnect = false;  // do not reconnect automatically
			// oSqlSvr.Connect(sHost);
			oSqlSvr.Connect(sHost, sUsr, sPwd);
		}
		
		// check that db doesn't exist
		var iDbId = 0, oDbs = new Enumerator(oSqlSvr.Databases);
		for ( ;!oDbs.atEnd(); oDbs.moveNext()) {
			var oDb = oDbs.item();
			if (!oDb.SystemObject) {
				if (sDb == oDb.Name) {
					if (-1 == _DEBUG) debugger;
					iDbId = oDb.ID;
					hr = E_ABORT;  // | iDbId;
					throw hr;  // duplicate db name already exists
				}
			}
			oDb = null;
		}

		if (-1 == _DEBUG) debugger;

		// define the db
		var oDb = new ActiveXObject("SQLDMO.Database");
		if (!oDb) { hr = E_FAIL; throw hr; }
		oDb.Name = sDb;

		// define the primary data file
		var oPrmyFile = new ActiveXObject("SQLDMO.DBFile");
		if (!oPrmyFile) { hr = E_FAIL; throw hr; }
		oPrmyFile.Name = sDb;
		oPrmyFile.PhysicalName = oSqlSvr.Registry.SQLDataRoot + "\\Data\\" + oPrmyFile.Name + ".mdf";  // physname = <sql>\data>\<prmyFileName>.mdf
		oPrmyFile.PrimaryFile = true;
		// oPrmyFile.Size = 1;  // optionally set initial size in MB
		// specify file growth in chunks of fixed size for all data files
		oPrmyFile.FileGrowthType = SQLDMOGrowth_MB;
		oPrmyFile.FileGrowth = 1;
		// add primary data file to db
		oDb.FileGroups("PRIMARY").DBFiles.Add(oPrmyFile);


		// define the db transaction log file		
		oLogFile = new ActiveXObject("SQLDMO.LogFile");
		if (!oLogFile) { hr = E_FAIL; throw hr; }
		oLogFile.Name = sDb + "Log";
		oLogFile.PhysicalName = oSqlSvr.Registry.SQLDataRoot + "\\Data\\" + oLogFile.Name + ".ldf";  // physname = <sql>\data>\<logFileName>.ldf
		// oLogFile.Size = 1;  // optionally set initial size in MB
		// add transactional log data file to db
		oDb.TransactionLog.LogFiles.Add(oLogFile);

		if (-1 == _DEBUG) debugger;

		// create the db as defined
		oSqlSvr.Databases.Add(oDb);

		// optionally refresh database list if there is any more work to be done
		// oSqlSvr.Databases.Refresh(true);

		// break connection
		oSqlSvr.DisConnect();
	}

	catch(xCptn) {
		if (-1 == _DEBUG) debugger;
		if (isNaN(xCptn)) { var sTemp = xCptn.description; hr = xCptn.number; }	
	}

	if (-1 == _DEBUG) debugger;
	return hr;
}


function DelRdmsDb(sHost, sUsr, sPwd, sCreds, sDb) {
	var hr = S_OK;
	try {
		if (-1 == _DEBUG) debugger;
		if (!sHost || ("" == sHost) || !sUsr || ("" == sUsr) || !sPwd || ("" == sPwd) ||
			!sCreds || ("" == sCreds) || !sDb || ("" == sDb)) { hr = E_FAIL; throw hr }

		var oSqlSvr = new ActiveXObject("SQLDMO.SQLServer");
		if (!oSqlSvr) { hr = E_FAIL; throw hr; }
		
		// connect to the Server
		oSqlSvr.LoginTimeout = -1;  // -1 is the ODBC default (60) seconds

		if ("sql" == sCreds) {
			oSqlSvr.LoginSecure = false;  // use sql authentication
			oSqlSvr.AutoReConnect = false;  // do not reconnect automatically
			oSqlSvr.Connect(sHost, sUsr, sPwd);
		}
		else  { // "wnd" == sCreds
			oSqlSvr.LoginSecure = true;  // use windows authentication
			oSqlSvr.AutoReConnect = false;  // do not reconnect automatically
			// oSqlSvr.Connect(sHost);
			oSqlSvr.Connect(sHost, sUsr, sPwd);
		}

		// check that db exists
		var iDbId = 0, sPrmyFilePath, sPrmyFilePhysicalName, sLogFilePhysicalName,
			oDbs = new Enumerator(oSqlSvr.Databases);
		for ( ;!oDbs.atEnd(); oDbs.moveNext()) {
			var oDb = oDbs.item();
			if (sDb == oDb.Name) {
				if (-1 == _DEBUG) debugger;
				iDbId = oDb.ID;
				sPrmyFilePath = oDb.PrimaryFilePath;
				sPrmyFilePhysicalName = oDb.FileGroups("PRIMARY").DBFiles(1).PhysicalName;
				sLogFilePhysicalName = oDb.TransactionLog.LogFiles(1).PhysicalName;
				break;
			}
			oDb = null;
		}

		if (-1 == _DEBUG) debugger;

		if (!iDbId) { hr = E_ABORT; throw hr; }

		// take database offline so we can delete objects in it without running into contention issues
		// oSqlSvr.Databases.ItemByID(iDbId).DBOption.offline = true;
		oSqlSvr.Databases.Item(sDb).DBOption.offline = true;

		// remote the db
		// oSqlSvr.Databases.Remove(iDbId);  // remove using db id
		oSqlSvr.Databases.Remove(sDb);  // remove using db name

		// optionally refresh database list if there is any more work to be done
		// oSqlSvr.Databases.Refresh(true);

		if (-1 == _DEBUG) debugger;

		// delete primary data and transaction log files which previous remove call does not do
		var oFso = new ActiveXObject("Scripting.FileSystemObject");
		if (!oFso) { hr = E_FAIL; throw hr; }
		oFso.DeleteFile(sPrmyFilePath + sDb + "*.*");
		oFso = null;

		// break connection
		oSqlSvr.DisConnect();
	}

	catch(xCptn) {
		if (-1 == _DEBUG) debugger;
		if (isNaN(xCptn)) { var sTemp = xCptn.description; hr = xCptn.number; }	
	}

	if (-1 == _DEBUG) debugger;
	return hr;
}


function AddRdmsTbl(sHost, sUsr, sPwd, sCreds, sDb, sTbl, daClms, daClmsLgth, daClmsAlwNul) {
	var hr = S_OK;
	try {
		if (-1 == _DEBUG) debugger;
		if (!sHost || ("" == sHost) || !sUsr || ("" == sUsr) || !sPwd || ("" == sPwd) ||
			!sCreds || ("" == sCreds) || !sDb || ("" == sDb) || !sTbl || ("" == sTbl) ||
			!daClms || !daClmsLgth || !daClmsAlwNul || (daClms.Count != daClmsLgth.Count) ||
			(daClms.Count != daClmsAlwNul.Count)) { hr = E_FAIL; throw hr }
	
		var oSqlSvr = new ActiveXObject("SQLDMO.SQLServer");
		if (!oSqlSvr) { hr = E_FAIL; throw hr; }
		
		// connect to the Server
		oSqlSvr.LoginTimeout = -1;  // -1 is the ODBC default (60) seconds

		if ("sql" == sCreds) {
			oSqlSvr.LoginSecure = false;  // use sql authentication
			oSqlSvr.AutoReConnect = false;  // do not reconnect automatically
			oSqlSvr.Connect(sHost, sUsr, sPwd);
		}
		else  { // "wnd" == sCreds
			oSqlSvr.LoginSecure = true;  // use windows authentication
			oSqlSvr.AutoReConnect = false;  // do not reconnect automatically
			// oSqlSvr.Connect(sHost);
			oSqlSvr.Connect(sHost, sUsr, sPwd);
		}
		
		// check that db exists
		var iDbId = 0, sPrmyFilePath, sPrmyFilePhysicalName, sLogFilePhysicalName,
			oDbs = new Enumerator(oSqlSvr.Databases);
		for ( ;!oDbs.atEnd(); oDbs.moveNext()) {
			var oDb = oDbs.item();
			if (sDb == oDb.Name) {
				if (-1 == _DEBUG) debugger;
				iDbId = oDb.ID;
				sPrmyFilePath = oDb.PrimaryFilePath;
				sPrmyFilePhysicalName = oDb.FileGroups("PRIMARY").DBFiles(1).PhysicalName;
				sLogFilePhysicalName = oDb.TransactionLog.LogFiles(1).PhysicalName;
				break;
			}
			oDb = null;
		}

		if (-1 == _DEBUG) debugger;

		if (!iDbId) { hr = E_ABORT; throw hr; }

		if (-1 == _DEBUG) debugger;

		// get the db
		// var oDb = oSqlSvr.Databases(iDbId);
		var oDb = oSqlSvr.Databases(sDb);
		if (!oDb) { hr = E_FAIL; throw hr; }

		if (-1 == _DEBUG) debugger;

		// check that table doesn't exist
		var iTblId = 0, oTbls = new Enumerator(oDb.Tables);
		for ( ;!oTbls.atEnd(); oTbls.moveNext()) {
			var oTbl = oTbls.item();
			if (!oTbl.SystemObject) {
				if (sTbl == oTbl.Name) {
					if (-1 == _DEBUG) debugger;
					iTblId = oTbl.ID;
					hr = E_ABORT;  // | iTblId;
					throw hr;  // duplicate tbl name already exists
				}
			}
			oTbl = null;
		}

		if (-1 == _DEBUG) debugger;

		// create the table object, name it and set desired properties to control eventual table construction
		var oTbl = new ActiveXObject("SQLDMO.Table");
		if (!oTbl) { hr = E_FAIL; throw hr; }
		oTbl.Name = sTbl;
		oTbl.FileGroup = "PRIMARY";

		var asKeys = new VBArray(daClms.Keys()).toArray();    // get the keys safearray
		for (var iIndex = 0; iIndex < daClms.Count; iIndex++) {
			// create the column object(s) and populate table with them
			var oClm = new ActiveXObject("SQLDMO.Column");
			if (!oClm) { hr = E_FAIL; throw hr; }

			oClm.Name = asKeys[iIndex];
			oClm.Datatype = daClms(asKeys[iIndex]);
			if (0 == iIndex) {  // assumes column 0 is an identity column
				if (-1 == _DEBUG) debugger;
				oClm.Identity = true;
				oClm.IdentityIncrement = 1;
				oClm.IdentitySeed = 1;				
			}
			// daClmsLgth(asKeys[iIndex]) ? (oClm.Length = daClmsLgth(asKeys[iIndex])) : /* else do nothing */;
			// use of conditional (ternary) operator above generates a JScript compilation error: Syntax error
			// so we will use an if instead until this the syntax error in the statement can be resolved
			if (daClmsLgth(asKeys[iIndex])) oClm.Length = daClmsLgth(asKeys[iIndex]); 
			oClm.AllowNulls = daClmsAlwNul(asKeys[iIndex]);
			// add the populated column object to the table columns collection
			oTbl.Columns.Add(oClm);
			// if (0 == iIndex)  // assumes column 0 is an identity column
			//	oClm.Identity = false;  // turn off so next column will not be of setup as identity as well
			oClm = null;  // attempts to reuse generate already in collection exceptions
		}

		if (-1 == _DEBUG) debugger;

		// create the table by adding the table object to its containing collection
		oDb.Tables.Add(oTbl);

		if (-1 == _DEBUG) debugger;

		/*
		// now that table is added in a second step create indexes / [primary] keys

		// create the index / [primary] [clustered] key object
		var oKey = new ActiveXObject("SQLDMO.Key");
		if (!oKey) { hr = E_FAIL; throw hr; }
		oKey.Clustered = false;
		oKey.Type = SQLDMOKey_Primary;

		// add the identity columns to the keys names collection
		// var oNames = oKey.KeyColumns
		// oNames.Add(asKeys[1]);
		oKey.KeyColumns.Add(asKeys[1]);  // i.e. vcHostname column

		// mark start of change unit
		oTbl.BeginAlter();

		// add the populated key object to the keys collection of the table object
		oTbl.Keys.Add(oKey);
		
		// create the indexe / [primary] key constraint by committing the unit of change
		oTbl.DoAlter();
		*/

		// optionally refresh database list if there is any more work to be done
		// oSqlSvr.Databases.Refresh(true);

		// break connection
		oSqlSvr.DisConnect();
	}

	catch(xCptn) {
		if (-1 == _DEBUG) debugger;
		if (isNaN(xCptn)) { var sTemp = xCptn.description; hr = xCptn.number; }	
	}

	if (-1 == _DEBUG) debugger;
	return hr;
}


function DelRdmsTbl(sHost, sUsr, sPwd, sCreds, sDb, sTbl) {
	var hr = S_OK;
	try {
		if (-1 == _DEBUG) debugger;
		if (!sHost || ("" == sHost) || !sUsr || ("" == sUsr) || !sPwd || ("" == sPwd) ||
			!sCreds || ("" == sCreds) || !sDb || ("" == sDb) || !sTbl || ("" == sTbl)) { hr = E_FAIL; throw hr }

		var oSqlSvr = new ActiveXObject("SQLDMO.SQLServer");
		if (!oSqlSvr) { hr = E_FAIL; throw hr; }
		
		// connect to the Server
		oSqlSvr.LoginTimeout = -1;  // -1 is the ODBC default (60) seconds

		if ("sql" == sCreds) {
			oSqlSvr.LoginSecure = false;  // use sql authentication
			oSqlSvr.AutoReConnect = false;  // do not reconnect automatically
			oSqlSvr.Connect(sHost, sUsr, sPwd);
		}
		else  { // "wnd" == sCreds
			oSqlSvr.LoginSecure = true;  // use windows authentication
			oSqlSvr.AutoReConnect = false;  // do not reconnect automatically
			// oSqlSvr.Connect(sHost);
			oSqlSvr.Connect(sHost, sUsr, sPwd);
		}

		// check that db exists
		var iDbId = 0, sPrmyFilePath, sPrmyFilePhysicalName, sLogFilePhysicalName,
			oDbs = new Enumerator(oSqlSvr.Databases);
		for ( ;!oDbs.atEnd(); oDbs.moveNext()) {
			var oDb = oDbs.item();
			if (sDb == oDb.Name) {
				if (-1 == _DEBUG) debugger;
				iDbId = oDb.ID;
				sPrmyFilePath = oDb.PrimaryFilePath;
				sPrmyFilePhysicalName = oDb.FileGroups("PRIMARY").DBFiles(1).PhysicalName;
				sLogFilePhysicalName = oDb.TransactionLog.LogFiles(1).PhysicalName;
				break;
			}
			oDb = null;
		}

		if (-1 == _DEBUG) debugger;

		if (!iDbId) { hr = E_ABORT; throw hr; }

		if (-1 == _DEBUG) debugger;

		// get the db
		// var oDb = oSqlSvr.Databases(iDbId);
		var oDb = oSqlSvr.Databases(sDb);
		if (!oDb) { hr = E_FAIL; throw hr; }

		if (-1 == _DEBUG) debugger;

		// check that tbl exists
		var iTblId = 0, oTbls = new Enumerator(oDb.Tables);
		for ( ;!oTbls.atEnd(); oTbls.moveNext()) {
			var oTbl = oTbl.item();
			if (sTbl == oTbl.Name) {
				if (-1 == _DEBUG) debugger;
				iTblId = oTbl.ID;
				break;
			}
			oDb = null;
		}

		if (-1 == _DEBUG) debugger;

		if (!iTblId) { hr = E_ABORT; throw hr; }

		if (-1 == _DEBUG) debugger;

		// take database offline so we can delete objects in it without running into contention issues
		// oSqlSvr.Databases.ItemByID(iDbId).DBOption.offline = true;
		oSqlSvr.Databases.Item(sDb).DBOption.offline = true;

		// remote the table
		// oDb.Tables.Remove(iTblId);  // remove using tbl id
		oDb.Tables.Remove(sTbl);  // remove using tbl name

		// optionally refresh tables list if there is any more work to be done
		// oDb.Tables.Refresh(true);

		if (-1 == _DEBUG) debugger;

		// bring database back online 
		// oSqlSvr.Databases.ItemByID(iDbId).DBOption.offline = false;
		oSqlSvr.Databases.Item(sDb).DBOption.offline = false;

		// break connection
		oSqlSvr.DisConnect();
	}

	catch(xCptn) {
		if (-1 == _DEBUG) debugger;
		if (isNaN(xCptn)) { var sTemp = xCptn.description; hr = xCptn.number; }	
	}

	if (-1 == _DEBUG) debugger;
	return hr;
}


function ExecRdmsTsql(sHost, sUsr, sPwd, sCreds, sDb, asTsql) {
	var hr = S_OK;
	try {
		if (-1 == _DEBUG) debugger;
		if (!sHost || ("" == sHost) || !sUsr || ("" == sUsr) || !sPwd || ("" == sPwd) ||
			!sCreds || ("" == sCreds) || !sDb || ("" == sDb) || !asTsql || (0 == asTsql.length)) { hr = E_FAIL; throw hr }

		var oSqlSvr = new ActiveXObject("SQLDMO.SQLServer");
		if (!oSqlSvr) { hr = E_FAIL; throw hr; }
		
		// connect to the Server
		oSqlSvr.LoginTimeout = -1;  // -1 is the ODBC default (60) seconds

		if ("sql" == sCreds) {
			oSqlSvr.LoginSecure = false;  // use sql authentication
			oSqlSvr.AutoReConnect = false;  // do not reconnect automatically
			oSqlSvr.Connect(sHost, sUsr, sPwd);
		}
		else  { // "wnd" == sCreds
			oSqlSvr.LoginSecure = true;  // use windows authentication
			oSqlSvr.AutoReConnect = false;  // do not reconnect automatically
			// oSqlSvr.Connect(sHost);
			oSqlSvr.Connect(sHost, sUsr, sPwd);
		}

		// check that db exists
		var iDbId = 0, sPrmyFilePath, sPrmyFilePhysicalName, sLogFilePhysicalName,
			oDbs = new Enumerator(oSqlSvr.Databases);
		for ( ;!oDbs.atEnd(); oDbs.moveNext()) {
			var oDb = oDbs.item();
			if (sDb == oDb.Name) {
				if (-1 == _DEBUG) debugger;
				iDbId = oDb.ID;
				sPrmyFilePath = oDb.PrimaryFilePath;
				sPrmyFilePhysicalName = oDb.FileGroups("PRIMARY").DBFiles(1).PhysicalName;
				sLogFilePhysicalName = oDb.TransactionLog.LogFiles(1).PhysicalName;
				break;
			}
			oDb = null;
		}

		if (-1 == _DEBUG) debugger;

		if (!iDbId) { hr = E_ABORT; throw hr; }

		if (-1 == _DEBUG) debugger;

		// get the db
		// var oDb = oSqlSvr.Databases(iDbId);
		var oDb = oSqlSvr.Databases(sDb);
		if (!oDb) { hr = E_FAIL; throw hr; }

		if (-1 == _DEBUG) debugger;

		for (var iIndex = 0; iIndex < asTsql.length; iIndex++) {
			oDb.ExecuteImmediate(asTsql[iIndex], SQLDMOExec_ContinueOnError, asTsql[iIndex].length);
		}

		if (-1 == _DEBUG) debugger;

		// break connection
		oSqlSvr.DisConnect();
	}

	catch(xCptn) {
		if (-1 == _DEBUG) debugger;
		if (isNaN(xCptn)) { var sTemp = xCptn.description; hr = xCptn.number; }	
	}

	if (-1 == _DEBUG) debugger;
	return hr;
}


function AddRdmsVdir(sHost, sSqlVdir, sPath, sUsr, sPwd, sCreds) {
	var hr = S_OK;
	try {
		if (-1 == _DEBUG) debugger;
		if (!sHost || ("" == sHost) || !sSqlVdir || ("" == sSqlVdir) || !sPath || ("" == sPath) ||
			!sUsr || ("" == sUsr) || !sPwd || ("" == sPwd) || !sCreds || ("" == sCreds)) { hr = E_FAIL; throw hr }
	
		var oSqlVdirCtrl = new ActiveXObject("SQLVDir.SQLVDirControl");
		if (!oSqlVdirCtrl) { hr = E_FAIL; throw hr; }

		// using WebSrvNum = 1, ServerComment = "Default Web Site", ServerBindings(0) = ":80:", VirtualDir = "Root"
		oSqlVdirCtrl.Connect(sHost, "1");
		// if (hr) throw hr;

		var oSqlVdirs = oSqlVdirCtrl.SQLVDirs;
		if (!oSqlVdirs) { hr = E_FAIL; throw hr };

		var oSqlVdir = oSqlVdirs.AddVirtualDirectory(sSqlVdir);
		// note - throws exception -2147024713 if the sqlvdir already exists
		if (!oSqlVdir) { hr = E_FAIL; throw hr };

		oSqlVdir.PhysicalPath = sPath;
		oSqlVdir.UserName = sUsr;
		oSqlVdir.Password = sPwd;
		if (-1 == _DEBUG) debugger;
		oSqlVdir.SecurityMode = 1;   // 1 == sql, 2 = windows;
		// if (2 == oSqlVdir.SecurityMode)  oSqlVdir.EnablePasswordSync = 1;  // 0 = disabled, 1 = enabled ???
		oSqlVdir.ServerName = sHost;
		oSqlVdir.DatabaseName = sSqlVdir;  // assume that we call vdir same name as database it exposes
		// var iAllowFlags = afURL_QUERIES | afTEMPLATES | afXPATH | afPOST;  // | afDONTCACHESCHEMAS;
		var iAllowFlags = 1 | 8 | 64 | 128;  // | 256;
		oSqlVdir.AllowFlags = iAllowFlags;  // note - set AllowFlags = 0 to temporarly disables sqlvdir
		var oSqlVdirNames = oSqlVdir.VirtualNames;
		if (!oSqlVdirNames) { hr = E_FAIL; throw hr };

		var oSqlVdirName = oSqlVdirNames.AddVirtualName("schema", 2, sPath)
		if (!oSqlVdirName) { hr = E_FAIL; throw hr };
		oSqlVdirName = null;  // ??? maybe not

		oSqlVdirName = oSqlVdirNames.AddVirtualName("template", 4, sPath)
		if (!oSqlVdirName) { hr = E_FAIL; throw hr };
		oSqlVdirName = null;  // ??? maybe not

		oSqlVdirCtrl.Disconnect();
		// if (hr) throw hr;
	}

	catch(xCptn) {
		if (-1 == _DEBUG) debugger;
		if (isNaN(xCptn)) { var sTemp = xCptn.description; hr = xCptn.number; }	
	}

	if (-1 == _DEBUG) debugger;
	return hr;
}


function DelRdmsVdir(sHost, sSqlVdir) {
	var hr = S_OK;
	try {
		if (-1 == _DEBUG) debugger;
		if (!sHost || ("" == sHost) || !sSqlVdir || ("" == sSqlVdir)) { hr = E_FAIL; throw hr }
	
		var oSqlVdirCtrl = new ActiveXObject("SQLVDir.SQLVDirControl");
		if (!oSqlVdirCtrl) { hr = E_FAIL; throw hr; }

		// using WebSrvNum = 1, ServerComment = "Default Web Site", ServerBindings(0) = ":80:", VirtualDir = "Root"
		oSqlVdirCtrl.Connect(sHost, "1");
		// if (hr) throw hr;

		var oSqlVdirs = oSqlVdirCtrl.SQLVDirs;
		if (!oSqlVdirs) { hr = E_FAIL; throw hr };

		oSqlVdirs.RemoveVirtualDirectory(sSqlVdir);
		// note - throws exception -2147196928 if the sqlvdir doesn't exist
		// if (hr) throw hr;

		oSqlVdirCtrl.Disconnect();
		// if (hr) throw hr;
	}

	catch(xCptn) {
		if (-1 == _DEBUG) debugger;
		if (isNaN(xCptn)) { var sTemp = xCptn.description; hr = xCptn.number; }	
	}

	if (-1 == _DEBUG) debugger;
	return hr;
}


function WmiSvcCtrl(sHost, sUsr, sPwd, sSvcName, bStarted) {
	var hr = S_OK;
	try {
		if (-1 == _DEBUG) debugger;
		if (/* !sHost || ("" == sHost) || !sUsr || ("" == sUsr) || !sPwd || ("" == sPwd) || */
			!sSvcName || ("" == sSvcName) /* || !bStarted */) { hr = E_FAIL; throw hr }

		var oSWbemLocator = new ActiveXObject("WbemScripting.SWbemLocator");
		if (!oSWbemLocator) { hr = E_FAIL; throw hr; }

		if (-1 == _DEBUG) debugger;
		oSWbemLocator.Security_.ImpersonationLevel = wbemImpersonationLevelImpersonate;
		// oSWbemLocator.Security_.AuthenticationLevel = wbemAuthenticationLevelDefault;
		oSWbemLocator.Security_.Privileges.Add(wbemPrivilegeDebug, true);
		var iTemp = oSWbemLocator.Security_.ImpersonationLevel;  // should now be = 3
		// iTemp = oSWbemLocator.Security_.AuthenticationLevel;  // should now be = 0
		var oSWbemPrivilege = oSWbemLocator.Security_.Privileges.Item(wbemPrivilegeDebug)  // should now exist and = true

		var oSWbemServices = oSWbemLocator.ConnectServer(sHost, "root\\cimv2", sUsr, sPwd);
		if (!oSWbemServices) { hr = E_FAIL; throw hr; }
		oSWbemServices.Security_.impersonationlevel = 3;

		var oSWbemInst = oSWbemServices.Get("Win32_Service=\"" + sSvcName + "\"");
		if (!oSWbemInst) { hr = E_FAIL; throw hr; }

		if (-1 == _DEBUG) debugger;
		if (bStarted)
			hr = oSWbemInst.StartService();
		else
			hr = oSWbemInst.StopService();
		if (hr) { hr = E_FAIL; throw hr; }
	}

	catch(xCptn) {
		if (-1 == _DEBUG) debugger;
		if (isNaN(xCptn)) { var sTemp = xCptn.description; hr = xCptn.number; }	
	}

	if (-1 == _DEBUG) debugger;
	return hr;
}
