// stdafx.h : include file for standard system include files,
//      or project specific include files that are used frequently,
//      but are changed infrequently

#if !defined(AFX_STDAFX_H__5CF7AA9B_4E77_4766_A23F_CD546206F268__INCLUDED_)
#define AFX_STDAFX_H__5CF7AA9B_4E77_4766_A23F_CD546206F268__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define STRICT
#ifndef _WIN32_WINNT
#define _WIN32_WINNT 0x0400
#endif
// #define _ATL_APARTMENT_THREADED
// note - see msdn / search / "COM Techniques by Panther Software" / "Part 1: A Free-Threaded DCOM Server"
// for details on making atl com services free-threaded.  This implies taht you also ensure that project /
// settings / c-c++ / category=codeGeneration / useRunTimeLibrary = [debug] multithreaded as well so that
// any c-runtime routines used in project are threadsafe.
#define _ATL_FREE_THREADED

#include <atlbase.h>
//You may derive a class from CComModule and use it if you want to override
//something, but do not change the name of _Module
extern CComModule _Module;
#include <atlcom.h>

#include <comdef.h>  // to support use of compiler com support classes
#include <wbemIdl.h>  // to support use of wmi interfaces
#pragma comment(lib, "wbemuuid.lib")  // note - required for vs.net build support, doesn't harm vs60 build support
//#include <winSock2.h>  // to support use of gethostname and ipaddress retrieval
// note - commented out for vs.net build support, appears it is not necessary for vs60 build support either
#pragma comment(lib, "ws2_32.lib")
#include <math.h>  // to support use of pow
#include "GnlPpsEvntCsmr.h"  // to support use of IActions

HRESULT OutputDebugStringEx(HRESULT hrError, BSTR bsRoutine);
HRESULT GetSystemTimeEx(BSTR bsWmiTime, LPSYSTEMTIME pSystemTime);
HRESULT GetSystemTimeElapsedInSeconds(SYSTEMTIME &oCreateSysTime, SYSTEMTIME &oTerminateSysTime, LONG *plElapsedSeconds);
HRESULT GetSqlDatetime(SYSTEMTIME &oSystemTime, BSTR *pbsSqlDatetime);
HRESULT GetYearMonthDay(SYSTEMTIME &oSystemTime, BSTR *pbsYearMonthDay);
HRESULT GetOwnerWmi(BSTR bsNamespace, BSTR bsClassPath, BSTR bsInstancePath, BSTR *pbsSamAccountName, BSTR *pbsNetbiosDomain);
HRESULT GetOwnerWin32(DWORD dwProcessId, BSTR *pbsSamAccountName, BSTR *pbsNetbiosDomain);
HRESULT GetUser(BSTR bsSamAccountName, BSTR bsNetbiosDomain, BSTR *pbsUser);
HRESULT WriteToLocalLogFile(BSTR bsUrl, BSTR bsXml, BSTR bsSep);

_COM_SMARTPTR_TYPEDEF(IWbemUnboundObjectSink, __uuidof(IWbemUnboundObjectSink));
_COM_SMARTPTR_TYPEDEF(IUnknown, __uuidof(IUnknown));
_COM_SMARTPTR_TYPEDEF(IWbemClassObject, __uuidof(IWbemClassObject));
_COM_SMARTPTR_TYPEDEF(IWbemLocator, __uuidof(IWbemLocator));
_COM_SMARTPTR_TYPEDEF(IWbemServices, __uuidof(IWbemServices));
_COM_SMARTPTR_TYPEDEF(IActions, __uuidof(IActions));
_COM_SMARTPTR_TYPEDEF(IXMLHttpRequest, __uuidof(IXMLHttpRequest));
_COM_SMARTPTR_TYPEDEF(IXMLDOMDocument, __uuidof(IXMLDOMDocument));
_COM_SMARTPTR_TYPEDEF(IXMLDOMNode, __uuidof(IXMLDOMNode));
_COM_SMARTPTR_TYPEDEF(IXMLDOMElement, __uuidof(IXMLDOMElement));
// compiler com smart pointer macro statements for each "Microsoft Scripting Runtime" interface 
// will be already be defined in autogenerated scrrun.tlh/.tli files output by #import statement
#import <scrrun.dll> no_namespace rename("FreeSpace", "FreeSpaceEx") /* rename("Folder", "FolderEx") */ rename("Unknown", "UnknownEx")

#define USE_HTTP_POST TRUE  // FALSE == use http get, TRUE == use http post to submit xml payloads

#define SA_EVENTRECORD_LWRBOUND 0  // lower bound to use in safearray, usually 0 or 1
#define SA_EVENTRECORD_DIMS 2  // 1 row for column names, 1 row for column values
#define SA_EVENTRECORD_ELEMENTS 14  // columns 0 - 8 = hostname, ipaddress, agent, name, description, create, terminate, duration, user
									// columns 9 - 14 = defined by logical consumer otherProps property values

#define MAX_FLOAT 16  // string representation of double in format [whitespace] [sign] [digits] [.digits]
#define MAX_HOSTNAME 100  // account for fully qualified domain name
#define MAX_IPADDRESS 16  // ###.###.###.###\0
#define MAX_SQLDATETIME 24  // yyyy-mm-dd hh:mm:ss.mmm
#define MAX_SYSTEMTIME_FIELD 5  // yyyy\0
#define MAX_OTHERPROPS MAX_PATH
#define MAX_URL 8 * MAX_PATH  // 8 * 256 = 2048bytes
#define MAX_XML 8 * MAX_PATH  // 8 * 256 = 2048bytes
#define MAX_TOKENINFO 256
#define MAX_PRINCIPAL 64
#define MAX_AUTHORITY 64
#define MAX_PASSWORD 64

#define WMIDATETIME_INDEXOF_YYYY 0  // yyyymmddHHMMSS.mmmmmmsUUU
#define WMIDATETIME_INDEXOF_MM 4
#define WMIDATETIME_INDEXOF_DD 6
#define WMIDATETIME_INDEXOF_HH 8
#define WMIDATETIME_INDEXOF_MIN 10
#define WMIDATETIME_INDEXOF_SS 12
#define WMIDATETIME_INDEXOF_MS 15
#define WMIDATETIME_INDEXOF_UTCOFFSET 21
#define WMIDATETIME_MAX_FIELD 7  // mmmmmm\0
									
// #define GNLPPSEVNTCSMR_NAMESPACE _T("\\\\.\\root\\cimv2\\msftNsg")
// #define VIEWCLASS_UNION_OF_ROOTCIMV2_WIN32PROCESS _T("ViewClassUnionOfRootCimv2Win32Process")
// #define VIEWCLASS_UNION_OF_ROOTCIMV2_WIN32PROCESS_INSTANCE_BASEPATH _T("ViewClassUnionOfRootCimv2Win32Process.Handle")

#define GPEC_VERSION _T("gpec24jan01")
#define DEFAULT_WMIDATETIME _T("20010124000000.000000-480")  
// note 1 - wmi datetime format = yyyymmddHHMMSS.mmmmmmsUUU, ranging from January 1, 1601 onward
// note 2 - needed to set a valid wmidate time default when configured wmi settings which ultimately affects the 
// processing in the gnlPpsEventPvdr CWuos::IndicateToConsumer routine as it tests several things to decide if the
// CreationDate/TerminationDate property values have been set by an event to discern between general purpose event
// provider generic, create, terminate generated events, so if you change this default then you also need to change the 
// constant setting in the current wmi settings and/or wmi configuration routines used by the installation process
#define WBEM_EVENT_CSMR_PVDR_CLSID _T("{A6875280-8A1E-4B3A-8AE3-D5A2EE419F04}")
// local log file prefix used to store appUseTrkSvc skipped records due to network or rdms down
#define LOCAL_LOG_FILE_PREFIX _T("autsSkpdRcdsDueToNetOrRdmsDwn");  
#define PRC_CREATE_EVENT_NAME _T("lgcGpecPrcCreateEvent")
#define PRC_CREATE_EVENT_DESCRIPTION _T("prcCreateEvent")
#define PRC_TERMINATE_EVENT_NAME _T("lgcGpecPrcTerminateEvent")
#define PRC_TERMINATE_EVENT_DESCRIPTION _T("prcTerminateEvent")
#define WIN32_PROCESS_PROCESSID_PROP _T("ProcessID")
#define GPEP_EVENT_NAME _T("lgcGpecGpepEvent")
#define GPEP_EVENT_DESCRIPTION _T("gpepEvent")
#define GPEP_EVENT_USER_PROP _T("User")

#define COLUMN_ID_NAME _T("idEvent")
#define COLUMN_0_NAME _T("vcHostname")
#define COLUMN_1_NAME _T("vcIpAddress")
#define COLUMN_2_NAME _T("vcAgent")
#define COLUMN_3_NAME _T("vcName")
#define COLUMN_4_NAME _T("vcDescription")
#define COLUMN_5_NAME _T("dtCreate")
#define COLUMN_6_NAME _T("dtTerminate")
#define COLUMN_7_NAME _T("iDuration")
#define COLUMN_8_NAME _T("vcUser")
#define COLUMN_OTHERPROPS_BASENAME _T("vcOtherProp")


//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_STDAFX_H__5CF7AA9B_4E77_4766_A23F_CD546206F268__INCLUDED)
