// Wecp.h : Declaration of the CWecp

#ifndef __WECP_H_
#define __WECP_H_

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// CWecp
class ATL_NO_VTABLE CWecp : 
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<CWecp, &CLSID_Wecp>,
	public IWecp,
	public IWbemProviderInit,
	public IWbemEventConsumerProvider
{
public:
	CWecp() {
		// initialize instance member variables
	}
	
	~CWecp() {
		// uninitialize instance member variables
	}

DECLARE_REGISTRY_RESOURCEID(IDR_WECP)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CWecp)
	COM_INTERFACE_ENTRY(IWecp)
	COM_INTERFACE_ENTRY(IWbemProviderInit)
	COM_INTERFACE_ENTRY(IWbemEventConsumerProvider)
END_COM_MAP()

// IWecp
public:
	// inherited from IWbemEventConsumerProvider
	STDMETHOD(FindConsumer)(/*[in]*/ IWbemClassObject *pLogicalConsumer, /*[in, out]*/ IWbemUnboundObjectSink **ppConsumer);

	// inherited from IWbemProviderInit
	STDMETHOD(Initialize)(/*[in]*/ LPWSTR wszUser, /*[in]*/  LONG lFlags, /*[in]*/ LPWSTR wszNamespace, /*[in]*/ LPWSTR wszLocale, /*[in]*/ IWbemServices *pNamespace, /*[in]*/ IWbemContext *pCtx, /*[in]*/ IWbemProviderInitSink *pInitSink);
};

#endif //__WECP_H_
